package kr.co.kihyun.beans.batch;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.db.DBManager;
import kr.co.kihyun.moumi.MoumiConfig;
import kr.co.kihyun.text.html.ServletUtil;

public class AcceptNote  extends DBManager {

   private static final Logger LOG = LoggerFactory.getLogger(AcceptNote.class);

	private ResultSet rs = null;    
	private int count = 0;
    PreparedStatement pstmt = null;
    Statement stmt = null;
    PrintWriter out=null;

	public void AcceptNote(HttpServletRequest req, HttpServletResponse res) throws IOException {

		StringBuilder sql = new StringBuilder(250);
           res.setContentType("text/html;charset=euc-kr");
			out = res.getWriter();
		try {
         

            String userID = req.getParameter("userID");
            String ID = req.getParameter("id");
            String prss = req.getParameter("prss");
            
            if(prss.isEmpty() || prss.equals(null)){
                sql.append("UPDATE MOUMI_TOT_REPORT SET PRSS = '3' WHERE USER_ID = '"+userID+"' and ID = '"+ID+"'");                
            }else{
                sql.append("UPDATE MOUMI_TOT_REPORT SET PRSS = '"+prss+"' WHERE USER_ID = '"+userID+"' and ID = '"+ID+"'");
            }
            
            //rs = execQuery(sql);
            execUpdate(sql.toString());

            //System.out.println("::: ::"+sql.toString());

            //out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.success")));
            out.println(ServletUtil.getJavaScript("opener.location.reload();"));
            out.println(ServletUtil.getJavaScript("self.close();"));

		} catch (SQLException sqlEx) {
			LOG.error("\nSQLState - {}\nMySQL Error Code - {}\nmessage - {}\nsql - {}",
			new Object[] { sqlEx.getSQLState(), sqlEx.getErrorCode(), sqlEx.getMessage(), sql });
			throw new RuntimeException(sqlEx);
		} catch (Exception ex) {
            out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.fail")));
			out.println(ServletUtil.getJavaScript("history.back();"));
			throw new RuntimeException(ex);
		} finally {
			close(rs);
			execClose();
		}

    }

}
