/*************************************************************************************************
 * α׷ : HttpAssign.java α׷ :  ̰ û   ۼ : ۼ :  :
 **************************************************************************************************/

package kr.co.kihyun.beans.batch;

import java.io.IOException;
import java.io.PrintWriter;

import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.entity.util.MPersistenceManager;
import kr.co.kihyun.beans.entity.util.PMF;

public class AcceptSetNote extends HttpServlet {

    private static final long serialVersionUID = 1L;
    private static final Logger LOG = LoggerFactory.getLogger(AcceptSetNote.class);
    String assignInfo = "";

    
    public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        
        //44.  ó(Ŭ)_CWE-754 : Update by YOUNGJUN,CHO
        Transaction tx = null;
        PersistenceManager pm = null;
        
        try {
            PrintWriter out = res.getWriter();
            pm = new MPersistenceManager(PMF.get().getPersistenceManager());
            tx = pm.currentTransaction();

            AcceptNote et = new AcceptNote();

            tx.begin();
            et.AcceptNote(req, res);
            tx.commit();
        } catch (IOException ioex) {
            ioex.printStackTrace();
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            if (tx.isActive())
                tx.rollback();
            pm.close();
        }
        //================================================
    }
}
