/**
 * 
 */
package kr.co.kihyun.beans.entity;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * @author bhs
 * 
 */

public enum AccessAuth {
	PER(""), DEPT("μ"), PART(""), ALL("ü");

	private final String name;
        private static final Logger LOG = LoggerFactory.getLogger(AccessAuth.class);

	private AccessAuth(String authName) {
		this.name = authName;
	}

      //v2. 5.static final ʵ  ɼ : Update by KWON,HAN 
      //private  Ŭ  ȣ ϹǷ   public ϰ final  ʴ´
      //public static final AccessAuth asAccessAuth(int authNum) {
	public static AccessAuth asAccessAuth(int authNum) {
            //LOG.debug("v2. 5.static final ʵ  ɼ : AccessAuth.asAccessAuth() Test OK {}", values()[authNum]);
		return values()[authNum];
	}
      //==========================================================
        
	@Override
	public String toString() {
		return name;
	}
}
