package kr.co.kihyun.beans.entity;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.moumi.MoumiConfig;

public enum TotDocType {
                          DUMMY1(""), 
                          FORM_DOC(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.formDoc")) //
                        , TOT_DOC(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.tot_doc")) //
                        , SUB_DOC(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.subDoc")) //ڷ
                        , SUB_DOC_LIST(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.subDoc")) //ڷ
                        , CANCEL_DOC_LIST(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.cancelDoc")) //ڷ
                        , DOC_LIST(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.docList")); //ڷ

	private String name;
        private static final Logger LOG = LoggerFactory.getLogger(TotDocType.class);

	private TotDocType(String name) {
		this.name = name;
	}
        
      //v2. 5.static final ʵ  ɼ : Update by KWON,HAN 
      //private  Ŭ  ȣ ϹǷ   public ϰ final  ʴ´.
//	public static final TotDocType asDocType(int typeNum) {
	public static TotDocType asDocType(int typeNum) {         
            //LOG.debug("v2. 5.static final ʵ  ɼ : TotDocType.asDocType() values()[typeNum]={}, Test OK", values()[typeNum]);
		return values()[typeNum];
	}
      //==========================================================        

	@Override
	public String toString() {
		return name;
	}
}
