/**
 * 
 */
package kr.co.kihyun.beans.entity;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.moumi.MoumiConfig;

/**
 * @author bhs
 * 
 */
public enum TotItemType {
	TITLE(MoumiConfig.getMessageBundle().getString("moumi.message.tot_item.type.title")), CHAR(MoumiConfig.getMessageBundle()
			.getString("moumi.message.tot_item.type.char")), INT(MoumiConfig.getMessageBundle().getString(
			"moumi.message.tot_item.type.int")), DATE(MoumiConfig.getMessageBundle().getString(
			"moumi.message.tot_item.type.date")), SPCHAR(MoumiConfig.getMessageBundle().getString(
			"moumi.message.tot_item.type.spchar"));

	private String name;
        private static final Logger LOG = LoggerFactory.getLogger(TotItemType.class);
        
	private TotItemType(String name) {
		this.name = name;
	}

	@Override
	public String toString() {
		return name;
	}

      //v2. 5.static final ʵ  ɼ : Update by KWON,HAN 
      //private  Ŭ  ȣ ϹǷ   public ϰ final  ʴ´.        
//	public static final TotItemType asTotItemType(int typeNum) {
	public static TotItemType asTotItemType(int typeNum) {            
            //LOG.debug("v2. 5.static final ʵ  ɼ : TotItemType.asTotItemType() values()[typeNum]={}, Test OK", values()[typeNum]);            
		return values()[typeNum];
	}
      //==========================================================               
}
