/**********************************************************************************
 * α׷ : HttpAdmFileUpload.java α׷ :    :    : ֽź :
 ***********************************************************************************/

package kr.co.kihyun.beans.totsys.board;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URLEncoder;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.io.FileUtil;
import kr.co.kihyun.io.MultipartRequest;
import kr.co.kihyun.moumi.MoumiConfig;
import kr.co.kihyun.text.html.ServletUtil;
import kr.co.kihyun.util.MRandom;

public class HttpAdmFileUpload extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
        private static final Logger LOG = LoggerFactory.getLogger(HttpAdmFileUpload.class);
	MultipartRequest multi = null;

	String sql = "";
	String writeDate = "";

	final int maxSize = 100 * (1024 * 1024);

	// 100ް 

	public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {

		res.setContentType("text/html;charset=euc-kr");
		PrintWriter out = res.getWriter();

		String svrFilename = "";
		String usrFilename = "";
		String boardGroupID = "";
		// String savePath = Moumi.getRoot()+"/totsys/sysadm/board/upfiles/";
		StringBuilder savePath = new StringBuilder(MoumiConfig.getSysAdmFileRoot().getPath())
				.append(System.getProperty("file.separator")).append("board")
				.append(System.getProperty("file.separator")).append("upfiles")
				.append(System.getProperty("file.separator"));

		String connURL = "";

		try {
			multi = new MultipartRequest(req, savePath.toString(), maxSize);
			boardGroupID = multi.getParameter("boardGroupID");
			usrFilename = multi.getParameter("appendFile");

                        //7.   ε(MultipartRequest)_CWE-434 : Add by KWON,HAN
                        int extIndex = 0 ;
                        extIndex = usrFilename.lastIndexOf('.');
                        if(extIndex < 0 ) {
                            LOG.debug("7.   ε(MultipartRequest)_CWE-434 : Not Test / usrFilename: {}", usrFilename);
                            out.print("<script language='javascript'>alert('Ȯڰ  Դϴ.');</script>");   
                            return;
                        }                        
                        String file_ext = usrFilename.substring(usrFilename.lastIndexOf('.') + 1); 
                        if( file_ext.equalsIgnoreCase("exe") || file_ext.equalsIgnoreCase("bat") || file_ext.equalsIgnoreCase("sh") ) { 
                            LOG.debug("7.   ε(MultipartRequest)_CWE-434 : Not Test / usrFilename: {}", usrFilename);
                            out.print("<script language='javascript'>alert('Ȯڰ [exe, bat, sh] ε尡 ѵ Դϴ.');</script>");   
                            return;
                        }
                        //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            
                        //  
                        // savePath = Moumi.root+boardGroup.getSavePath(boardGroupID);
                        svrFilename = FileUtil.getName(usrFilename, Integer.toString(MRandom.getInt(100))); // ڸ  ġ 
                        FileItem upFile = multi.getFileItem("appendFile");
                        
                        //3.丮  (getParameter)_CWE-22/23/36 : Add by KWON,HAN
                        String chkFilename = "";
                        chkFilename = savePath + System.getProperty("file.separator") + svrFilename;
                        LOG.debug("chkFilename: {}", chkFilename);
                        if(chkFilename.contains("..") || chkFilename. contains("/")) { // Ưڿ 
                            LOG.debug("HttpAdmFileUpload doPost ===");
                            LOG.debug("3.丮  (getParameter)_CWE-22/23/36 : Not Test {}", chkFilename);
                            LOG.debug("============================");
                            return;
                        }
                        //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        
                        upFile.write(new File(savePath + System.getProperty("file.separator") + svrFilename));

                        svrFilename = URLEncoder.encode(svrFilename, "UTF-8");
                        usrFilename = URLEncoder.encode(usrFilename, "UTF-8");

                       //v2. 1.HTTP  : Update by KWON,HAN                        
//                        res.sendRedirect("/totsys/sysadm/board/write_file_upload.jsp?execMode=up&svrFilename=" + svrFilename
//                                        + "&usrFilename=" + usrFilename + "&boardGroupID=" + boardGroupID);
                        if (svrFilename != null || usrFilename != null) {               
                            //  : ܺ Է° ͸
                            String filtered_svrFilename = svrFilename.replaceAll("\r","").replaceAll("\n","");      
                            String filtered_usrFilename = usrFilename.replaceAll("\r","").replaceAll("\n","");      
                            LOG.debug("v2 1.HTTP  : HttpAdmFileUpload.doPost() filtered_svrFilename={} Not Test", filtered_svrFilename);
                            LOG.debug("v2 1.HTTP  : HttpAdmFileUpload.doPost() filtered_usrFilename={} Not Test", filtered_usrFilename);
                            res.sendRedirect("/totsys/sysadm/board/write_file_upload.jsp?execMode=up&svrFilename=" + filtered_svrFilename
                                            + "&usrFilename=" + filtered_usrFilename + "&boardGroupID=" + boardGroupID);
                        }                        
                        //========================================                        
		} catch (IOException ex) {
			out.println(ServletUtil.getJavaScript(connURL));
			ex.printStackTrace();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
