/*************************************************************************************************
 * α׷ : HttpReportRegister.java α׷ :     Ǵ  ڷ 濡  ۼ :  ۼ : 2004.01.12  : 2003.11.30
 **************************************************************************************************/

package kr.co.kihyun.beans.totsys.report;

import java.io.IOException;
import java.io.PrintWriter;

import javax.jdo.Transaction;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.datanucleus.ObjectManager;
import org.datanucleus.jdo.JDOPersistenceManager;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.ecross.VCMCCMC2016;
import kr.co.kihyun.beans.entity.TotReport;
import kr.co.kihyun.beans.entity.util.MPersistenceManager;
import kr.co.kihyun.beans.entity.util.PMF;
import kr.co.kihyun.beans.user.HttpSSOLogin;
import kr.co.kihyun.lang.MLong;
import kr.co.kihyun.moumi.MoumiConfig;
import kr.co.kihyun.text.html.ServletUtil;

public class HttpVCMCCMC2016Send extends HttpServlet {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static final Logger LOG = LoggerFactory.getLogger(HttpVCMCCMC2016Send.class);

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		doPost(req, res);
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		res.setContentType("text/html;charset=euc-kr");
		res.setHeader("Cache-Control","no-cache");
		res.setHeader("Pragma","no-cache");
		res.setDateHeader ("Expires", -1);
		PrintWriter out = res.getWriter();
		HttpSession session = req.getSession(true);

		/********** session userId **********/
		String usID = HttpSSOLogin.getLoginID(req);

		Long reportID = MLong.parseLong(req.getParameter("reportID"));

		MPersistenceManager moumiPm = new MPersistenceManager(PMF.get().getPersistenceManager());
		Transaction tx = moumiPm.currentTransaction();
		MPersistenceManager eCrossPm = new MPersistenceManager(PMF.get("ECROSS").getPersistenceManager());
		Transaction eCrossTx = eCrossPm.currentTransaction();
		ObjectManager om = ((JDOPersistenceManager) tx.getPersistenceManager()).getObjectManager(); // jeus 6 proplem
		try {
                    
			TotReport totReport = moumiPm.getObjectById(TotReport.class, reportID);

			eCrossTx.begin();
			VCMCCMC2016 eInterface = new VCMCCMC2016(totReport);
			tx.begin();
			eInterface.saveAll(moumiPm, eCrossPm, totReport.getTotDoc().getDept(moumiPm));
			tx.commit();
			eCrossTx.commit();
                    
                        out.println(ServletUtil.alert("η Ͽϴ"));
                        out.println(ServletUtil.getJavaScript("history.back();"));
                        } catch (Exception ex) {
			ex.printStackTrace();
			LOG.error(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report") + MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.save")+ MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.fail") +" {}, {}, {}",
					new Object[] { usID, req.getRemoteAddr(), reportID });
			out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.popup.saveFailAdmin")));
			out.println(ServletUtil.getJavaScript("history.back();"));
                        } finally {
			if (tx.isActive())
				tx.rollback();
			moumiPm.close();
			if (eCrossTx.isActive())
				eCrossTx.rollback();
			eCrossPm.close();
		}
	}
}
