/***********************************************************************************
 * @@ Program Name : HttpDeptList.java Description :  μ  Author :  Create Date : 2003-12-16 History :
 * @@
 ***********************************************************************************/

package kr.co.kihyun.beans.user;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.totsys.report.Report;
import kr.co.kihyun.db.DBManager;

public class HttpApproveUpdateCancel extends DBManager {

    private  List<String> recogid;
    private ResultSet rs = null;
   	private static final Logger LOG = LoggerFactory.getLogger(Report.class);

   	private String[] ID = null;
   	private String[] RECOG = null;
   	private String[] RECOG_NUM = null;
   	private String[] RECOG_USER_ID = null;
   	private String[] REPORT_ID = null;
   	private String[] RECOGFLAG = null;
    
    public HttpApproveUpdateCancel(Long reportID,String reportType,String typeList,String docReportID,HttpServletRequest req, HttpServletResponse res) throws SQLException, IOException
	{
        String[] reoogUserDList = null;
        String strReportID = null;
        String sql = null;
        String sql2 = null;

       	String usID = HttpSSOLogin.getLoginID(req);
		int sysAuth = HttpSSOLogin.getSysAuth(req);  
        strReportID = docReportID;
        String RecogId = null;
        ResultSet rs = null;      

        res.setContentType("text/html;charset=euc-kr");
		PrintWriter out = res.getWriter();
		try
		{
                //System.out.println("::reportID:::"+strReportID);

                UpdateCancelRepoAdm(strReportID);
                cancelRepoAdm(strReportID);               

            //v2. 1.HTTP  : Update by KWON,HAN        
//          res.sendRedirect("/totsys/repoper/mydocbox/tempbox/report_view.jsp?reportID="	+ reportID + "&totperInfo=true&reportType=" + reportType + "'&cancelState=Y");
          
            //  : ܺ Է° ͸
            String filtered_reportType = reportType.replaceAll("\r","").replaceAll("\n","");     
            LOG.debug("v2 1.HTTP  : HttpApproveUpdateCancel.HttpApproveUpdateCancel() filtered_reportType={}, Not Test", filtered_reportType);
            
            
            //v2. 3.ŷڵ ʴ URL ּҷ ڵ  _CWE-601 : Update by KWON,HAN 
//            res.sendRedirect("/totsys/repoper/mydocbox/tempbox/report_view.jsp?reportID="	+ reportID + "&totperInfo=true&reportType=" + filtered_reportType + "'&cancelState=Y");
            
            // ٸ  ̵ϴ URL Ʈ 
            String connURL = "";
            String allowURL[] = { "/totsys/repoper/mydocbox/tempbox/report_view.jsp" };
            connURL = allowURL[0] + "?reportID="	+ reportID + "&totperInfo=true&reportType=" + filtered_reportType + "'&cancelState=Y";
            LOG.debug("v2 3.ŷڵ ʴ URL ּҷ ڵ  _CWE-601 : HttpApproveUpdateCancel.HttpApproveUpdateCancel() connURL={} : Not Test", connURL);
            res.sendRedirect(connURL);
            //========================================================================            
            //======================================
            
         return;
        }catch (Exception e){
                e.printStackTrace();
        }
        finally
        {
        try {
            if (stmt != null)
                stmt.close();
        } catch (SQLException ex) {
            ex.printStackTrace();
        } try {
            if (rs != null)
                rs.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }
	}
     
	
     public void  cancelRepoAdm(String strReportID) throws SQLException
	{
        ResultSet rs = null;
		PrintWriter out=null;
        String recogFlag="Y";
        
		try
		{
                  //System.out.println("::reportID:::"+strReportID);
                  //String sql="DELETE FROM MOUMI_REPOADM WHERE REPORT_ID = ?";
                  String sql="UPDATE MOUMI_REPOADM SET DELTYPE='Y',RECOG=0 WHERE REPORT_ID = ?";
                  execUpdate(sql,strReportID);

                  //System.out.println("cancelRepoAdm  SQL::::::"+sql);
                  return;
		}catch (Exception e){
    			e.printStackTrace();
		}
		finally
        {
            try {
                if (stmt != null)
                    stmt.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (con != null)
                    con.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (rs != null)
                    rs.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }
	}

     public void  UpdateCancelRepoAdm(String docReportID) throws SQLException
	{
        String strReportID = null;
        ResultSet rs = null;
		PrintWriter out=null;
		try
		{
            strReportID = docReportID;

            String sql="UPDATE MOUMI_TOT_REPORT SET CURRENT_REPOADM_ID ='',PRSS=4 WHERE ID =?";
            execUpdate(sql,strReportID);

            //System.out.println("UpdateCancelRepoAdm  SQL::::::"+sql);

            return;

		}catch (Exception e){
			e.printStackTrace();
		}
		finally
        {
            try {
                if (stmt != null)
                    stmt.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (con != null)
                    con.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (rs != null)
                    rs.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }
	}


}