package kr.co.kihyun.beans.user;

import java.io.PrintWriter;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kr.co.kihyun.lang.MString;


public class HttpMultiCheckCount extends HttpServlet
{
    public void doGet(HttpServletRequest req, HttpServletResponse res) {
        doPost(req,res);
        return;
    }
    
    
    public void doPost(HttpServletRequest req, HttpServletResponse res) {
        String sUserId = MString.checkNull(req.getParameter("userId"));
        int iCount = -1;
        
//        System.out.println("=== HttpMultiCheckCount.doPost =====================");             
//        System.out.println("sUserId = "+sUserId);
//        System.out.println("====================================================");

        try {      
            MultiCheck mc = new MultiCheck();

            mc.idCheck(sUserId);
            iCount = mc.getCount();
            
//            System.out.println("=== HttpMultiCheckCount.doPost =====================");             
//            System.out.println("iCount = "+iCount);
//            System.out.println("====================================================");
        
            res.setContentType("text/html;charset=euc-kr");
            PrintWriter out = res.getWriter(); 
            out.println(Integer.toString(iCount));
            
//        } catch (SQLException ex) {
//            java.util.logging.Logger.getLogger(HttpApproveSet.class.getName()).log(Level.SEVERE, null, ex);
        } catch (Exception ex) {
            Logger.getLogger(HttpMultiCheckCount.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            
        }
    }
}