/***********************************************************************************
 * @@ Program Name : HttpDeptList.java Description :  μ  Author :  Create Date : 2003-12-16 History :
 * @@
 ***********************************************************************************/

package kr.co.kihyun.beans.user;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.ResultSet;
import java.sql.SQLException;
//import java.util.ArrayList;
import java.util.List;
//import javax.jdo.JDOObjectNotFoundException;
//import javax.jdo.PersistenceManager;
//import javax.jdo.Transaction;

//import javax.servlet.ServletException;
//import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

//import kr.co.kihyun.lang.Encoder;
//import kr.co.kihyun.moumi.MoumiConfig;
//import kr.co.kihyun.lang.MString;
//import kr.co.kihyun.text.html.ServletUtil;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

//import kr.co.kihyun.beans.entity.MDept;
//import kr.co.kihyun.beans.entity.MUser;
//import kr.co.kihyun.beans.entity.UserPart;
//import kr.co.kihyun.beans.entity.util.MPersistenceManager;
//import kr.co.kihyun.beans.entity.util.PMF;
//import kr.co.kihyun.beans.totsys.report.Report;
import kr.co.kihyun.db.DBManager;

public class HttpProveRecogSet extends DBManager {

    private  List<String> recogid;
    private ResultSet rs = null;
   	private static final Logger LOG = LoggerFactory.getLogger(HttpProveRecogSet.class);

   	private String[] ID = null;
   	private String[] RECOG = null;
   	private String[] RECOG_NUM = null;
   	private String[] RECOG_USER_ID = null;
   	private String[] REPORT_ID = null;
   	private String[] RECOGFLAG = null;
    
    public HttpProveRecogSet(String docName,Long reportID,String reportType,String typeList,Long repoadminID,String userID,String GetID,HttpServletRequest req, HttpServletResponse res) throws SQLException, IOException
	{
        String[] reoogUserDList = null;
        String strUserID = null;
        Long maxId = null;
        String sql = null;
        String sql2 = null;
        Long tmpID = null;

       	String usID = HttpSSOLogin.getLoginID(req);
		int sysAuth = HttpSSOLogin.getSysAuth(req);  
        strUserID = userID;
        String RecogId = null;
        ResultSet rs = null;      

        res.setContentType("text/html;charset=euc-kr");
		PrintWriter out = res.getWriter();
        
		try
		{
         tmpID = repoadminID;
         UpdateRecogRepoAdm(reportID,strUserID);        
         SelectMaxId sm = new SelectMaxId(reportID);
         maxId = sm.getMaxId();
         //System.out.println("::userID:::"+strUserID+" tmpID::"+tmpID+"  maxId::::"+maxId);

         if(tmpID < maxId){
              tmpID = tmpID + 1;
              UpdateTotReport(tmpID,reportID);
         }else{
              UpdateTotReportFin(maxId,reportID);
         }

            //v2. 1.HTTP  : Update by KWON,HAN   
//         res.sendRedirect("/totsys/repoper/mydocbox/approve/report_list.jsp?reportID="+reportID+"&totperInfo=true&reportType=COMPLETE&doctName="+docName+"&repoadminID="+repoadminID);
         
            //  : ܺ Է° ͸
            String filtered_docName = docName.replaceAll("\r","").replaceAll("\n","");     
            LOG.debug("v2 1.HTTP  : HttpProveRecogSet.HttpProveRecogSet() filtered_docName={}, Not Test", filtered_docName);
            
            //v2. 3.ŷڵ ʴ URL ּҷ ڵ  _CWE-601 : Update by KWON,HAN 
//            res.sendRedirect("/totsys/repoper/mydocbox/approve/report_list.jsp?reportID="+reportID+"&totperInfo=true&reportType=COMPLETE&doctName="+filtered_docName+"&repoadminID="+repoadminID);
            
            // ٸ  ̵ϴ URL Ʈ 
            String connURL = "";
            String allowURL[] = { "/totsys/repoper/mydocbox/approve/report_list.jsp" };
            connURL = allowURL[0] + "?reportID="+reportID+"&totperInfo=true&reportType=COMPLETE&doctName="+filtered_docName+"&repoadminID="+repoadminID;
            LOG.debug("v2 3.ŷڵ ʴ URL ּҷ ڵ  _CWE-601 : HttpProveRecogSet.HttpProveRecogSet() connURL={} : Not Test", connURL);
            res.sendRedirect(connURL);        
            //========================================================================               
            //======================================
            
         return;

		}catch (Exception e){
			e.printStackTrace();
		}
		finally
        {

            try {
                if (stmt != null)
                    stmt.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (con != null)
                    con.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (rs != null)
                    rs.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }
	}
   

     public void  UpdateRecogRepoAdm(Long reportID,String strUserID) throws SQLException
	{
        String tmpUserID = null;
        String acceptFlag = null;
        ResultSet rs = null;
		PrintWriter out=null;
		try
		{
            tmpUserID = strUserID;
            acceptFlag = "Y";


            String sql="UPDATE MOUMI_REPOADM SET RECOG = 2,ACCEPTFLAG=? WHERE REPORT_ID = ? AND RECOG_USER_ID = ?";
            execUpdate(sql,acceptFlag,reportID,tmpUserID);

            //System.out.println("UpdateRecogRepoAdm  SQL::::::"+sql);

            return;

		}catch (Exception e){
			e.printStackTrace();
		}
		finally
        {
            try {
                if (stmt != null)
                    stmt.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (con != null)
                    con.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (rs != null)
                    rs.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }
	}


      public void  UpdateTotReport(Long tmpID,Long reportID) throws SQLException
	{
        ResultSet rs = null;
		PrintWriter out=null;
		try
		{
            String sql="UPDATE MOUMI_TOT_REPORT SET CURRENT_REPOADM_ID = ? WHERE ID =?";
            execUpdate(sql,tmpID,reportID);

            //System.out.println("UpdateTotReport  SQL::::::"+sql);
            return;

		}catch (Exception e){
			e.printStackTrace();
		}
		finally
        {
            try {
                if (stmt != null)
                    stmt.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (con != null)
                    con.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (rs != null)
                    rs.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }
	}

    public void  UpdateTotReportFin(Long maxId,Long reportID) throws SQLException
	{
        ResultSet rs = null;
		PrintWriter out=null;
		try
		{
            String sql="UPDATE MOUMI_TOT_REPORT SET CURRENT_REPOADM_ID = ?,PRSS = 6 WHERE ID =?";
            execUpdate(sql,maxId,reportID);

            //System.out.println("UpdateTotReportFin  SQL::::::"+sql);
            return;

		}catch (Exception e){
			e.printStackTrace();
		}
		finally
        {
            try {
                if (stmt != null)
                    stmt.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (con != null)
                    con.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
            try {
                if (rs != null)
                    rs.close();
            } catch (SQLException ex) {
                ex.printStackTrace();
            }
        }
	}


}