/***********************************************************************************
 * @@ Program Name : HttpDeptList.java Description :  μ  Author :  Create Date : 2003-12-16 History :
 * @@
 ***********************************************************************************/

package kr.co.kihyun.beans.user;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.logging.Level;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.lang.Encoder;
import kr.co.kihyun.lang.MLong;
import kr.co.kihyun.lang.MString;

public class HttpProveSet extends HttpServlet {

	private static final long serialVersionUID = 1L;
	private static final Logger LOG = LoggerFactory.getLogger(HttpProveSet.class);

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException,NumberFormatException {
		doPost(req, res);
		return;
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException,NumberFormatException {
		res.setContentType("text/html;charset=euc-kr");
		PrintWriter out = res.getWriter();

        String docName = Encoder.toJava(req.getParameter("docName"));
        Long reportID = MLong.parseLong(req.getParameter("reportID"));
        String reportType = MString.checkNull(req.getParameter("reportType"));
		String typeList = Encoder.toJava(req.getParameter("deptTypes"));
        Long repoadminID = MLong.parseLong(req.getParameter("repoadminID"));
        String userID = Encoder.toJava(req.getParameter("userID"));
        String setGubun = Encoder.toJava(req.getParameter("setGubun"));
        String GetID = Encoder.toJava(req.getParameter("GetID"));
        String RecogGubun = Encoder.toJava(req.getParameter("RecogGubun"));
        String Contents = Encoder.toJava(req.getParameter("contents"));
        //System.out.println("setGubun:::::::"+setGubun+"   History:::"+Contents);

        try {
             if(setGubun.equals("1")){
                 HttpProveRecogSet dm = new HttpProveRecogSet(docName,reportID,reportType,typeList,repoadminID,userID,GetID,req,res);
             }else{
                 HttpProveRestoreSet dm = new HttpProveRestoreSet(docName,reportID,reportType,typeList,repoadminID,userID,GetID,Contents,req,res);
             }
            
        } catch (SQLException ex) {
            java.util.logging.Logger.getLogger(HttpApproveSet.class.getName()).log(Level.SEVERE, null, ex);
        }finally
        {
          
        }
	}

  
}
