/***********************************************************************************
 * @@ Program Name : HttpSSOLogin.java Description : SSO α ó ý Author :  Create Date : 2004.10.13 History :
 * @@
 ***********************************************************************************/
package kr.co.kihyun.beans.user;

import java.io.IOException;
import java.io.PrintWriter;
//import java.text.SimpleDateFormat;

import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.jasypt.digest.StandardStringDigester;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.entity.MDept;
import kr.co.kihyun.beans.entity.MUser;
import kr.co.kihyun.beans.entity.util.MPersistenceManager;
import kr.co.kihyun.beans.entity.util.PMF;
import kr.co.kihyun.lang.MString;
import kr.co.kihyun.moumi.MoumiConfig;
import kr.co.kihyun.text.html.ServletUtil;

public class HttpSSOLogin extends HttpServlet {
/**
* 
*/
	private static final long serialVersionUID = 1L;
	private static final Logger LOG = LoggerFactory.getLogger(HttpSSOLogin.class);

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		doPost(req, res);
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		try {
			res.setContentType("text/html;charset=euc-kr");
			PrintWriter out = res.getWriter();
 
			//  Ȱȭ
			HttpSession session = req.getSession(true);

			String connURL = "";
			String mode = MString.checkNull(req.getParameter("mode"));
			String redirect = MString.checkNull(req.getParameter("redirect"));

			String id = (String) session.getAttribute("SSO_USER_ID");
            
                        //  ȯ ȯ ϰ  ó.
//                        if (!"localhost".equals(req.getServerName()) && !"127.0.0.1".equals(req.getServerName())) {
//                            SPApiManager spApi = new SPApiManager(req, res);
//                            String spApi_USER_ID = spApi.getUserID();
//                            id = spApi.getUserID();
//                        }
                        
                        int sysAuth = new User().getSysAuth(id);
			String ip = req.getRemoteAddr();
                        
                        //21.ũνƮ ũƮ (getParameter)_CWE-81 : Add by KWON,HAN
                        String reqId = req.getParameter("id");
                        if (!MString.isNull(reqId)) { 
                            reqId = reqId.replaceAll("<","&lt");
                            reqId = reqId.replaceAll(">","&gt");
                        }
                        //LOG.debug("HttpSSOLogin.doPost ===");
                        //LOG.debug("21.ũνƮ ũƮ (getParameter)_CWE-81 : Test OK {}", reqId);
                        //LOG.debug("=======================");                        
                        //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        
			if (MString.isNull(id)
					&& ("127.0.0.1".equals(ip) || "0:0:0:0:0:0:0:1".equals(ip) || "192.168.4.45".equals(ip))) {
                          //21. if (MString.isNull(req.getParameter("id"))) {
				if (MString.isNull(reqId)) { 
                                  //21. res.sendError(HttpServletResponse.SC_UNAUTHORIZED, "ID: '" + req.getParameter("id") + "' "
					res.sendError(HttpServletResponse.SC_UNAUTHORIZED, "ID: '" + reqId + "' " 
							+ MoumiConfig.getMessageBundle().getString("moumi.message.popup.notIdorPasswd"));
					return;
				}
                          //21. id = req.getParameter("id");
				id = reqId; 
			}



            /*******************************************************************************************************
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
            if(session.getAttribute("SSO_USER_ID") != null) {
                System.out.println(sdf.format(System.currentTimeMillis()) + " - [_SSO]UserID(WASSession)=[" + (String)session.getAttribute("SSO_USER_ID") + "], UserID(SSOCache)=["+ spApi.getUserID() +"]
             * , UserIP:" + req.getRemoteAddr() + ", JSESSIONID:" + session.getId());
                if(!spApi_USER_ID.equals((String)session.getAttribute("SSO_USER_ID"))) {
                    System.out.println("[USERID_MATCH_ERROR!!]" + sdf.format(System.currentTimeMillis()) + " - [_SSO]UserID(WASSession)=[" + (String)session.getAttribute("SSO_USER_ID") + "]
             * , UserID(SSOCache)=["+ spApi.getUserID() +"], UserIP:" + req.getRemoteAddr() + ", JSESSIONID:" + session.getId());
                }
            }else{
                System.out.println(sdf.format(System.currentTimeMillis()) + " - [_SSO]UserID(WASSession) is null, UserID(SSOCache)=["+ spApi.getUserID() +"], UserIP:" + req.getRemoteAddr() + "
             * , JSESSIONID:" + session.getId());
            }
            *******************************************************************************************************/




			LOG.debug("id: {}\nip: {}", id, ip);
                      
			if (MoumiConfig.isSysAdmLoginConstraint()) {
				if (sysAuth == MoumiConfig.SYSADM && !MoumiConfig.getSysAdmIP().equals(ip)) {
                                  //21. res.sendError(HttpServletResponse.SC_UNAUTHORIZED, "ID: '" + req.getParameter("id") + "' "
					res.sendError(HttpServletResponse.SC_UNAUTHORIZED, "ID: '" + reqId + "' " 
							+ MoumiConfig.getMessageBundle().getString("moumi.message.popup.notConnectAdmin"));
					return;
				}
			}

			if (mode.equals("logout")) {
                          //21. res.sendError(HttpServletResponse.SC_UNAUTHORIZED, "ID: '" + req.getParameter("id") + "' "
				res.sendError(HttpServletResponse.SC_UNAUTHORIZED, "ID: '" + reqId + "' " 
						+ MoumiConfig.getMessageBundle().getString("moumi.message.popup.loginFailRetry"));
				return;
                        }else{
				int succNum = 11;
				succNum = executeSSOLogin(id, ip, session);
				if (succNum <= 10) {
					session.setAttribute("APP_LOGIN", true);
					//session.setAttribute("LOCAL_LOGIN", false);
				}

				if (succNum == MoumiConfig.REPOPER) {
					// 
                    //connURL = "location='/totsys/repoper/main.jsp';";
                                    connURL = "location='/totsys/login/frame.jsp?redirect=" + redirect + "';";
				} else if (succNum == MoumiConfig.SUB_TOTPER) {
					// 
                    //connURL = "location='/totsys/totper/main.jsp';";
                                    connURL = "location='/totsys/login/frame.jsp?redirect=" + redirect + "';";
				} else if (succNum == MoumiConfig.TOTPER) {
				   /*
					* connURL = "parent.frames['left'].location.href='/totsys/common/inc/totper/left/left.jsp';"+
					* "parent.frames['main'].location.href='/totsys/totper/main.jsp';";
					*/
                                    connURL = "location='/totsys/login/frame.jsp?redirect=" + redirect + "';";
				} else if (succNum == MoumiConfig.PART_REPOADM) {
                                    connURL = "location='/totsys/partrepoadm/main.jsp';";
				} else if (succNum == MoumiConfig.REPOADM) {
					//connURL = "location='/totsys/repoadm/main.jsp';";
                                    connURL = "location='/totsys/login/frame.jsp?redirect=" + redirect + "';";
				} else if (succNum == MoumiConfig.TOTADM || succNum == MoumiConfig.SUB_TOTADM) {
                                    connURL = "location='/totsys/totadm/main.jsp';";
				} else if (succNum == MoumiConfig.SYSADM || succNum == MoumiConfig.SUB_SYSADM) {
                    /*
                     * connURL = "parent.left.location.href='/totsys/common/inc/totper/left/left.jsp';"+
                     * "parent.main.location.href='/totsys/sysadm/main.jsp';";
                     */
                     connURL = "location='/totsys/login/frame.jsp?redirect=" + redirect + "';";
				} else if (succNum == 11) {
                                  //21. res.sendError(HttpServletResponse.SC_UNAUTHORIZED, "ID: '" + req.getParameter("id") + "' "
					res.sendError(HttpServletResponse.SC_UNAUTHORIZED, "ID: '" + reqId + "' "  
							+ MoumiConfig.getMessageBundle().getString("moumi.message.popup.notIdorPasswd"));
					return;
				} else if (succNum == 12) {
                                  //21. res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "ID: '" + req.getParameter("id") + "' "
					res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "ID: '" + reqId + "' "   
							+ MoumiConfig.getMessageBundle().getString("moumi.message.popup.retry"));
					return;
				} else if (succNum == 13) {
                                  //21. res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "ID: '" + req.getParameter("id") + "' "
					res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "ID: '" + reqId + "' "   
							+ MoumiConfig.getMessageBundle().getString("moumi.message.popup.deptChangeFailAdmin"));
					return;
				} else {
                                  //21. res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "ID: '" + req.getParameter("id") + "' "
					res.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "ID: '" + reqId + "' " 
							+ MoumiConfig.getMessageBundle().getString("moumi.message.popup.loginFailRetry"));
					return;
				}

				if (succNum > 10) {
					failLogin(session);
				}

				if (succNum <= 8 && succNum >= 0) {
					session.setMaxInactiveInterval(60 * 60 * 24); // 24ð
				}

                                //v2. 9.ũνƮ ũƮ (PrintWrier) : Update by KWON,HAN 
//				out.println(ServletUtil.getJavaScript(connURL));
                                
                                //  : ܺ Է° ͸ : '/totsys/login/frame.jsp?redirect=';
                                String filtered_connURL = connURL.replaceAll("<","").replaceAll(">","").replaceAll(",","");
                                //LOG.debug("v2 9.ũνƮ ũƮ (PrintWrier) : HttpSSOLogin.doPost() filtered_connURL={}, Test OK", filtered_connURL);
                                out.println(ServletUtil.getJavaScript(filtered_connURL));      
                                //========================================                                
			}
		} catch (Exception ex) {
			throw new RuntimeException(ex);
             	}
        }

	private void failLogin(HttpSession session) {
		session.setAttribute("APP_LOGIN", false);
		//session.setAttribute("LOCAL_LOGIN", false);
	}

	protected void executeLogout(HttpSession session) {
		session.invalidate();
	}

	/**************
	 * USER ************** return 0 =>   return 1 =>   return 5 => ID PWġ  return 6 => ϴ ID return
	 * 7 => ý 
	 ************************************/
	private int executeSSOLogin(String id, String ip, HttpSession session) {

		LOG.debug("SSO Login for user {}", id);
		MUser mUser = null;
		String userId = "";
		String deptId = "";
		String userPassword = "";
		PersistenceManager pm = new MPersistenceManager(PMF.get().getPersistenceManager());
		Transaction tx = pm.currentTransaction();
		try {
			tx.begin();

            /*̺κ multi check õǾ ޾ƿ ̵ н αϴ κ*/
			mUser = pm.detachCopy(pm.getObjectById(MUser.class, id));
			userId = mUser.getId();
			deptId = mUser.getUpperDept(pm).getId();
			userPassword = mUser.getPassword();
			LOG.debug("user password: {}", userPassword);
            /**/

			tx.rollback();

			return executeLogin(userId, userPassword, ip, session, deptId);
		} catch (Exception e) {
			LOG.error("User '{}' login failed: {}", id, e.getMessage());
			return 11;
		} finally {
			if (tx.isActive())
				tx.rollback();
			pm.close();
		}
	}

	int executeLogin(String id, String password, String ip, HttpSession session, String deptID) {
		int result = 11;
		MUser tmpUser = null;
		MDept userDept = null;
		PersistenceManager pm = new MPersistenceManager(PMF.get().getPersistenceManager());
		Transaction tx = pm.currentTransaction();
		try {
			tx.begin();
			tmpUser = pm.getObjectById(MUser.class, id);
			if (!((MoumiConfig.getUsePasswdEncrypt() && new StandardStringDigester().matches(password, tmpUser.getPassword())) || tmpUser
					.getPassword().equals(password))) {
				session.setAttribute("SSO_SIGN_MOUMI", "fail");
				LOG.debug("id: {} password: {}", id, password);

				return 11;
			}
			userDept = pm.getObjectById(MDept.class, deptID);
//			tmpUser.setUpperDept(userDept);
//			pm.makePersistent(tmpUser);

			LOG.debug("sessionID: {} for {}", session.getId(), tmpUser);
                        LOG.debug("Dept ID: {}", deptID);
			session.setAttribute("userID", tmpUser.getId());
			session.setAttribute("userName", tmpUser.getName(pm));
			session.setAttribute("sysAuth", new Integer(tmpUser.getSysAuth().ordinal()));
			session.setAttribute("deptID", userDept.getId());
			session.setAttribute("deptName", userDept.getName());
                        session.setAttribute("grade", userDept.getGrade());
//			session.setAttribute("organ", userDept.getOrgan(pm));
			// session.setAttribute("organName", userDept.getOrganization().getName());
			session.setAttribute("SSO_SIGN_MOUMI", "success"); // SSO  ǰ üũ
			result = tmpUser.getSysAuth().ordinal();

			LOG.info("{} logged in.", tmpUser);
//			tx.commit();
			tx.rollback();
			return result;
		} catch (Exception e) {
			e.printStackTrace();
			session.setAttribute("SSO_SIGN_MOUMI", "fail");

			return 12;
		} finally {
			if (tx.isActive()) {
				tx.rollback();
			}
			pm.close();
		}
	}

	public static boolean isLogin(HttpServletRequest req) {
		return req.getSession(true).getAttribute("userID") != null;
	}

	/**
	 * 
	 * use getMUser
	 * 
	 * @deprecated
	 * @param req
	 * @return
	 */
	@Deprecated
	public static String getLoginID(HttpServletRequest req) {
		return (String) req.getSession(true).getAttribute("userID");
	}

	/**
	 * 
	 * use getUser
	 * 
	 * @deprecated
	 * @param req
	 * @return
	 */
	@Deprecated
	public static String getUserName(HttpServletRequest req) {
		return (String) req.getSession(true).getAttribute("userName");
	}

	public static MUser getUser(HttpServletRequest req) {
		PersistenceManager pm = new MPersistenceManager(PMF.get().getPersistenceManager());
		try {
			return pm.getObjectById(MUser.class, req.getSession(true).getAttribute("userID"));
		} finally {
			pm.close();
		}
	}

	/**
	 * 
	 * use getUser
	 * 
	 * @deprecated
	 * @param req
	 * @return
	 */
	@Deprecated
	public static String getDeptID(HttpServletRequest req) {
		return (String) req.getSession(true).getAttribute("deptID");
	}

	/**
	 * 
	 * use getUser
	 * 
	 * @deprecated
	 * @param req
	 * @return
	 */
	@Deprecated
	public static String getDeptName(HttpServletRequest req) {
		return (String) req.getSession(true).getAttribute("deptName");
	}

	/**
	 * 
	 * use getOrganization
	 * 
	 * @deprecated
	 * @param req
	 * @return
	 */
	@Deprecated
	public static String getOrganID(HttpServletRequest req) {
		return (String) req.getSession(true).getAttribute("organID");
	}

	/**
	 * 
	 * use getMUser
	 * 
	 * @deprecated
	 * @param req
	 * @return
	 */
	@Deprecated
	public static int getSysAuth(HttpServletRequest req) {
		String userID = "";
		try {
			userID = (String) req.getSession(true).getAttribute("userID");
			return (Integer) req.getSession(true).getAttribute("sysAuth");
		} catch (NullPointerException npe) {
			LOG.error("user@{} is disconnected.", userID);
			throw new NullPointerException("user: " + userID + " is disconnected.");
		}
	}
}
