/***********************************************************************************
 * @@ Program Name : HttpLogin.java Description : α ó α    Author :  Create Date : 2004.10.13 History :
 * @@
 ***********************************************************************************/

package kr.co.kihyun.beans.user;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.entity.MUser;
import kr.co.kihyun.beans.entity.MoumiEntity;
import kr.co.kihyun.db.DBManager;

public class MultiCheck extends DBManager {
	private static final Logger LOG = LoggerFactory.getLogger(MultiCheck.class);

	private ResultSet rs = null;

        String[] array;
        String[] nameList;
        String[] getPassword;
        String[] userId;
        String[] adpInsttCode;
        String[] pNo;
        String[] kraOrgNm;

        int tcount = 0;

	/**************
	 * mUSER ************** return 0 =>   return 1 =>   return 5 => ID PWġ  return 6 => ϴ ID
	 * return 7 => ý 
	 ************************************/
	private String[] deptID = null;
	private String[] deptName = null;

	public String getPassword(String id) {
		StringBuilder sql = new StringBuilder(60);
		String password = "";
		try {
			sql.append("select passwd from ").append(MoumiEntity.getTableName(MUser.class)).append(" where id=?");
			rs = execQuery(sql, id);
			if (rs.next()) {
				password = rs.getString(1);
			}
			return password;
		} catch (SQLException sqlEx) {
			LOG.error("\nSQLState - {}\nMySQL Error Code - {}\nmessage - {}\nsql - {}",
					new Object[] { sqlEx.getSQLState(), sqlEx.getErrorCode(), sqlEx.getMessage(), sql });
			throw new RuntimeException(sqlEx);
		} catch (Exception ex) {
			throw new RuntimeException(ex);
		} finally {
			close(rs);
			execClose();
		}
	}

	public boolean idCheck(String id) {
		StringBuilder sql = new StringBuilder(60);
		int count = 0;

		try {
/*ð   ش  ʿ 2015.6.9*/
//			sql.append("select passwd from ").append(MoumiEntity.getTableName(MUser.class)).append(" where id=?");
//
//			rs = execQuery(sql, id);
//			if (!rs.next()) { // FIXME: sso does not check password
//				return false;
//			}
//
//			close(rs);
//			execClose();

//			sql.append("select dt.id, dt.name from ").append(MoumiEntity.getTableName(Emul.class)).append(" em, ")
//					.append(MoumiEntity.getTableName(MDept.class)).append(" dt ")
//					.append("where em.user_id=? and dt.id=em.dept_id");
                        
                         sql.append(" SELECT DT.ID, DT.NAME \n")
                            .append(" FROM XF.PT_MEMBER PM, MOUMI_DEPT DT \n")
                            .append(" WHERE PM.USER_ID = ? AND PM.GROUP_ID = DT.ID \n")
                            .append(" ORDER BY DT.PRIORITY ");
			rs = execQuery(sql, id);
			if (rs != null) {
				rs.last();
				tcount = rs.getRow();
				rs.beforeFirst();
			} else {
				return false;
			}

			deptID = new String[tcount];
			deptName = new String[tcount];

			for (int i = 0; rs.next(); i++) {
				deptID[i] = rs.getString(1);
				deptName[i] = rs.getString(2);
			}

			return true;
		} catch (SQLException sqlEx) {
			LOG.error("\nSQLState - {}\nMySQL Error Code - {}\nmessage - {}\nsql - {}",
					new Object[] { sqlEx.getSQLState(), sqlEx.getErrorCode(), sqlEx.getMessage(), sql });
			throw new RuntimeException(sqlEx);
		} catch (Exception ex) {
			LOG.error("ResultSet: {}, id: {}, password: {}", new Object[] { rs, id });
			throw new RuntimeException(ex);
		} finally {
			close(rs);
			execClose();
		}
	}

	public int deptUpdate(String id, String deptID) {
		String sql = "";
		try {
			sql = "UPDATE MOUMI_MUSER SET DEPT_ID = '"+deptID+"' WHERE ID = '"+id+"'";
                        System.out.println(sql);
			//return execUpdate(sql, DBUtil.nullToSpace(deptID), id);
                        return execUpdate(sql);
		} catch (SQLException sqlEx) {
			LOG.error("\nSQLState - {}\nMySQL Error Code - {}\nmessage - {}\nsql - {}",
					new Object[] { sqlEx.getSQLState(), sqlEx.getErrorCode(), sqlEx.getMessage(), sql });
			return -1;
		} catch (Exception ex) {
			ex.printStackTrace();
			return -1;
		} finally {
			execClose();
		}
	}

	public String[] getDeptID() {
		return deptID;
	}

	public String[] getDeptName() {
		return deptName;
	}

        public String[] getNameList() {
                    return nameList;
            }

        //user_id
        public String[] getUserId() {
                    return userId;
            }

        //p_No
       public String[] getPno() {
                    return pNo;
            }


        public int getCount(){
              return tcount;
          }
}
