package kr.co.kihyun.beans.user;

//import java.io.IOException;
import java.io.PrintWriter;
//import kr.co.kihyun.tree.*;
import java.sql.ResultSet;
import java.sql.SQLException;

//import javax.servlet.ServletException;
//import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.entity.SubmitReport;
import kr.co.kihyun.db.DBManager;
import kr.co.kihyun.lang.Encoder;
import kr.co.kihyun.lang.MString;
//import kr.co.kihyun.lang.MInteger;
//import kr.co.kihyun.lang.MLong;
import kr.co.kihyun.moumi.MoumiConfig;
//import kr.co.kihyun.beans.user.HttpSSOLogin;
import kr.co.kihyun.text.html.ServletUtil;

public class UserApproSetModify extends DBManager {
    private static final Logger LOG = LoggerFactory.getLogger(UserApproSetModify.class);
    
    public UserApproSetModify(HttpServletRequest req, HttpServletResponse res) {
        String userId = null;
        String docID = null;
        String deptID = null;
        String userID = null;
        String Appro = null;
        String reportID = null;
        String reportType = null;
        String docType = null;
        String strPage = null;
        String findOption = null;
        String findWord = null;
            
        String[] reportIDList = null;
        String[] userIDList = null;
        String strGubun = null;
        String usID = HttpSSOLogin.getLoginID(req);
        int sysAuth;
        ResultSet rs = null;

        PrintWriter out = null;
        try {
            res.setContentType("text/html;charset=euc-kr");
            out = res.getWriter();
            if (!HttpSSOLogin.isLogin(req)) {
                String connURL = "location='/totsys/login/login.jsp';";
                out.println(ServletUtil.getJavaScript(connURL));
                return;
            }
            reportID = MString.checkNull(req.getParameter("reportID"), "null");
            //userId=MString.checkNull(req.getParameter("userID"),null);
            //reportType= MString.checkNull(req.getParameter("reportType"),"null");
            docType = MString.checkNull(req.getParameter("docType"), "null");
            strPage = (String) Encoder.toJava(req.getParameter("strPage"));
            findOption = MString.checkNull(Encoder.toJava(req.getParameter("findOption")));
            findWord = MString.checkNull(Encoder.toJava(req.getParameter("findWord")));            
            strGubun = MString.checkNull(req.getParameter("strGubun"), "null");
            // = userId.split(",");
            reportIDList = reportID.split(",");

            SubmitReport submitReport = new SubmitReport();
            submitReport.getSysAuth(usID);
            sysAuth = submitReport.getAuthNum();
            String tmpSysAuth = Integer.toString(sysAuth);

            //for(int i = 1; i < userIDList.length; i++){
            for (int i = 0; i < reportIDList.length; i++) {
                 //System.out.print("usID:::"+usID+"::reportIDList:::"+reportIDList[i]+"::sysAuth::"+tmpSysAuth+"\n");
                //String tmpStr = userIDList[i].replace(" ","");
                String tmpSysAuthRlpc = tmpSysAuth.replace(" ", "");
                String tmpGubun = strGubun.replace(" ", "");

                String sql = "UPDATE MOUMI_TOT_DOC SET ACC_AUTH=? WHERE ID=?";
//System.out.println("user::sql:::::"+sql+"\n::::tmpGubun::"+tmpGubun+":::id:"+reportIDList[i]);
                execUpdate(sql, tmpGubun, reportIDList[i]);

                if (tmpGubun.equals("1")) {
                    out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.approModify")));
                } else {
                    out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.approCancel")));
                }
                //out.println(ServletUtil.redirect("/totsys/repoper/mydocbox/endbox/report_list.jsp?reload=yes&reportID="+reportID+"&reportType="+reportType));
                //out.println(ServletUtil.redirect("/totsys/totper/mydocbox/prssbox/doc_list.jsp?reload=yes&reportID=" + reportID + "&docType=END"));
                out.println(ServletUtil.redirect("/totsys/totper/mydocbox/prssbox/doc_list.jsp?reload=yes&reportID=" + reportID + "&docType="+ docType + "&strPage="+ strPage + "&findOption="+ findOption + "&findWord="+ findWord + ""));
            }
        } catch (Exception e) {
            e.printStackTrace();
            out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.approModifyCancel")));
            //out.println(ServletUtil.redirect("/totsys/totper/mydocbox/prssbox/doc_list.jsp?reload=yes&reportID=" + reportID + "&docType=END"));
            
            //v2. 9.ũνƮ ũƮ (PrintWrier) : Update by KWON,HAN 
//            out.println(ServletUtil.redirect("/totsys/totper/mydocbox/prssbox/doc_list.jsp?reload=yes&reportID=" + reportID + "&docType="+ docType + "&strPage="+ strPage + "&findOption="+ findOption + "&findWord="+ findWord + ""));
            
            //  : ܺ Է° ͸
            String callbackFunc = "/totsys/totper/mydocbox/prssbox/doc_list.jsp?reload=yes&reportID=" + reportID + "&docType="+ docType + "&strPage="+ strPage + "&findOption="+ findOption + "&findWord="+ findWord + "";
            String filtered_callbackFunc = callbackFunc.replaceAll("<","").replaceAll(">","").replaceAll(",","");
            LOG.debug("v2 9.ũνƮ ũƮ (PrintWrier) : UserApproModify.UserApproModify() filtered_callbackFunc={}, Not Test", filtered_callbackFunc);
            out.println(ServletUtil.redirect(filtered_callbackFunc));
            //========================================              
            
        } finally {
            //execClose();
            try {
                if (stmt != null) {
                    stmt.close();
                }
            } catch (SQLException ex) {
                //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                ex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
            }
            try {
                if (con != null) {
                    con.close();
                }
            } catch (SQLException ex) {
                //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                ex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
            }
            try {
                if (rs != null) {
                    rs.close();
                }
            } catch (SQLException ex) {
                //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                ex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
            }
        }
    }
}
