/*********************************************************************************************************
 * α׷ : OPTSQLException.java α׷ :    ϴ  pool ϱ  Ŭ getConnection() ȣ⸶  üũ  ʱ  
 * ȯ游 ּ óؼ ϵ Ѵ.
 * 
 * ۼ :  ۼ : 2003.12.16  : 2002.07.22
 **********************************************************************************************************/

package kr.co.kihyun.db;

import java.sql.SQLException;

public class SQLMessage extends Throwable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	SQLException sqlEx = null;
	String formClass = null;
	String sql = null;

	public SQLMessage(SQLException sqlEx, String formClass, String sql) {
		this.sqlEx = sqlEx;
		this.formClass = formClass;
		this.sql = sql;
	}

	public SQLMessage(SQLException sqlEx, String sql) {
		this.sqlEx = sqlEx;
		this.sql = sql;
	}

	public SQLMessage(SQLException sqlEx) {
		this.sqlEx = sqlEx;
	}

	public String getMessage(String formClass) {
		StringBuffer strbuf = new StringBuffer();
		this.formClass = formClass;

		strbuf.append("\n\nSQLState: ");
		strbuf.append(sqlEx.getSQLState());
		strbuf.append("\nMySQL Error Code: ");
		strbuf.append(sqlEx.getErrorCode());
		strbuf.append("\nFile name: ");
		strbuf.append(formClass);
		strbuf.append("\nmessage: ");
		strbuf.append(sqlEx.getMessage());
		strbuf.append("\nsql: ");
		strbuf.append(sql);

		return strbuf.toString();
	}

	public static String getMessage(SQLException sqlEx, String formClass, String sql) {
		StringBuffer strbuf = new StringBuffer();

		strbuf.append("\n\nSQLState: ");
		strbuf.append(sqlEx.getSQLState());
		strbuf.append("\nMySQL Error Code: ");
		strbuf.append(sqlEx.getErrorCode());
		strbuf.append("\nFile name: ");
		strbuf.append(formClass);
		strbuf.append("\nmessage: ");
		strbuf.append(sqlEx.getMessage());
		strbuf.append("\nsql: ");
		strbuf.append(sql);

		return strbuf.toString();
	}

	public static String getMessage(SQLException sqlEx, String sql) {
		StringBuffer strbuf = new StringBuffer();

		strbuf.append("\n\nSQLState: ");
		strbuf.append(sqlEx.getSQLState());
		strbuf.append("\nMySQL Error Code: ");
		strbuf.append(sqlEx.getErrorCode());
		strbuf.append("\nmessage: ");
		strbuf.append(sqlEx.getMessage());
		strbuf.append("\nsql: ");
		strbuf.append(sql);

		return strbuf.toString();
	}

	public static String getMessage(SQLException sqlEx) {
		StringBuffer strbuf = new StringBuffer();

		strbuf.append("\n\nSQLState: ");
		strbuf.append(sqlEx.getSQLState());
		strbuf.append("\nMySQL Error Code: ");
		strbuf.append(sqlEx.getErrorCode());
		strbuf.append("\nmessage: ");
		strbuf.append(sqlEx.getMessage());

		return strbuf.toString();
	}
}