/*********************************************************************************************************
 * : UploadedFiles.java : 2003.12.30 : 2003.11.15
 **********************************************************************************************************/

package kr.co.kihyun.io;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class OPTFileWriter {
    
    private static final Logger LOG = LoggerFactory.getLogger(OPTFileWriter.class);
        
    public void fileWrite(String fileName, String data) throws IOException {
        
        FileWriter fw = null;
        BufferedWriter outFile = null;
        
        try {
            //9.丮  (Ƽε)_CWE-22/23 : Add by KWON,HAN
            if(fileName.contains("..") || fileName. contains("/")) { // Ưڿ 
                LOG.debug("9.丮  (Ƽε)_CWE-22/23 : Not Test {}", fileName);
                return;
            }
            //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                
            fw = new FileWriter(fileName);
            outFile = new BufferedWriter(fw);
            
            if (data != null) {
                outFile.write(data);
            }
            outFile.flush();
            //outFile.close();
        
        } catch (FileNotFoundException exception) {
                //34.޼   (toString)_CWE-209 : Update by YOUNGJUN,CHO
                //System.out.println("The file " + fileName + " was not found.");
                LOG.error("\nThe file {} was not found.", fileName);
                //================================================
        } catch (IOException exception) {
                //34.޼   (toString)_CWE-209 : Update by YOUNGJUN,CHO
                //System.out.println(exception);
                LOG.error("\nOPTFileWriter fileWrite() Exception - {}", exception.toString());
                //================================================                        
        } catch (ArrayIndexOutOfBoundsException e) {
            //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
            e.printStackTrace();
            //++++++++++++++++++++++++++++++++++++++++++++++++
        } finally {
            //v2 21. ڿ  (IO)_CWE-404 : Add by YOUNGJUN,CHO
            // Ͽ  , finally  ݵ .
            if(outFile != null) {
                outFile.close();
            }
            
            if (fw != null) {
                fw.close();
            }
            //++++++++++++++++++++++++++++++++++++++++++++++++
        }
    }
}
