package kr.co.kihyun.lang;

public class MInteger {

	public static int parseInt(String s) {
		return parseInt(s, 0);
	}

	public static int parseInt(String s, int earlyValue) {
		try {
			if (s != null) {
				return Integer.parseInt(s);
			} else {
				return earlyValue;
			}
		} catch (NumberFormatException ex) {
			return earlyValue;
		}
	}

	public static String toString(int num) {
		return (num > 9) ? ("" + num) : ("0" + num);
	}
}