package kr.co.kihyun.mail;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.db.DBManager;

public class getMailid extends DBManager
{
  private List<String> recogid;
  private ResultSet rs = null;
  private static final Logger LOG = LoggerFactory.getLogger(getMailid.class);
  private String[] DEPTNAME = null;
  private String[] EMPCODE = null;
  private String[] ID = null;
  private String[] DEPTID = null;
  private String[] NAME = null;
  private String USERID = null;
  private String EMP_CODE = null;
  private int Count;
  private int tCount;

  public void getEmpCode(String usID, String dpID)
  {
    StringBuilder sql = new StringBuilder(250);
    int count = 0;
    String tmpStr = null;
    try
    {
      sql.append(new StringBuilder().append("SELECT DISTINCT(NVL(EMP_CODE,'N')) AS EMPCODE FROM MOUMI_MUSER WHERE ID ='").append(usID).append("' AND DEPT_ID = '").append(dpID).append("'").toString());
      System.out.println(new StringBuilder().append("GET EMP_CODE::::::").append(sql).toString());
      this.rs = execQuery(sql, new Object[0]);

      if (this.rs != null) {
        this.rs.last();
        count = this.rs.getRow();
        this.rs.beforeFirst();
      }
      else {
        return;
      }
      this.Count = count;
      for (int i = 0; this.rs.next(); i++) {
        this.EMP_CODE = this.rs.getString(1);
      }

      System.out.println(sql);
    }
    catch (SQLException sqlEx) {
      LOG.error("\nSQLState - {}\nMySQL Error Code - {}\nmessage - {}\nsql - {}", new Object[] { sqlEx.getSQLState(), Integer.valueOf(sqlEx.getErrorCode()), sqlEx.getMessage() });

      throw new RuntimeException(sqlEx);
    } catch (Exception ex) {
      throw new RuntimeException(ex);
    } finally {
      try {
        if (this.con != null)
          this.con.close();
      } catch (SQLException ex) {
      }
      try {
        if (this.stmt != null)
          this.stmt.close();
      } catch (SQLException ex) {
      }
      try {
        if (this.rs != null)
          this.rs.close();
      } catch (SQLException ex) {
      }
    }
  }

  public void getUserId(String dpID, String docID) {
    StringBuilder sql = new StringBuilder(250);
    int count = 0;
    String tmpStr = null;
    try
    {
      sql.append(new StringBuilder().append("SELECT DISTINCT(NVL(USER_ID,'N')) AS USERID FROM MOUMI_TOT_REPORT WHERE DEPT_ID ='").append(dpID).append("' AND DOC_ID ='").append(docID).append("'").toString());
      System.out.println(new StringBuilder().append("getUserId::::::").append(sql).toString());
      this.rs = execQuery(sql, new Object[0]);

      if (this.rs != null) {
        this.rs.last();
        count = this.rs.getRow();
        this.rs.beforeFirst();
      }
      else {
        return;
      }
      this.Count = count;
      for (int i = 0; this.rs.next(); i++) {
        this.USERID = this.rs.getString(1);
      }

      System.out.println(sql);
    }
    catch (SQLException sqlEx) {
      LOG.error("\nSQLState - {}\nMySQL Error Code - {}\nmessage - {}\nsql - {}", new Object[] { sqlEx.getSQLState(), Integer.valueOf(sqlEx.getErrorCode()), sqlEx.getMessage() });

      throw new RuntimeException(sqlEx);
    } catch (Exception ex) {
      throw new RuntimeException(ex);
    } finally {
      try {
        if (this.con != null)
          this.con.close();
      } catch (SQLException ex) {
      }
      try {
        if (this.stmt != null)
          this.stmt.close();
      } catch (SQLException ex) {
      }
      try {
        if (this.rs != null)
          this.rs.close();
      }
      catch (SQLException ex)
      {
      }
    }
  }

  public void getEmailIdList(String docID, String dpID, String rptID)
  {
    StringBuilder sql = new StringBuilder(250);
    int count = 0;
    String tmpStr = null;
    String tmpRptId = null;
    try
    {
      System.out.println(new StringBuilder().append("::::rptID::::::").append(rptID).toString());

      if (rptID.equals(null))
        tmpRptId = "00001";
      else {
        tmpRptId = rptID;
      }
      sql.append(" select DT.NAME AS DEPTNAME, US.NAME AS NAME,US.EMP_CODE AS EMPCODE,US.ID AS ID,US.DEPT_ID AS DEPTID")
              .append(" from moumi_muser us, moumi_tot_report rt, moumi_dept dt")
              .append(" where US.DEPT_ID = DT.ID")
              .append(" AND rt.dept_id = dt.id")
              .append(" and (rt.user_id = us.id or rt.user_id is null)")
              .append(new StringBuilder()
              .append(" and rt.doc_id = '")
              .append(docID)
              .append("'").toString())
              .append(new StringBuilder()
              .append(" and rt.id in (")
              .append(tmpRptId)
              .append(")").toString())
              .append(" and rt.prss not in (6,12)");

      this.rs = execQuery(sql, new Object[0]);
      if (this.rs != null) {
        this.rs.last();
        count = this.rs.getRow();
        this.rs.beforeFirst();
      }
      else {
        return;
      }
      this.DEPTNAME = new String[count];
      this.NAME = new String[count];
      this.EMPCODE = new String[count];
      this.ID = new String[count];
      this.DEPTID = new String[count];
      this.tCount = count;

      for (int i = 0; this.rs.next(); i++) {
        this.DEPTNAME[i] = this.rs.getString(1);
        this.NAME[i] = this.rs.getString(2);
        this.EMPCODE[i] = this.rs.getString(3);
        this.ID[i] = this.rs.getString(4);
        this.DEPTID[i] = this.rs.getString(5);
      }

      System.out.println(new StringBuilder().append("getEmailIdList::::::").append(sql).toString());
    }
    catch (SQLException sqlEx) {
      LOG.error("\nSQLState - {}\nMySQL Error Code - {}\nmessage - {}\nsql - {}", new Object[] { sqlEx.getSQLState(), Integer.valueOf(sqlEx.getErrorCode()), sqlEx.getMessage() });

      throw new RuntimeException(sqlEx);
    } catch (Exception ex) {
      throw new RuntimeException(ex);
    } finally {
      try {
        if (this.con != null)
          this.con.close();
      } catch (SQLException ex) {
      }
      try {
        if (this.stmt != null)
          this.stmt.close();
      } catch (SQLException ex) {
      }
      try {
        if (this.rs != null)
          this.rs.close();
      }
      catch (SQLException ex) {
      }
    }
  }

  public String getUserId() {
    return this.USERID;
  }

  public String[] getEmpCode() {
    return this.EMPCODE;
  }

  public String[] getDeptName() {
    return this.DEPTNAME;
  }

  public String getEmp_Code() {
    return this.EMP_CODE;
  }

  public String[] getID() {
    return this.ID;
  }

  public String[] getDeptId() {
    return this.DEPTID;
  }

  public String[] getName() {
    return this.NAME;
  }

  public int getTcount() {
    return this.tCount;
  }

  public int getCount() {
    return this.Count;
  }
}