/*********************************************************************************************************
 * α׷ : Moumi.java α׷ : Ʈ õ   ִ class ۼ : ()ũ ۼ : 2003.12.18  : 2003.11.30
 **********************************************************************************************************/

package kr.co.kihyun.moumi;

import java.io.File;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Properties;
import java.util.ResourceBundle;

import javax.jdo.JDOHelper;
import javax.jdo.PersistenceManagerFactory;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.entity.util.ECrossSchemaOrganizer;
import kr.co.kihyun.beans.entity.util.PMF;
import kr.co.kihyun.beans.entity.util.SchemaOrganizer;
import kr.co.kihyun.sync.OrgSynchronizer;

public final class Moumi implements Filter {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static final Logger LOG = LoggerFactory.getLogger(Moumi.class);
	private OrgSynchronizer sync;

	/**
	 * @deprecated Use {@link MoumiConfig#getMessageBundle()} instead
	 */
	public static final ResourceBundle getMessageBundle() {
		return MoumiConfig.getMessageBundle();
	}

	public Moumi() {
	}

      //v2. 5.static final ʵ  ɼ : Update by KWON,HAN 
      // public̶ ̹ ٸ ڹԼ ̹ ϰ Ƿ  ذå  ƴ.
	/******** 蹮 ٱ  
	 * @deprecated Use {@link MoumiConfig#PER} instead********/
	@Deprecated
	public static final int PER = MoumiConfig.PER;
	/**
	 * @deprecated Use {@link MoumiConfig#DEPT} instead
	 */
	@Deprecated
	public static final int DEPT = MoumiConfig.DEPT;
	/**
	 * @deprecated Use {@link MoumiConfig#PART} instead
	 */
	@Deprecated
	public static final int PART = MoumiConfig.PART;
	/**
	 * @deprecated Use {@link MoumiConfig#ALL} instead
	 */
	@Deprecated
	public static final int ALL = MoumiConfig.ALL;

	/********     
	 * @deprecated Use {@link MoumiConfig#REPOPER} instead*********/
	@Deprecated
	public static final int REPOPER = MoumiConfig.REPOPER; // 
	/**
	 * @deprecated Use {@link MoumiConfig#SUB_TOTPER} instead
	 */
	@Deprecated
	public static final int SUB_TOTPER = MoumiConfig.SUB_TOTPER; // 
	/**
	 * @deprecated Use {@link MoumiConfig#TOTPER} instead
	 */
	@Deprecated
	public static final int TOTPER = MoumiConfig.TOTPER; // 
	/**
	 * @deprecated Use {@link MoumiConfig#PART_REPOADM} instead
	 */
	@Deprecated
	public static final int PART_REPOADM = MoumiConfig.PART_REPOADM; // 
	/**
	 * @deprecated Use {@link MoumiConfig#REPOADM} instead
	 */
	@Deprecated
	public static final int REPOADM = MoumiConfig.REPOADM; // 
	/**
	 * @deprecated Use {@link MoumiConfig#SUB_TOTADM} instead
	 */
	@Deprecated
	public static final int SUB_TOTADM = MoumiConfig.SUB_TOTADM; // 
	/**
	 * @deprecated Use {@link MoumiConfig#SUB_SYSADM} instead
	 */
	@Deprecated
	public static final int SUB_SYSADM = MoumiConfig.SUB_SYSADM; // ý۰
	/**
	 * @deprecated Use {@link MoumiConfig#TOTADM} instead
	 */
	@Deprecated
	public static final int TOTADM = MoumiConfig.TOTADM; // 
	/**
	 * @deprecated Use {@link MoumiConfig#SYSADM} instead
	 */
	@Deprecated
	public static final int SYSADM = MoumiConfig.SYSADM; // ý۰
      //==========================================================            

        
      //v2. 5.static final ʵ  ɼ : Update by KWON,HAN
      //private  Ŭ  ȣ ϹǷ   public ϰ final  ʴ´ 
      // public static final   public static  Ѵ.
	/**
	 * @deprecated Use {@link MoumiConfig#getInitParameter(String)} instead
	 */
	public static String getInitParameter(String paramName) {
		return MoumiConfig.getInitParameter(paramName);
	}

	/******** Setup values 
	 * @deprecated Use {@link MoumiConfig#getRoot()} instead********/
	public static File getRoot() {
		return MoumiConfig.getRoot();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getDir(String)} instead
	 */
	private static File getDir(String fileDir) {
		return MoumiConfig.getDir(fileDir);
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getFileDirectory()} instead
	 */
	public static File getFileDirectory() {
		return MoumiConfig.getFileDirectory();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getTotRoot()} instead
	 */
	public static File getTotRoot() {
		return MoumiConfig.getTotRoot();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getTotPerRoot()} instead
	 */
	public static File getTotPerRoot() {
		return MoumiConfig.getTotPerRoot();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getTotPerTmp()} instead
	 */
	public static File getTotPerTmp() {
		return MoumiConfig.getTotPerTmp();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getRepoPerRoot()} instead
	 */
	public static File getRepoPerRoot() {
		return MoumiConfig.getRepoPerRoot();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getRepoPerTmp()} instead
	 */
	public static File getRepoPerTmp() {
		return MoumiConfig.getRepoPerTmp();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getBoardFileRoot()} instead
	 */
	public static File getBoardFileRoot() {
		return MoumiConfig.getBoardFileRoot();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getDocFileRoot()} instead
	 */
	public static File getDocFileRoot() {
		return MoumiConfig.getDocFileRoot();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getCsvFileRoot()} instead
	 */
	public static File getCsvFileRoot() {
		return MoumiConfig.getCsvFileRoot();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getSysAdmFileRoot()} instead
	 */
	public static File getSysAdmFileRoot() {
		return MoumiConfig.getSysAdmFileRoot();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getTitle()} instead
	 */
	public static String getTitle() {
		return MoumiConfig.getTitle();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getSysAdmIP()} instead
	 */
	public static String getSysAdmIP() {
		return MoumiConfig.getSysAdmIP();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getUseRecog()} instead
	 */
	public static boolean getUseRecog() {
		return MoumiConfig.getUseRecog();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getUsePasswdEncrypt()} instead
	 */
	public static boolean getUsePasswdEncrypt() {
		return MoumiConfig.getUsePasswdEncrypt();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#isSysAdmLoginConstraint()} instead
	 */
	public static boolean isSysAdmLoginConstraint() {
		return MoumiConfig.isSysAdmLoginConstraint();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getUseAssign()} instead
	 */
	public static boolean getUseAssign() {
		return MoumiConfig.getUseAssign();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#is2Step()} instead
	 */
	public static boolean is2Step() {
		return MoumiConfig.is2Step();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#isMonitor()} instead
	 */
	public static boolean isMonitor() {
		return MoumiConfig.isMonitor();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#is2StepDirect()} instead
	 */
	public static boolean is2StepDirect() {
		return MoumiConfig.is2StepDirect();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getDtdUri()} instead
	 */
	public static String getDtdUri() {
		return MoumiConfig.getDtdUri();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getMessengerServerAddress()} instead
	 */
	public static String getMessengerServerAddress() {
		return MoumiConfig.getMessengerServerAddress();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getMessengerServerPort()} instead
	 */
	public static int getMessengerServerPort() {
		return MoumiConfig.getMessengerServerPort();
	}

	/**
	 * @deprecated Use {@link MoumiConfig#getPMFProperties()} instead
	 */
	public static Properties getPMFProperties() {
		return MoumiConfig.getPMFProperties();
	}
      //==========================================================
        
	public void destroy() {
		LOG.info("Moumi has been destroyed.");
	}

    public void doFilter(ServletRequest arg0, ServletResponse arg1, FilterChain arg2) throws IOException,
			ServletException {
		arg2.doFilter(arg0, arg1);
		// HttpServletRequest req = (HttpServletRequest) arg0;
		// if (req.getMethod().equalsIgnoreCase("POST")
		// && req.getContentType().startsWith("multipart/form-data")) {
		// LOG.debug("MULTIPART REQUEST");
		// arg2.doFilter(new MultipartRequest(req), arg1);
		// } else {
		// arg2.doFilter(arg0, arg1);
		// }
	}
   

 /*public void doFilter(ServletRequest arg0, ServletResponse arg1, FilterChain arg2) throws IOException,
			ServletException {
	             
		 try {
              arg2.doFilter(arg0, arg1);
              LOG.debug("arg0 {}",arg0);
              LOG.debug("arg1 {}",arg1);
              LOG.debug("arg2 {}",arg2);
			  return;
		} catch (Exception e) {
            LOG.error("arg0 {}",arg0);
            LOG.error("arg1 {}",arg1);
            LOG.error("arg2 {}",arg2);
            LOG.error(e.toString());
		}
	}*/


	public void init(FilterConfig arg0) throws ServletException {
		SchemaOrganizer so = new SchemaOrganizer(PMF.get());
		so.validateSchema();
		// so.validateUsers();
		so.validateCategories();

		PersistenceManagerFactory ecrossPmf = JDOHelper.getPersistenceManagerFactory(MoumiConfig.getECrossProperties());
		PMF.set("ECROSS", ecrossPmf);
		ECrossSchemaOrganizer eso = new ECrossSchemaOrganizer(PMF.get("ECROSS"));
		eso.validateSchema();

                //moumi.properties ϳ  moumi.use.replication = false
		if (Boolean.parseBoolean(MoumiConfig.getInitParameter("moumi.use.replication"))) {
			PersistenceManagerFactory handyPmf = JDOHelper.getPersistenceManagerFactory(MoumiConfig.getHandyProperties());
			PMF.set("HANDY", handyPmf);
			sync = new OrgSynchronizer();
			sync.start();
		}

                //20.˻ (Ƽ)_CWE-367 : Test by KWON,HAN
                //sync = new OrgSynchronizer();
                //sync.run();
                //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                
		LOG.info("Moumi has been initialized.");
		StringBuilder configs = new StringBuilder();
		for (Enumeration<String> keys = MoumiConfig.getMoumiConfig().getKeys(); keys.hasMoreElements();) {
			String key = keys.nextElement();
			configs.append("  ").append(key).append(" : ").append(MoumiConfig.getMoumiConfig().getString(key)).append("\n");
		}
		LOG.info("Moumi installed on : {}", MoumiConfig.getRoot());
		LOG.info("Moumi configurations are : \n{}", configs.toString());
	}
}
