/*********************************************************************************************************
 * α׷ : MreportMake.java α׷ :  ڷ   Ͽ ڷ  ó  ۼ :  ۼ : 2003.11.30  : 2005-02-04
 **********************************************************************************************************/

package kr.co.kihyun.moumi.report;

import java.text.NumberFormat;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.totsys.doc.table.item.ItemList;
import kr.co.kihyun.moumi.doc.table.MTable;
import kr.co.kihyun.moumi.doc.table.item.MItem;
import kr.co.kihyun.text.excel.CalculationForm;
import kr.co.kihyun.text.html.Html;
import kr.co.kihyun.text.html.HtmlUtil;
import kr.co.kihyun.text.html.TagFilter;

public class MReportMaker {
	private static final Logger LOG = LoggerFactory.getLogger(MReportMaker.class);

	public static String reportMake(String form, String[] dataList, ItemList itemList, int strInItemNum, int tableType,
			int outType) {
		return reportMake(form, dataList, itemList.getNumList(), itemList.getNameList(), itemList.getBNWList(),
				itemList.getTypeList(), itemList.getExprList(), strInItemNum, 0, 0, tableType, outType);
	}

	// ڷẸ ǥ, Ȳ ǥ, ǥ , ǥ
	public static String reportMake(String form, String[] dataList, int[] itemNumList, int[] itemBNWList,
			int[] itemTypeList, String[] itemExprList, int strInItemNum, int tableType, int outType)
			throws NullPointerException {
		return reportMake(form, dataList, itemNumList, null, itemBNWList, itemTypeList, itemExprList, strInItemNum, 0,
				0, MTable.STATIC, outType);
	}

	// ڷẸ ǥ, Ȳ ǥ, ǥ , ǥ
	public static String reportMake(String form, String[] dataList, int[] itemNumList, int[] itemBNWList,
			int[] itemTypeList, int strInItemNum, int tableType, int outType) throws NullPointerException {
		return reportMake(form, dataList, itemNumList, null, itemBNWList, itemTypeList, null, strInItemNum, 0, 0,
				MTable.STATIC, outType);
	}

	// ڷẸ ǥ, Ȳ ǥ
	public static String reportMake(String form, String[][] dataList, int[] itemNumList, String[] itemNameList,
			int[] itemBNWList, int[] itemTypeList, String[] itemExprList, int strInItemNum, int titleRowCount,
			int rowCount, int tableType, int outType) throws NullPointerException {
		StringBuffer repoBuf = new StringBuffer();
		for (int i = 0; i < dataList.length; i++) {
			repoBuf.append(reportMake(form, dataList[i], itemNumList, itemNameList, itemBNWList, itemTypeList,
					itemExprList, strInItemNum, titleRowCount, i, tableType, outType));
		}
		return repoBuf.toString();
	}

	//  Ÿ html, excel, hml  ؼ excel̸  ־ Ѵ.
	public static String reportMake(String form, String[] dataList, int[] itemNumList, String[] itemNameList,
			int[] itemBNWList, int[] itemTypeList, String[] itemExprList, int strInItemNum, int titleRowCount,
			int rowCount, int tableType, int outType) throws NullPointerException {
		if (outType == MReport.EXCEL) {
			return excelReportMake(form, dataList, itemNumList, itemNameList, itemBNWList, itemTypeList, itemExprList,
					strInItemNum, titleRowCount, rowCount, tableType);
		} else {
			return nomalReportMake(form, dataList, itemNumList, itemBNWList, itemTypeList, itemExprList, strInItemNum,
					titleRowCount, rowCount, tableType);
		}
	}

	// ,  Ϲ  , Ȳ , ǥ 
	private static String nomalReportMake(String form, String[] dataList, int[] itemNumList, int[] itemBNWList,
			int[] itemTypeList, String[] itemExprList, int strInItemNum, int titleRowCount, int rowCount, int tableType)
			throws NullPointerException {
		if (form == null)
			return null;
		StringBuilder repoBuf = new StringBuilder();

		int stTDIndex;
		int edTDIndex;
		int dataIndex = 0;
		int itemAllCount = itemNumList.length - 1; // 0  index    -1 

		for (int i = strInItemNum; i <= itemAllCount; i++) {
			if (dataIndex > itemAllCount)
				break; // dataList length  itemNameList length  .

			stTDIndex = form.indexOf("<td");
			if (stTDIndex < 0)
				break;
			edTDIndex = form.indexOf(">", stTDIndex + 1);
			if (edTDIndex < 0)
				break;

			if (itemBNWList[i] == 1)
				dataList[dataIndex] = HtmlUtil.toBR(dataList[dataIndex]); // <TextArea></TextArea>

			if (itemTypeList[i] == MItem.TITLE) { // ŸƲ϶
				repoBuf.append(form.substring(0, edTDIndex));
				repoBuf.append(" align=center>");
				/*
				 * repoBuf.append(" bgcolor='"); repoBuf.append(Html.titleBGColor); repoBuf.append("' align=center>");
				 * //µǴ  Ǵ 
				 */
			} else if (itemTypeList[i] == MItem.INT) { // ϶
				repoBuf.append(form.substring(0, edTDIndex));
				repoBuf.append(" align=right>");

				if (tableType == MTable.DYNATOTLINE) {
					repoBuf.append("<font color='");
					repoBuf.append(Html.dynaTotLineFontColor);
					repoBuf.append("'>");
					repoBuf.append(changeNumber(dataList[dataIndex])); // µǴ  Ǵ 
					repoBuf.append("</font>");

				} else {
					repoBuf.append(changeNumber(dataList[dataIndex])); // µǴ  Ǵ 
				}
				dataIndex++;

			} else if (itemTypeList[i] == MItem.CHAR) { // ϶
				repoBuf.append(form.substring(0, edTDIndex));
				if (itemExprList != null && itemExprList[i] != null && itemExprList[i].matches(".+?\\^.+?"))
					repoBuf.append(" valign=top");
				repoBuf.append(" align=left>");
				repoBuf.append((dataList[dataIndex] == null || dataList[dataIndex].trim().equals("")) ? "&nbsp;"
						: dataList[dataIndex]); // µǴ  Ǵ 
				dataIndex++;

			} else if (itemTypeList[i] == MItem.DATE) { // ¥϶
				repoBuf.append(form.substring(0, edTDIndex));
				repoBuf.append(" align=left>");
				repoBuf.append((dataList[dataIndex] == null || dataList[dataIndex].trim().equals("")) ? "&nbsp;"
						: dataList[dataIndex]); // µǴ  Ǵ 
				dataIndex++;
			}

			form = form.substring(edTDIndex + 1, form.length());
		}

		repoBuf.append(form);
		return repoBuf.toString();
	}

	// ڷ excel̸ excel  ȴ.
	private static String excelReportMake(String form, String[] dataList, int[] itemNumList, String[] itemNameList,
			int[] itemBNWList, int[] itemTypeList, String[] itemExprList, int strInItemNum, int titleRowCount,
			int rowCount, int tableType) throws NullPointerException {
		if (form == null)
			return null;
		StringBuffer repoBuf = new StringBuffer();

		int stTDIndex;
		int edTDIndex;
		int dataIndex = 0;
		int itemAllCount = itemNumList.length - 1; // 0  index    -1 

		rowCount = 0;
		String tmpExp = "";
		for (int i = strInItemNum; i <= itemAllCount; i++)
        {
			if (dataIndex > itemAllCount) break; // dataList length  itemNameList length  .
			stTDIndex = form.indexOf("<td");
			if (stTDIndex < 0)	break;
			edTDIndex = form.indexOf(">", stTDIndex + 1);
			if (edTDIndex < 0) break;
			if (stTDIndex > form.indexOf("<table") && form.indexOf("<table") > -1) { rowCount = 0; tmpExp = "";	}
			if (tmpExp.equals("") && !(itemExprList[i].equals(""))) tmpExp = itemExprList[i];
			else if ((itemExprList[i].trim()).equals(tmpExp) && !(tmpExp.equals(""))) rowCount++;
			if (itemBNWList[i] == 1) dataList[dataIndex] = HtmlUtil.toBR(dataList[dataIndex]); // <TextArea></TextArea>

			if (itemTypeList[i] == MItem.TITLE)
            { // ŸƲ϶
				repoBuf.append(form.substring(0, edTDIndex));
				repoBuf.append(" bgcolor='");
				repoBuf.append(Html.titleBGColor);
				repoBuf.append("' align=center>"); // µǴ  Ǵ 
			} 
            else if (itemTypeList[i] == MItem.INT)
            { // ϶
				repoBuf.append(form.substring(0, edTDIndex));
				if (tableType == MTable.DYNATOTLINE)
                { // ڷ  ǥ  ,     
					repoBuf.append(CalculationForm.getCalculationForm(itemExprList[i], rowCount, "add"));
					repoBuf.append(" align=right>");
					repoBuf.append("<font color='" + Html.dynaTotLineFontColor + "'>");
					repoBuf.append(changeNumber(dataList[dataIndex])); // µǴ  Ǵ 
					repoBuf.append("</font>");
				} 
                else if (tableType == MTable.DYNA)
                { // ߰ ǾǷ   
					repoBuf.append(CalculationForm.getCalculationForm(itemExprList[i], rowCount, "add"));
					repoBuf.append(" align=right>");
					repoBuf.append(changeNumber(dataList[dataIndex])); // µǴ  Ǵ 

				} 
                else
                { // ǥ
					repoBuf.append(" align=right>");
					repoBuf.append(changeNumber(dataList[dataIndex])); // µǴ  Ǵ 
				}
				dataIndex++;
			} 
            else
            { // ϶, //¥϶
				repoBuf.append(form.substring(0, edTDIndex));
				if (itemExprList != null && itemExprList[i] != null && itemExprList[i].matches(".+?\\^.+?")) repoBuf.append(" valign=top");
				repoBuf.append(" align=left>");
				repoBuf.append((dataList[dataIndex] == null || dataList[dataIndex].trim().equals("")) ? "&nbsp;" : dataList[dataIndex]); // µǴ  Ǵ 
				dataIndex++;
			}
			form = form.substring(edTDIndex + 1, form.length());
		}
		repoBuf.append(form);
		
                // 2014.08.21 Youngjun Cho
                //  ҽ
                //  ȿ ʿ ±׷  η    ߻Ѵ.
                //return (repoBuf.toString()).replaceAll("&nbsp;", "");
                
                //<?xml:namespace ±׸ Žִ  ߰
                String repoHTML = TagFilter.removeXmlNamepace(repoBuf.toString());
                
                //  &nbsp; 
                repoHTML = repoHTML.replaceAll("&nbsp;", "");
                
                //return (repoBuf.toString()).replace("<p style=\"mso-pagination: none; mso-padding-alt: 0.0pt 0.0pt 0.0pt 0.0pt\" class=0>&nbsp; <?xml:namespace prefix = o ns = \"urn:schemas-microsoft-com:office:office\" /><o:p></o:p></p>", "<font> </font>").replaceAll("&nbsp;", "");\
                //return (repoBuf.toString()).replace("<?xml:namespace prefix = o ns = \"urn:schemas-microsoft-com:office:office\" /><o:p></o:p>", "<font> </font>").replaceAll("&nbsp;", "");
                return repoHTML;
	}

	private static String changeNumber(String data) {
		try {
if(data==null || data.equals("")) return "0";
			/* ڸ ǥϴ ڿ ޸  */
			String tmpStr = "";
			String[] strList = data.split(",");

			for (int i = 0; i < strList.length; i++) {
				tmpStr += strList[i];
			}
			data = tmpStr;

			data = NumberFormat.getNumberInstance().format(Double.parseDouble(data.trim()));
		} catch (NumberFormatException ex) {
			System.err.println("numberformat exception data: " + data);
			data = "0";
		} catch (NullPointerException ex) {
			data = " ";
		}
		return data;
	}
}
