-- Step 1. Sync
CREATE TABLE CMCDBMGR.MOUMI_ACPT_LIMIT_STRATEGY (
  ID	BIGINT	NOT NULL,
  SUBMIT_LIMIT_CNT	BIGINT,
  PRSS	INTEGER	NOT NULL,
  ACPT_TYPE	VARCHAR(50)	NOT NULL
  ) ;

COMMENT ON TABLE CMCDBMGR.MOUMI_ACPT_LIMIT_STRATEGY IS '종료방법';

COMMENT ON CMCDBMGR.MOUMI_ACPT_LIMIT_STRATEGY ( 
	ID IS '종료방법 ID',
	SUBMIT_LIMIT_CNT IS '제출부서 카운트',
	PRSS IS '진행상태',
	ACPT_TYPE IS '종료방법' );

GRANT ALTER ON TABLE CMCDBMGR.MOUMI_ACPT_LIMIT_STRATEGY TO USER CMCDBMGR;

-- Step 2. Restoring constraints and indexes
ALTER TABLE CMCDBMGR.MOUMI_ACPT_LIMIT_STRATEGY
  ADD CONSTRAINT MOUMI_ACPT_CHY8_PK PRIMARY KEY
    (ID)
    ENFORCED;

COMMIT;


