package kr.co.kihyun.beans.batch;
import java.io.PrintWriter;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Calendar;
import java.util.Date;

import kr.co.kihyun.db.DBManagerCmcp;

public class GroupConinfoUpConsol  extends DBManagerCmcp {
    
    private ResultSet rs = null;    
    private int count = 0;
    PreparedStatement pstmt = null;
    Statement stmt = null;
    PrintWriter out=null;

    public void updateMoumiDept() {

        StringBuilder sql = new StringBuilder(250);

        Calendar oCalendar = Calendar.getInstance( );  //  ¥/ð    
        Integer yyCompare = oCalendar.get(Calendar.YEAR);
        Integer monCompare = (oCalendar.get(Calendar.MONTH) + 1);
        Integer dayCompare = oCalendar.get(Calendar.DAY_OF_MONTH);
        Integer hourCompare = oCalendar.get(Calendar.HOUR_OF_DAY);
        String dateCompare = Integer.toString(yyCompare)+"-"+Integer.toString(monCompare)+"-"+Integer.toString(dayCompare)+" "+"01:00:00";//2012-07-01 01:00:00

        try {
            //out = res.getWriter();
            sql.append("MERGE INTO MOUMI_DEPT A                                                                                                       \n");
            sql.append("USING (                                                                                                                       \n");
            sql.append("	SELECT TREE1.ORG_CODE AS ID                                                                                           \n");
            sql.append("		, TREE1.ATPT_OFCDC_ORG_CODE AS ROOT_DEPT                                                                      \n");
            sql.append("		, NULL AS HANDY_ID                                                                                            \n");
            sql.append("		, TREE1.KRA_ORG_NM AS NAME                                                                                    \n");
            sql.append("		, NULL AS ADDRESS                                                                                             \n");
            sql.append("		, DETAIL.ORG_TELNO AS PHONE                                                                                   \n");
            sql.append("		, TREE1.ORG_CODE AS PASSCODE                                                                                  \n");
            sql.append("		, NULL AS RECO_IMG                                                                                            \n");
            sql.append("		, 2 AS SYS_AUTH, TREE1.STDIL_SNO AS PRIORITY                                                                  \n");
            sql.append("		, CASE                                                                                                        \n");
            sql.append("			WHEN MASTER.ORG_CODE LIKE '%00000001' OR MASTER.ORG_CODE LIKE '%00000000' THEN NULL                   \n");
            sql.append("			ELSE TREE1.UPPER_ORG_CODE                                                                             \n");
            sql.append("		END AS UPPER_DEPT                                                                                             \n");
            
            /*ӱ(INSTT_CLSF_CODE='4')̰ μ ƴ  organڵ忡 ڽ μڵ带  */
            sql.append("                , CASE                                                                                                          \n");
            sql.append("                        WHEN MASTER.INSTT_CLSF_CODE = '4' AND MASTER.JU_ORG_INSTT_CLSF_CODE <> '4' THEN MASTER.ORG_CODE         \n");
            sql.append("                        ELSE TREE1.JU_ORG_CODE                                                                                  \n");
            sql.append("                END AS ORGAN                                                                                                    \n");
            sql.append("		, NULL AS SEC_ID                                                                                                \n");
            sql.append("		, CHAR(0) AS SEQNUM                                                                                             \n");
            sql.append("		, CASE WHEN MASTER.ORG_CODE IS NULL THEN CHAR('N') ELSE CHAR('Y') END AS SEL_TYPE                               \n");
            
            /* ̺ μ (ORG_UON) ('Y')̸ 'N' ̻('N')̸ 'Y'  */
            sql.append("		, CASE WHEN TREE1.ORG_UON = 'Y' AND (SCHOOL.ABSCH_YN != 'Y' OR SCHOOL.ABSCH_YN IS NULL) THEN 'N'                \n");
            sql.append("		  ELSE 'Y' END AS IS_OUT                                                                                        \n");
            sql.append("		, NULL AS LOCATION                                                                                              \n");
            sql.append("		, CASE WHEN MASTER.SCHUL_KND_SC_CODE >= '25' THEN 5 ELSE INTEGER(TRIM(MASTER.SCHUL_KND_SC_CODE)) END AS GRADE   \n");
            sql.append("		, INTEGER(TRIM(MASTER.FOND_SC_CODE)) AS FOUNDATION                                                              \n");
            sql.append("	FROM                                                                                                                    \n");
            sql.append("		TN_SYMOCMOM001 TREE1 LEFT JOIN TC_SYMOCMOC000 MASTER ON MASTER.ORG_CODE = TREE1.ORG_CODE,                       \n");
            sql.append("		TN_SYMOCMOM001 TREE2 LEFT JOIN TN_SYMOCMOC001 DETAIL ON DETAIL.ORG_CODE = TREE2.ORG_CODE,                       \n");
            sql.append("		TN_SYMOCMOM001 TREE3 LEFT JOIN TN_SYMOCMSI001 SCHOOL ON SCHOOL.ORG_CODE = TREE3.ORG_CODE                        \n");
            sql.append("	WHERE                                                                                                                   \n");
            sql.append("		TREE1.ORG_CODE = TREE2.ORG_CODE                                                                                 \n");
            sql.append("		AND TREE1.ORG_CODE = TREE3.ORG_CODE                                                                             \n");
            sql.append("		AND TREE1.ORG_BUSN_CODE = TREE2.ORG_BUSN_CODE                                                                   \n");
            sql.append("		AND TREE1.ORG_BUSN_CODE = TREE3.ORG_BUSN_CODE                                                                   \n");
            sql.append("		AND TREE1.ORG_UON = TREE2.ORG_UON                                                                               \n");
            sql.append("		AND TREE1.ORG_UON = TREE3.ORG_UON                                                                               \n");
            sql.append("		AND TREE1.APPLC_BEGIN_YMD = TREE2.APPLC_BEGIN_YMD                                                               \n");
            sql.append("		AND TREE1.APPLC_END_YMD = TREE2.APPLC_END_YMD                                                                   \n");
            sql.append("		AND TREE1.APPLC_BEGIN_YMD = TREE3.APPLC_BEGIN_YMD                                                               \n");
            sql.append("		AND TREE1.APPLC_END_YMD = TREE3.APPLC_END_YMD                                                                   \n");
            sql.append("		AND TREE1.ORG_BUSN_CODE = 'SYM00'                                                                               \n");
            //sql.append("		AND TREE1.ORG_UON = 'Y'                                                                                         \n");
            
            /*  ڵ忡 μ ı 쿡 ȸ */
            sql.append("		AND TREE1.ORG_SC_CODE IN (1,3)                                                                                  \n");
            sql.append("		AND TREE1.APPLC_BEGIN_YMD <= TO_CHAR(SYSDATE, 'YYYYMMDD')                                                       \n");
            sql.append("		AND TREE1.APPLC_END_YMD >= TO_CHAR(SYSDATE, 'YYYYMMDD')                                                         \n");
            sql.append(") B                                                                                                                             \n");
            sql.append("ON (A.ID = B.ID)                                                                                                                \n");
            sql.append("WHEN NOT MATCHED THEN                                                                                                           \n");
            sql.append("	INSERT (                                                                                                                \n");
            sql.append("		A.ID,                                                                                                         \n");
            sql.append("		A.ROOT_DEPT,                                                                                                  \n");
            sql.append("		A.HANDY_ID,                                                                                                   \n");
            sql.append("		A.NAME,                                                                                                       \n");
            sql.append("		A.ADDR,                                                                                                       \n");
            sql.append("		A.PHONE,                                                                                                      \n");
            sql.append("		A.PASSCODE,                                                                                                   \n");
            sql.append("		A.RECO_IMG,                                                                                                   \n");
            sql.append("		A.SYS_AUTH,                                                                                                   \n");
            sql.append("		A.PRIORITY,                                                                                                   \n");
            sql.append("		A.UPPER_DEPT,                                                                                                 \n");
            sql.append("		A.ORGAN,                                                                                                      \n");
            sql.append("		A.SEC_ID,                                                                                                     \n");
            sql.append("		A.SEQNUM,                                                                                                     \n");
            sql.append("		A.SEL_TYPE,                                                                                                   \n");
            sql.append("		A.IS_OUT,                                                                                                     \n");
            sql.append("		A.LOCATION,                                                                                                   \n");
            sql.append("		A.GRADE,                                                                                                      \n");
            sql.append("		A.FOUNDATION                                                                                                  \n");
            sql.append("	)                                                                                                                     \n");
            sql.append("	VALUES (                                                                                                              \n");
            sql.append("		B.ID,                                                                                                         \n");
            sql.append("		B.ROOT_DEPT,                                                                                                  \n");
            sql.append("		B.HANDY_ID,                                                                                                   \n");
            sql.append("		B.NAME,                                                                                                       \n");
            sql.append("		B.ADDRESS,                                                                                                    \n");
            sql.append("		B.PHONE,                                                                                                      \n");
            sql.append("		B.PASSCODE,                                                                                                   \n");
            sql.append("		B.RECO_IMG,                                                                                                   \n");
            sql.append("		B.SYS_AUTH,                                                                                                   \n");
            sql.append("		B.PRIORITY,                                                                                                   \n");
            sql.append("		B.UPPER_DEPT,                                                                                                 \n");
            sql.append("		B.ORGAN,                                                                                                      \n");
            sql.append("		B.SEC_ID,                                                                                                     \n");
            sql.append("		B.SEQNUM,                                                                                                     \n");
            sql.append("		B.SEL_TYPE,                                                                                                   \n");
            sql.append("		B.IS_OUT,                                                                                                     \n");
            sql.append("		B.LOCATION,                                                                                                   \n");
            sql.append("		B.GRADE,                                                                                                      \n");
            sql.append("		B.FOUNDATION                                                                                                  \n");
            sql.append(")                                                                                                                     \n");
            sql.append("WHEN MATCHED THEN UPDATE SET                                                                                          \n");
            sql.append("A.ID          = B.ID,                                                                                                 \n");
            sql.append("A.ROOT_DEPT   = B.ROOT_DEPT,                                                                                          \n");
            sql.append("A.HANDY_ID    = B.HANDY_ID,                                                                                           \n");
            sql.append("A.NAME        = B.NAME,                                                                                               \n");
            sql.append("A.ADDR        = B.ADDRESS,                                                                                            \n");
            sql.append("A.PHONE       = B.PHONE,                                                                                              \n");
            sql.append("A.PASSCODE    = B.PASSCODE,                                                                                           \n");
            sql.append("A.RECO_IMG    = B.RECO_IMG,                                                                                           \n");
            sql.append("A.SYS_AUTH    = B.SYS_AUTH,                                                                                           \n");
            sql.append("A.PRIORITY    = B.PRIORITY,                                                                                           \n");
            sql.append("A.UPPER_DEPT  = B.UPPER_DEPT,                                                                                         \n");
            sql.append("A.ORGAN       = B.ORGAN,                                                                                              \n");
            sql.append("A.SEC_ID      = B.SEC_ID,                                                                                             \n");
            sql.append("A.SEQNUM      = B.SEQNUM,                                                                                             \n");
            sql.append("A.SEL_TYPE    = B.SEL_TYPE,                                                                                           \n");
            sql.append("A.IS_OUT      = B.IS_OUT,                                                                                             \n");
            sql.append("A.LOCATION    = B.LOCATION,                                                                                           \n");
            sql.append("A.GRADE       = B.GRADE,                                                                                              \n");
            sql.append("A.FOUNDATION  = B.FOUNDATION                                                                                          \n");
            
            //rs = execQuery(sql);
            
            //System.out.print("::::updateMoumiDept::::\n"+sql.toString());
            int iSuccessCount = execUpdate(sql.toString());

            System.out.println("::::updateMoumiDept::::");
            System.out.println("::::execute date : " + new Date());
            System.out.println("::::success count : " + iSuccessCount);
            
            return;
	
        } catch (SQLException sqlEx) {		
            throw new RuntimeException(sqlEx);
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        } finally {
            //close(rs);
            //execClose();
            try {
                if(rs!=null) {rs.close();}
                if(stmt!=null) {stmt.close();}
                if(con!=null) {con.close();}
            } catch (Exception e) {  
                //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                e.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
            }
        }
    }


    public void updateMoumiMuser() {
        StringBuilder sql = new StringBuilder(250);

        Calendar oCalendar = Calendar.getInstance( );  //  ¥/ð    
        Integer yyCompare = oCalendar.get(Calendar.YEAR);
        Integer monCompare = (oCalendar.get(Calendar.MONTH) + 1);
        Integer dayCompare = oCalendar.get(Calendar.DAY_OF_MONTH);
        Integer hourCompare = oCalendar.get(Calendar.HOUR_OF_DAY);
        String dateCompare = Integer.toString(yyCompare)+"-"+Integer.toString(monCompare)+"-"+Integer.toString(dayCompare)+" "+"01:00:00";//2012-07-01 01:00:00
        
        try {
            sql.append("MERGE INTO MOUMI_MUSER A USING (                                                                                           \n");
            sql.append("    SELECT                                                                                                                 \n");
            sql.append("    US.USRID AS ID                                                                                                         \n");
            sql.append("    , VARCHAR('1') AS PASSWD                                                                                               \n");
            sql.append("    , US.USER_NM_ENCPT AS NAME                                                                                             \n");
            sql.append("    , NULL AS SL_NO_1                                                                                                      \n");
            sql.append("    , NULL AS SL_NO_2                                                                                                      \n");
            sql.append("    , US.EMAIL_ADRES AS EMAIL                                                                                              \n");
            sql.append("    , US.OFFM_TELNO AS PHONE                                                                                               \n");
            sql.append("    , NULL AS CELL_PHONE                                                                                                   \n");
            sql.append("    , CASE WHEN US.ALL_MASTR_YN = 'Y' OR US.MNGR_YN = 'Y' THEN 9  WHEN USER_SC_CODE=6 THEN 7 ELSE 2 END AS SYS_AUTH        \n");
            sql.append("    , CASE WHEN US.USE_POSBL_YN = 'Y' THEN CHAR('N') ELSE CHAR('Y') END AS DEL_TYPE                                        \n");
            sql.append("    , DT.ORG_CODE AS DEPT_ID                                                                                               \n");
            sql.append("    , 0 AS PRIORITY                                                                                                        \n");
            sql.append("    , NULL AS DUTY_NAME                                                                                                    \n");
            sql.append("    , NULL AS GW_ID                                                                                                        \n");
            sql.append("    , TIMESTAMP('1970-01-01') AS DEL_DATE                                                                                  \n");
            sql.append("    , US.P_NO AS EMP_CODE                                                                                                  \n");
            sql.append("    , NULL AS ROLES                                                                                                        \n");
            sql.append("    , 'N' AS MOD_YN                                                              \n");  /*λ̵  default N  */
            sql.append("   FROM                                                                                                                    \n");
            sql.append("     TN_SYMUSMUM001 US                                                                                                     \n");
            sql.append("   , TN_SYMOCMOC001 DT                                                                                                     \n");
            sql.append("   WHERE                                                                                                                   \n");
            sql.append("     US.PSITN_ORG_CODE = DT.ORG_CODE                                                                                       \n");
            sql.append("     ) B                                                                                                                   \n");
            sql.append("     ON (A.ID = B.ID )    WHEN NOT MATCHED THEN                                                                            \n");
            sql.append("     INSERT (                                                                                                              \n");
            sql.append("     A.ID                                                                                                                  \n");
            sql.append("     , A.PASSWD                                                                                                            \n");
            sql.append("     , A.NAME                                                                                                              \n");
            sql.append("     , A.SL_NO_1                                                                                                           \n");
            sql.append("     , A.SL_NO_2                                                                                                           \n");
            sql.append("     , A.EMAIL                                                                                                             \n");
            sql.append("     , A.PHONE                                                                                                             \n");
            sql.append("     , A.CELL_PHONE                                                                                                        \n");
            sql.append("     , A.SYS_AUTH                                                                                                          \n");
            sql.append("     , A.DEL_TYPE                                                                                                          \n");
            sql.append("     , A.DEPT_ID                                                                                                           \n");
            sql.append("     , A.PRIORITY                                                                                                          \n");
            sql.append("     , A.DUTY_NAME                                                                                                         \n");
            sql.append("     , A.GW_ID                                                                                                             \n");
            sql.append("     , A.DEL_DATE                                                                                                          \n");
            sql.append("     , A.EMP_CODE                                                                                                          \n");
            sql.append("     , A.ROLES                                                                                                             \n");
            sql.append("     , A.MOD_YN                                                                                                            \n");
            sql.append("     )                                                                                                                     \n");
            sql.append("    VALUES     (                                                                                                           \n");
            sql.append("    B.ID                                                                                                                   \n");
            sql.append("    , B.PASSWD                                                                                                             \n");
            sql.append("    , B.NAME                                                                                                               \n");
            sql.append("    , B.SL_NO_1                                                                                                            \n");
            sql.append("    , B.SL_NO_2                                                                                                            \n");
            sql.append("    , B.EMAIL                                                                                                              \n");
            sql.append("    , B.PHONE                                                                                                              \n");
            sql.append("    , B.CELL_PHONE                                                                                                         \n");
            sql.append("    , B.SYS_AUTH                                                                                                           \n");
            sql.append("    , B.DEL_TYPE                                                                                                           \n");
            sql.append("    , B.DEPT_ID                                                                                                            \n");
            sql.append("    , B.PRIORITY                                                                                                           \n");
            sql.append("    , B.DUTY_NAME                                                                                                          \n");
            sql.append("    , B.GW_ID                                                                                                              \n");
            sql.append("    , B.DEL_DATE                                                                                                           \n");
            sql.append("    , B.EMP_CODE                                                                                                           \n");
            sql.append("    , B.ROLES                                                                                                              \n");
            sql.append("    , B.MOD_YN                                                                                                             \n");
            sql.append("    )                                                                                                                      \n");
            sql.append("    WHEN MATCHED AND A.DEPT_ID=B.DEPT_ID THEN                                                                              \n");
            sql.append("    UPDATE SET                                                                                                             \n");
            sql.append("            A.ID         = B.ID                                                                                            \n");
            sql.append("    ,       A.PASSWD     = B.PASSWD                                                                                        \n");
            sql.append("    ,       A.NAME       = B.NAME                                                                                          \n");
            sql.append("    ,       A.SL_NO_1    = B.SL_NO_1                                                                                       \n");
            sql.append("    ,       A.SL_NO_2    = B.SL_NO_2                                                                                       \n");
            sql.append("    ,       A.CELL_PHONE = B.CELL_PHONE                                                                                    \n");
            sql.append("    ,       A.DEL_TYPE   = B.DEL_TYPE                                                                                      \n");
            sql.append("    ,       A.DEPT_ID    = B.DEPT_ID                                                                                       \n");
            sql.append("    ,       A.PRIORITY   = B.PRIORITY                                                                                      \n");
            sql.append("    ,       A.DUTY_NAME  = B.DUTY_NAME                                                                                     \n");
            sql.append("    ,       A.GW_ID      = B.GW_ID                                                                                         \n");
            sql.append("    ,       A.DEL_DATE   = B.DEL_DATE                                                                                      \n");
            sql.append("    ,       A.EMP_CODE   = B.EMP_CODE                                                                                      \n");
            sql.append("    ,       A.ROLES      = B.ROLES                                                                                         \n");

            /* ---------------------------------------------------------------------------------------------------------------- */
            /* | ӻ | λ̵ | Ӻμ  | A.DEPT_ID != NEISμ | A.ORIGN_DEPT_ID != NEISμ | 'AND'  | */
            /* ---------------------------------------------------------------------------------------------------------------- */
            /* |      X     |     X    |     ش      |         FALSE         |             TRUE            |    FALSE   | */
            /* |      X     |     O    |     ش      |         TRUE          |             TRUE            |    TRUE    | */
            /* |      O     |     X    |         X         |         FALSE         |             FALSE           |    FALSE   | */
            /* |      O     |     X    |         O         |         TRUE          |             FALSE           |    FALSE   | */
            /* |      O     |     O    |         X         |         TRUE          |             TRUE            |    TRUE    | */
            /* |      O     |     O    |         O         |         TRUE          |             TRUE            |    TRUE    | */
            /* ---------------------------------------------------------------------------------------------------------------- */
            sql.append("    WHEN MATCHED                                                                                                           \n");
            sql.append("        AND A.DEPT_ID != B.DEPT_ID                                                                                         \n");
            sql.append("        AND (A.ORIGN_DEPT_ID IS NULL OR A.ORIGN_DEPT_ID != B.DEPT_ID)                                                         \n");
            sql.append("    THEN                                                                                                                   \n");
            sql.append("    UPDATE SET                                                                                                             \n");
            sql.append("            A.ID         = B.ID                                                                                            \n");
            sql.append("    ,       A.PASSWD     = B.PASSWD                                                                                        \n");
            sql.append("    ,       A.SYS_AUTH   = B.SYS_AUTH                                  \n");    /*λ̵ ߻  ̽  update */
            sql.append("    ,       A.NAME       = B.NAME                                                                                          \n");
            sql.append("    ,       A.SL_NO_1    = B.SL_NO_1                                                                                       \n");
            sql.append("    ,       A.SL_NO_2    = B.SL_NO_2                                                                                       \n");
            sql.append("    ,       A.CELL_PHONE = B.CELL_PHONE                                                                                    \n");
            sql.append("    ,       A.DEL_TYPE   = B.DEL_TYPE                                                                                      \n");
            sql.append("    ,       A.DEPT_ID    = B.DEPT_ID                                                                                       \n");
            sql.append("    ,       A.PRIORITY   = B.PRIORITY                                                                                      \n");
            sql.append("    ,       A.DUTY_NAME  = B.DUTY_NAME                                                                                     \n");
            sql.append("    ,       A.GW_ID      = B.GW_ID                                                                                         \n");
            sql.append("    ,       A.DEL_DATE   = B.DEL_DATE                                                                                      \n");
            sql.append("    ,       A.EMP_CODE   = B.EMP_CODE                                                                                      \n");
            sql.append("    ,       A.ROLES      = B.ROLES                                                                                         \n");
            sql.append("    ,       A.MOD_YN     = 'Y'                                          \n");   /*λ̵ ߻  μ  Y update */ 
            sql.append("    ,       A.ORIGN_DEPT_ID = NULL                                \n");    /*λ̵ ߻  Ҽ μ NULL  update */
            
            //rs = execQuery(sql);
             
            //System.out.print("\n::::updateMoumiMuser::::\n"+sql.toString());
            int iSuccessCount = execUpdate(sql.toString());

            System.out.println("::::updateMoumiMuser::::");
            System.out.println("::::execute date : " + new Date());
            System.out.println("::::success count : " + iSuccessCount);

            return;

        } catch (SQLException sqlEx) {		
            throw new RuntimeException(sqlEx);
        } catch (Exception ex) {
            throw new RuntimeException(ex);
        } finally {
            //close(rs);
            //execClose();
            try {
                if(rs!=null) {rs.close();}
                if(stmt!=null) {stmt.close();}
                if(con!=null) {con.close();}
            } catch (Exception e) {  
                //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                e.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
            }
        }
    }
}
