/*************************************************************************************************
 * α׷ : HttpAssign.java α׷ :  ̰ û   ۼ : ۼ :  :
 **************************************************************************************************/

package kr.co.kihyun.beans.batch;

import java.io.IOException;
import java.io.PrintWriter;

import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.entity.util.MPersistenceManager;
import kr.co.kihyun.beans.entity.util.PMF;
import kr.co.kihyun.text.html.ServletUtil;

public class HttpUpdate extends HttpServlet {

    private static final long serialVersionUID = 1L;
    private static final Logger LOG = LoggerFactory.getLogger(HttpUpdate.class);
    String assignInfo = "";

    public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        
        //44.  ó(Ŭ)_CWE-754 : Update by YOUNGJUN,CHO
        Transaction tx = null;
        PrintWriter out = null;
        PersistenceManager pm = null;
        
        try {
            out = res.getWriter();
            pm = new MPersistenceManager(PMF.get().getPersistenceManager());
            tx = pm.currentTransaction();
            GroupConinfoUp et = new GroupConinfoUp();
            
            tx.begin();
            
            et.updateMoumiDept();
            et.updateMoumiMuser();
            
            tx.commit();
            
            out.println(ServletUtil.alert("Success Merge Update"));
            String connURL = "location='/totsys/login/top.jsp';";            
            out.println(ServletUtil.getJavaScript(connURL));
        } catch (IOException ioex) {
            out.println(ServletUtil.alert("Fail Meger Update"));
            out.println(ServletUtil.getJavaScript("history.back();"));
            ioex.printStackTrace();
        } catch (Exception ex) {
            out.println(ServletUtil.alert("Fail Meger Update"));
            out.println(ServletUtil.getJavaScript("history.back();"));
            ex.printStackTrace();
        } finally {
            if (tx.isActive())
                tx.rollback();
            pm.close();
        }
        //================================================
        
    }
}
