package kr.co.kihyun.beans.entity;

import kr.co.kihyun.moumi.MoumiConfig;

public enum Grade {

	NULL(""),                                                                                                                      //0.
	PRE(MoumiConfig.getMessageBundle().getString("moumi.message.grade.pre")),                                                      //1.ġ
	ELEMENTARY(MoumiConfig.getMessageBundle().getString("moumi.message.grade.elementary")),                                        //2.ʵб
	MIDDLE(MoumiConfig.getMessageBundle().getString("moumi.message.grade.middle")),                                                //3.б
	HIGH(MoumiConfig.getMessageBundle().getString("moumi.message.grade.high")),                                                    //4.б
	SPECIAL(MoumiConfig.getMessageBundle().getString("moumi.message.grade.special")),                                              //5.Ưб
	CIVIL(MoumiConfig.getMessageBundle().getString("moumi.message.grade.civil")),                                                  //6.б
	CIVIL_HIGH(MoumiConfig.getMessageBundle().getString("moumi.message.grade.civilHigh")),                                         //7.б
	CIVIL_TECHNICAL(MoumiConfig.getMessageBundle().getString("moumi.message.grade.civilTechnical")),                               //8.б
	ETC_MIDDLE(MoumiConfig.getMessageBundle().getString("moumi.message.grade.etcMiddle")),                                         //9.б()
	ETC_HIGH(MoumiConfig.getMessageBundle().getString("moumi.message.grade.etcHigh")),                                             //10.б()
	CORRESPONDENCE_HIGH(MoumiConfig.getMessageBundle().getString("moumi.message.grade.correspondenceHigh")),                       //11.Űб
	LIFELONG_MIDDLE_THREE_YEARS(MoumiConfig.getMessageBundle().getString("moumi.message.grade.lifelongMiddleThreeYears")),         //12.б()-36б
	LIFELONG_HIGH_THREE_YEAYRS(MoumiConfig.getMessageBundle().getString("moumi.message.grade.lifelongHighThreeYears")),            //13.б()-36б
	LIFELONG_ELEMENTARY_THREE_YEARS(MoumiConfig.getMessageBundle().getString("moumi.message.grade.lifelongElementaryThreeYears")), //14.б()-36б
	COMMUNAL_PRACTICE_CENTER(MoumiConfig.getMessageBundle().getString("moumi.message.grade.communalPracticeCenter")),              //15.ǽ
	LIFELONG_MIDDLE_TWO_YEARS(MoumiConfig.getMessageBundle().getString("moumi.message.grade.lifelongMiddleTwoYears")),             //16.б()-26б
	LIFELONG_HIGH_TWO_YEARS(MoumiConfig.getMessageBundle().getString("moumi.message.grade.lifelongHighTwoYears")),                 //17.б()-26б
	FOREIGN(MoumiConfig.getMessageBundle().getString("moumi.message.grade.foreign")),                                              //18.ܱб
	ETC_ELEMENTARY(MoumiConfig.getMessageBundle().getString("moumi.message.grade.etcElementary")),                                 //19.б()
	LIFELONG_ELEMENTARY_FOUR_YEARS(MoumiConfig.getMessageBundle().getString("moumi.message.grade.lifelongElementaryFourYears")),   //20.б()-412б
	UNIVERSITY(MoumiConfig.getMessageBundle().getString("moumi.message.grade.university"));                                        //21.б
	private final String name;

	private Grade(String gradeName) {
		this.name = gradeName;
	}

	@Override
	public String toString() {
		return this.name;
	}
}
