/**
 *
 */
package kr.co.kihyun.beans.entity;

import kr.co.kihyun.moumi.MoumiConfig;

/**
 * @author bhs
 *
 */
public enum TotReportProcess {
	          ACCEPT(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.acceptStatus")) //    0
            , REASSIGN(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.process.reassign")) //û 1
            , ASSIGN(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.process.assign")) // 2
            , RETURN(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.returnStatus")) //Է¿û 3
            , TEMP(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.tempStatus")) // 4
            , APPROVE(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.process.approve")) // 5
            , COMP(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.compStatus")) //Ϸ 6
            , END(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.process.end")) // 7
            , READ(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.process.read")) // 8
            , CANCEL(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.cancel")) // 9
            , ALL(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.allStatus")) //ü 10
            , SUBMIT(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.submit")) // 11
            , NOT(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.notStatus")) //ش 12
            , NOT_REPORT(MoumiConfig.getMessageBundle().getString("moumi.message.tot_report.not_reportStatus")) // 13
            , NOTE(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.recalInfo"))//ȸû 14
            , SORT_DATE("SORTDATE");

	private String name;

	private TotReportProcess(String name) {
		this.name = name;
	}

	@Override
	public String toString() {
		return name;
	}
}
