package kr.co.kihyun.beans.tosys.etc1;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.entity.SysAuth;
import kr.co.kihyun.db.DBManager;

public class TotsysEtc extends DBManager
{
	private static final Logger LOG=LoggerFactory.getLogger(TotsysEtc.class);
	private String sql="";
	private ResultSet rs=null;
	public int count=0;
	public String[] popupId=null;
    public int tCount=0;

    public int  getCount(){
          return tCount;
      }

    public String[]  getPopupId(){
          return popupId;
     }

	public void getPopupNotice()
 	{
		try
		{
            sql="SELECT ID FROM MOUMI_BOARD WHERE GROUP_ID='ID_SYSTEM_NOTICE' AND POPUP_YN='Y'";
			rs=execQuery(sql);
			if(rs!=null)
			{
				rs.last();
				count=rs.getRow();
				rs.beforeFirst();
			}
			else { count=0; return; }
			popupId=new String[count];
                        tCount     = count;
			for(int ii=0;rs.next();ii++){
                        popupId[ii]=rs.getString(1);
            }
                //System.out.println(sql);
		}
		catch (SQLException sqlEx)
		{
			LOG.error("\nSQLState-{}\nErr Code-{}\nmsg-{}\nsql-{}",
                new Object[] { sqlEx.getSQLState(),sqlEx.getErrorCode(),sqlEx.getMessage(),sql });
			throw new RuntimeException(sqlEx);
		}
		catch (Exception ex)
		{
			throw new RuntimeException(ex);
		}
		finally
		{
			close(rs);
			execClose();
		}
	}

    public int getDocCount(String id,String dept,SysAuth level)
    {
        int retCnt=0;
        try
        {
            if(level==SysAuth.SYSADM)
            {
                sql="SELECT COUNT(*) ";
                sql+="FROM MOUMI_TOT_DOC DC, MOUMI_ACPT_LIMIT_STRATEGY AC ";
                sql+="WHERE DC.del_type='0' AND DC.GROUP_ID=2 ";
                //sql+="AND (DC.USER_ID='"+id+"' OR (DC.DEPT_ID='"+dept+"' AND DC.ACC_AUTH=1) OR DC.ACC_AUTH=2) ";
                sql+="AND (DC.END_DATE IS NOT NULL AND DC.END_DATE > SYSDATE) ";
                sql+="and DC.START_DATE < SYSDATE " ;
                sql+="and DC.ACPT_LIMIT = AC.ID ";
                sql+="AND (AC.SUBMIT_LIMIT_CNT = 0 OR AC.SUBMIT_LIMIT_CNT > FN_SNDCNT(DC.ID)) ";
            }
            else if(level==SysAuth.SUB_SYSADM)
            {
                sql="SELECT COUNT(*) ";
                sql+="FROM MOUMI_TOT_DOC DC, MOUMI_ACPT_LIMIT_STRATEGY AC ";
                sql+="WHERE DC.del_type='0' AND DC.GROUP_ID=2 ";
                sql+="AND (DC.USER_ID='"+id+"' OR (DC.DEPT_ID='"+dept+"' AND DC.ACC_AUTH=1) OR DC.ACC_AUTH=2) ";
                sql+="AND (DC.END_DATE IS NOT NULL AND DC.END_DATE > SYSDATE) ";
                sql+="and DC.START_DATE < SYSDATE " ;
                sql+="and DC.ACPT_LIMIT = AC.ID ";
                sql+="AND (AC.SUBMIT_LIMIT_CNT = 0 OR AC.SUBMIT_LIMIT_CNT > FN_SNDCNT(DC.ID)) ";
            }
            else
            {
                sql="SELECT COUNT(*) ";
                sql+="FROM MOUMI_TOT_DOC DC, MOUMI_ACPT_LIMIT_STRATEGY AC, MOUMI_DEPT DT, MOUMI_DEPT GR ";
                sql+="WHERE DC.del_type='0' AND DC.GROUP_ID=2 ";
                sql+="AND DC.DEPT_ID = DT.ID AND DT.ORGAN = GR.ID ";
                sql+="AND (DC.USER_ID='"+id+"' OR (DC.DEPT_ID='"+dept+"' AND DC.ACC_AUTH=1) ";
                sql+="OR (GR.ID = (SELECT DT.ORGAN FROM MOUMI_DEPT DT WHERE DT.ID = '"+dept+"') AND DC.ACC_AUTH=2)) ";
                sql+="AND (DC.END_DATE IS NOT NULL AND DC.END_DATE > SYSDATE) ";
                sql+="and DC.START_DATE < SYSDATE " ;
                sql+="and DC.ACPT_LIMIT = AC.ID ";
                sql+="AND (AC.SUBMIT_LIMIT_CNT = 0 OR AC.SUBMIT_LIMIT_CNT > FN_SNDCNT(DC.ID)) ";
            }
            
            rs=execQuery(sql);
            //System.out.println("doc_conut :::::  " + sql);
            rs.next();
            return (retCnt=rs.getInt(1));
        }
            catch (SQLException sqlEx)
		{
			LOG.error("\nSQLState-{}\nErr Code-{}\nmsg-{}\nsql-{}",
            new Object[] { sqlEx.getSQLState(),sqlEx.getErrorCode(),sqlEx.getMessage(),sql });
			throw new RuntimeException(sqlEx);
		}
		catch (Exception ex) { throw new RuntimeException(ex);	}
		finally { close(rs); execClose(); return retCnt; }
    }

    public int getReportCount(String id, String dept)
    {
        int retCnt=0;
        try
        {
            sql="SELECT GRADE,ORGAN,UPPER_DEPT FROM MOUMI_DEPT WHERE ID='"+dept+"'";
            rs=execQuery(sql);
            rs.next();
            String grade=rs.getString(1);
            String organ=rs.getString(2);
            String upper=rs.getString(3);
            close(rs); rs=null; execClose();
            if(grade==null)
            {
                sql="SELECT COUNT(*) FROM MOUMI_TOT_REPORT RT, MOUMI_TOT_DOC DC, MOUMI_ACPT_LIMIT_STRATEGY AC WHERE RT.DOC_ID=DC.ID AND DC.del_type='0' ";
                sql+="AND RT.del_type='0' AND RT.DOC_TYPE=0 AND RT.PRSS IN (0,1,2,3) ";
                sql+="AND (DC.END_DATE IS NOT NULL AND DC.END_DATE > SYSDATE) ";
                sql+="AND DC.START_DATE < SYSDATE ";
                sql+="AND DC.ACPT_LIMIT = AC.ID ";
                sql+="AND (AC.SUBMIT_LIMIT_CNT = 0 OR AC.SUBMIT_LIMIT_CNT > FN_SNDCNT(DC.ID)) ";
                //sql+="AND (RT.DEPT_ID='"+dept+"' OR RT.DEPT_ID='"+organ+"' OR RT.DEPT_ID='"+upper+"') ";
                sql+="AND (((RT.DEPT_ID='"+dept+"' OR RT.DEPT_ID='"+organ+"' OR RT.DEPT_ID='"+upper+"') and rt.user_id is null) or (rt.user_id = ('"+id+"'))) ";
            }
            else if(grade!=null)
            {
                sql="SELECT COUNT(*) FROM MOUMI_TOT_REPORT RT, MOUMI_TOT_DOC DC, MOUMI_ACPT_LIMIT_STRATEGY AC WHERE RT.DOC_ID=DC.ID AND DC.del_type='0' ";
                sql+="AND RT.del_type='0' AND RT.DOC_TYPE=0 AND RT.PRSS IN (0,1,2,3) ";
                sql+="AND (DC.END_DATE IS NOT NULL AND DC.END_DATE>SYSDATE) ";
                sql+="AND DC.START_DATE < SYSDATE ";
                sql+="AND DC.ACPT_LIMIT = AC.ID ";
                sql+="AND (AC.SUBMIT_LIMIT_CNT = 0 OR AC.SUBMIT_LIMIT_CNT > FN_SNDCNT(DC.ID)) ";
                //sql+="AND RT.DEPT_ID='"+dept+"' ";
                sql+="AND ((rt.dept_id in ('"+dept+"') and rt.user_id is null) or (rt.user_id = ('"+id+"'))) ";
            }
            
            rs=execQuery(sql);
            rs.next();
            return (retCnt=rs.getInt(1));
        }
        catch (SQLException sqlEx)
		{
			LOG.error("\nSQLState-{}\nErr Code-{}\nmsg-{}\nsql-{}",
            new Object[] { sqlEx.getSQLState(),sqlEx.getErrorCode(),sqlEx.getMessage(),sql });
			throw new RuntimeException(sqlEx);
		}
		catch (Exception ex) { throw new RuntimeException(ex);	}
		finally { close(rs); execClose(); return retCnt; }
    }

    public String getRootName(String id)
    {
        String sql="";
        try
        {
            sql="select d1.id||'*'||d2.name||'-'||d1.name from moumi_dept d1,moumi_dept d2 ";
            sql+="where d1.id in ('"+id+"') and d2.id=d1.organ";
            rs=execQuery(sql);
            rs.next();
            return rs.getString(1);
        }
        catch (SQLException sqlEx)
		{
			LOG.error("\nSQLState-{}\nErr Code-{}\nmsg-{}\nsql-{}",
            new Object[] { sqlEx.getSQLState(),sqlEx.getErrorCode(),sqlEx.getMessage(),sql });
			throw new RuntimeException(sqlEx);
		}
		catch (Exception ex) { throw new RuntimeException(ex);	}
		finally { close(rs); execClose(); }
    }

    public String[] getGroupElement(String[] id)
 	{
        int ii=0,jj=0;
        boolean flag=false;
        if(id==null || id.length==0) return null;
        String tmp="";
        String[] tmpArray=new String[id.length];
        for(ii=0;ii<id.length;ii++)
        {
            if(id[ii]==null || id[ii].length()!=10) continue;
            if(id[ii].substring(2).equals("00000000")||id[ii].substring(2).equals("00000001"))
            {
                tmpArray[jj++]=getRootName(id[ii]);
                flag = true;
            }
            if(ii==0) tmp="'"+id[ii]+"'";
            else tmp+=",'"+id[ii]+"'";
        }
        ii=jj;      
		try
		{
            sql="select d1.id||'*'||d2.name||'-'||d3.name||'-'||d1.name from moumi_dept d1,moumi_dept d2,moumi_dept d3 ";
            sql+="where d1.id in ("+tmp+") and d2.id=d1.organ and d3.id=d1.upper_dept";
			rs=execQuery(sql);
			while(rs.next())
			{				
				tmpArray[ii++]=rs.getString(1);
			}
		}
		catch (SQLException sqlEx)
		{
			LOG.error("\nSQLState-{}\nErr Code-{}\nmsg-{}\nsql-{}",
            new Object[] { sqlEx.getSQLState(),sqlEx.getErrorCode(),sqlEx.getMessage(),sql });
			throw new RuntimeException(sqlEx);
		}
		catch (Exception ex) { throw new RuntimeException(ex);	}
		finally
		{
			close(rs);	execClose();
            return tmpArray;
		}
	}

    public static String[] getDeliToArr(String str, String deli)
    {
        String[] arr=null;
        if(str==null || deli==null || deli.length()==0) return null;
        String temp=str;
        int start=0; int cnt=0;
        while(temp.indexOf(deli)>=0)
        {
            String test=temp.substring(start,temp.indexOf(deli));
            temp=temp.substring(temp.indexOf(deli)+1,temp.length());
            cnt++;
        }

        arr=new String[cnt]; int ii = 0; temp=str; start=0;
        while(temp.indexOf(deli)>=0)
        {
            arr[ii]=temp.substring(start,temp.indexOf(deli));
            temp=temp.substring(temp.indexOf(deli)+deli.length(),temp.length());
            ii++;
        }
       return arr;
    }
}

