/**
 * *******************************************************************************************************
 * α׷ : HttpDocModifyer.java α׷ : Ʈ õ   ִ class ۼ : 
 * ۼ : 2003.12.10  : 2003.11.15
 *********************************************************************************************************
 */
package kr.co.kihyun.beans.totsys.doc;

import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.entity.AcceptanceLimitStrategy;
import kr.co.kihyun.beans.entity.AccessAuth;
import kr.co.kihyun.beans.entity.ExecutionCode;
import kr.co.kihyun.beans.entity.MDept;
import kr.co.kihyun.beans.entity.MUser;
import kr.co.kihyun.beans.entity.TotDoc;
import kr.co.kihyun.beans.entity.TotDocAppendType;
import kr.co.kihyun.beans.entity.TotDocProcess;
import kr.co.kihyun.beans.entity.util.MPersistenceManager;
import kr.co.kihyun.beans.entity.util.PMF;
import kr.co.kihyun.beans.user.HttpSSOLogin;
import kr.co.kihyun.io.FileUtil;
import kr.co.kihyun.lang.Encoder;
import kr.co.kihyun.lang.MInteger;
import kr.co.kihyun.lang.MLong;
import kr.co.kihyun.lang.MString;
import kr.co.kihyun.moumi.MoumiConfig;
import kr.co.kihyun.text.html.ServletUtil;

public class HttpDocModifyer extends HttpServlet {

    /**
     *
     *
     */
    private static final long serialVersionUID = 1L;
    private static final Logger LOG = LoggerFactory.getLogger(HttpDocModifyer.class);

    @Override
    public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        doPost(req, res);
    }

    @Override
    public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
        res.setContentType("text/html;charset=euc-kr");
        PrintWriter out = res.getWriter();
        HttpSession session = req.getSession(true);
        String usID = HttpSSOLogin.getLoginID(req);
        int sysAuth = HttpSSOLogin.getSysAuth(req);

        /**
         * ******** parameter value *********
         */
        Long docID = MLong.parseLong(req.getParameter("docID"), null);
        int execNum = MInteger.parseInt(req.getParameter("execNum"));
        String execDate = MString.checkNull(req.getParameter("execDate"));

        TotDocAppendType appendType = TotDocAppendType.valueOf(MString.checkNull(req.getParameter("appendType"), TotDocAppendType.COPY.toString())); // ÷, ,  

        int accAuth = MInteger.parseInt(req.getParameter("accAuth"), 0);
        String stDate = MString.checkNull(req.getParameter("stDate"));
        String stTime = req.getParameter("stTime");
        String edDate = MString.checkNull(req.getParameter("edDate"));
        String edTime = req.getParameter("edTime");
        String title = Encoder.toJava(req.getParameter("title"));
        String contents = Encoder.toJava(req.getParameter("notify"));
        String prss = MString.checkNull(req.getParameter("prss"), "PRSS");
      //String deptIDs = MString.checkNull(req.getParameter("deptIDs"));
        //LOG.debug("prss: {}", prss);
        //LOG.debug("contents: {}", contents);
        String svrFilenames = Encoder.toJava(req.getParameter("svrFilenames"));
        String redirectURI = req.getParameter("redirectURI");
        String setTheTime = Encoder.toJava(req.getParameter("setTheTime"));

        String acceptanceLimitStrategy = MString.checkNull(req.getParameter("acceptanceLimitStrategy"), "UnlimitStrategy");
        stDate = stDate + " " + stTime + ":00:00";
        edDate = edDate + " " + edTime + ":00:00";
        Date startDate, endDate;
        startDate = endDate = new Date();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            if (setTheTime.contains("") || setTheTime.contains("")) {
                startDate = new Date();
            } else {
                startDate = sdf.parse(stDate);
            }
            if (acceptanceLimitStrategy.equals("LimitBySubmitDateStrategy") || acceptanceLimitStrategy.equals("UnlimitStrategy")) {
                edDate = "9999-12-30 12:00:00";
            }
            endDate = sdf.parse(edDate);
      //startDate = sdf.parse(stDate);
            //endDate = sdf.parse(edDate);
        } catch (ParseException e) {
            e.printStackTrace();
        }

        kr.co.kihyun.beans.entity.Board mBoard = null;
        TotDoc totDoc = null;
        MUser mUser = null;

        if (!HttpSSOLogin.isLogin(req)) {
            String connURL = "location='/totsys/login/login.jsp';";
            out.println(ServletUtil.getJavaScript(connURL));
            return;
        }

        PersistenceManager pm = new MPersistenceManager(PMF.get().getPersistenceManager());
        Transaction tx = pm.currentTransaction();
//		ObjectManager om = ((JDOPersistenceManager) tx.getPersistenceManager()).getObjectManager(); // jeus 6 proplem
        try {
            tx.begin();
            TotDoc pc = pm.getObjectById(TotDoc.class, docID);
            totDoc = pm.detachCopy(pc);

//			totDoc = pm.getObjectById(TotDoc.class, docID);
            mUser = pm.getObjectById(MUser.class, usID);
            if (sysAuth == MoumiConfig.TOTPER && !usID.equals(pc.getUser(pm).getId())) {
                out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc")
                        + MoumiConfig.getMessageBundle().getString("moumi.message.popup.modifyFail")));
                out.println(ServletUtil.getJavaScript("document.location='/totsys/totper/mydocbox/prssbox/doc_modify.jsp?docID="
                        + docID + "';"));
                return;
            }

            SimpleDateFormat execDateFormat = new SimpleDateFormat("yyyy-MM-dd");
            ExecutionCode execCode = null;
            //ȣ Է ʿ信  ּ.
            //2014.09.01 LIM
            if (execNum > 0 && !MString.isNull(execDate)) {
                ExecutionCode curExecCode = pc.getExecutionCode();
                execCode = new ExecutionCode(curExecCode.getDeptName() == null ? pm.getObjectById(MDept.class, pc.getDept()).getName() : curExecCode.getDeptName(), execNum, execDateFormat.parse(execDate));
                pc.setExecutionCode(execCode);//ȣ Է
             }

          //pm.makePersistent(mBoard);
            pc.setStartDate(startDate);
            pc.setEndDate(endDate);
            pc.setRegDate(new Date());
            pc.setAppendType(appendType);
            pc.setAccessAuth(AccessAuth.values()[accAuth]);

            /* LJH
             AcceptanceLimitStrategy oldStrategy = pc.getAcceptanceLimitStrategy();
             LOG.debug("oldStrategy : {}", oldStrategy);
             if(acceptanceLimitStrategy.equals("LimitBySubmitDateStrategy"))
             oldStrategy.setLimitCount(MLong.parseLong(req.getParameter("submitLimit"), 10000L));
             oldStrategy.setProcess(TotDocProcess.valueOf(MString.checkNull(req.getParameter("prss"), pc.getProcess(pm).name())));
             */
            AcceptanceLimitStrategy acptLimitStrategy = AcceptanceLimitStrategy.create(acceptanceLimitStrategy, MLong.parseLong(req.getParameter("submitLimit"), 10000L));
            acptLimitStrategy.setProcess(TotDocProcess.valueOf(MString.checkNull(req.getParameter("prss"), pc.getProcess(pm).name())));
            pc.setAcceptanceLimitStrategy(acptLimitStrategy);

//		AcceptanceLimitStrategy acptLimitStrategy = AcceptanceLimitStrategy.create(
//		acceptanceLimitStrategy, MLong.parseLong(req.getParameter("submitLimit"), 10000L));
//      acptLimitStrategy.setProcess(
//	    TotDocProcess.valueOf(MString.checkNull(req.getParameter("prss"), pc.getProcess(pm).name())));
//		LOG.debug("acptLimitStrategy.getProcess(pm) : {}", acptLimitStrategy.getProcess(pm));
//		pc.setAcceptanceLimitStrategy(acptLimitStrategy); 
//      pc.setAcceptanceLimitStrategy(oldStrategy);
            FileUtil.putInFiles(svrFilenames, pc);

//			if (pc.getMasterTotReport() != null) {	// Can not execute this code until NEIS-49 be resolved.
//				TotReport masterReport = pc.getMasterTotReport();
//				if (masterReport.getProcess().ordinal() < TotReportProcess.COMP.ordinal())
//					masterReport.setProcess(TotReportProcess.TEMP);
//				pm.makePersistent(masterReport);
//				LOG.info("move master report '{}' into temp box", masterReport);
//			}
            mBoard = pc.getBoard();
            mBoard.setTitle(title);
            mBoard.setContents(contents);
            mBoard.setTotDoc(pc);
            pc.setName(title);
            pm.makePersistent(mBoard);
            pm.makePersistent(pc);

//			om.postCommit(); // jeus 6 problem
            tx.commit();

           // FileUtil.delUpFiles(svrFilenames,pc); //丮  
//			try {
//				tx.begin();
//				pm.deletePersistent(oldStrategy);
//				tx.commit();
//			} catch (Exception e) {
//				LOG.warn("Could not delete old AcceptanceLimitStrategy: {}. You may delete garbage strategies manually.", oldStrategy);
//			}
//			LOG.debug("prss {}, submit_limit_cnt {}, doc_id {}, acpt_type {}",
//					new Object[] {acptLimitStrategy.getProcess(pm), acptLimitStrategy.getLimitCount(), acptLimitStrategy.getTotDoc(), acptLimitStrategy});
//			LOG.debug("prss changed to {}", totDoc.getProcess(pm));
            LOG.info("{}{}{}: {}, {}, {}", new Object[]{
                MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.information"),
                MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.change"),
                MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.success"),
                usID, req.getRemoteAddr(), docID
            });
            out.println("<script> alert(\" ⺻  Ͽϴ.\")</script>");
			//LOG.debug("redirect URI: {}", redirectURI);
            //res.sendRedirect(redirectURI);
            
            
            //8.ŷڵ ʴ URL ּҷ ڵ  (getParameter)_CWE-601 : Update by KWON.HAN
            //res.sendRedirect("/totsys/totper/mydocbox/prssbox/doc_list.jsp?docType=" + prss);
                        
            // ٸ ̵ϴ URL Ʈ .
            String allowURL[] = { "/totsys/totper/mydocbox/prssbox/doc_list.jsp" };
            ArrayList arr = new ArrayList();
            for ( int i = 0; i < allowURL.length; i++ )
            arr.add(allowURL[i]);

            //String url = request.getParameter("url");
            String url = "/totsys/totper/mydocbox/prssbox/doc_list.jsp";
            if (url != null && !url.contains("http://") ) {
                url = url.replaceAll("\r", "").replaceAll("\n", "");

                if ( arr.contains(url) ) {
                   //v2. 1.HTTP  : Update by KWON,HAN        
//                   url += "?docType="+prss;
//                   res.sendRedirect(url);
                   
                    if (prss != null) {    
                        //  : ܺ Է° ͸
                        String filtered_prss = prss.replaceAll("\r","").replaceAll("\n","");      
                        //LOG.debug("v2 1.HTTP  : HttpDocModifyer.doPost() filtered_prss={} : Test OK ", filtered_prss);
                        url += "?docType="+filtered_prss;
			res.sendRedirect(url);
                    }                        
                    //========================================                    
                }
            }
            //=================================================================================
                        
        } catch (Exception e) {
            e.printStackTrace();
            LOG.error("{}{}{}: {}, {}, {}, {}", new Object[]{
                MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.information"),
                MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.change"),
                MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.fail"),
                e.getMessage(), usID, req.getRemoteAddr(), docID
            });
            out.println("<script> alert(\"⺻  Ͽϴ.\")</script>");
            //v2. 9.ũνƮ ũƮ (PrintWrier) : Update by KWON,HAN
//            out.println(ServletUtil.redirect((String) session.getAttribute("modifyFailTargetURI")));
            
            //  : ܺ Է° ͸
            String url = (String) session.getAttribute("modifyFailTargetURI");
            String filtered_url = url.replaceAll("<","").replaceAll(">","").replaceAll("&","").replaceAll(",","");
            LOG.debug("v2 9.ũνƮ ũƮ (PrintWrier) : HttpDocModifyer.doPost() filtered_url={}, Not Test", filtered_url);
            out.println(ServletUtil.getJavaScript(filtered_url));
            //============================================================
                            
            return;
        } finally {
            if (tx.isActive()) {
                tx.rollback();
            }
            pm.close();
        }
    }
}
