/***********************************************************************************
 * @@ Program Name : HttpReFormReader.java Description : 蹮  ǽ   ,  ,    и  Author : 
 *    Create Date : 2004.10.13 History :
 * @@
 ***********************************************************************************/

package kr.co.kihyun.beans.totsys.doc;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import kr.co.kihyun.io.MultipartRequest;
import kr.co.kihyun.moumi.MoumiConfig;
import kr.co.kihyun.text.html.CallbackHandler;

public class HttpReFormReader2 extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	String savePath = MoumiConfig.getTotPerTmp().getPath(); // ε  ӽ  
	MultipartRequest multi;

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

		response.setContentType("text/html;charset=euc-kr");
		PrintWriter out = response.getWriter();
		HttpSession session = request.getSession(true);

		try {
			multi = new MultipartRequest(request, savePath);

			String docID = multi.getParameter("docID");
			String docForm;
			String isAdmin = multi.getParameter("isAdmin");

			//  ܰ迡 óܰ  data  
			String action = "/totsys/totper/mydocbox/prssbox/doc_form_config2.jsp";
			if (isAdmin != null) {
				if (isAdmin.equals("admin")) {
					action = "/totsys/sysadm/prssbox/doc_form_config2.jsp";
				} else if (isAdmin.equals("form")) {
					action = "/totsys/totper/mydocbox/formbox/doc_reform_config2.jsp";
				}
			}

			// form 
			docForm = multi.getParameter("docFCM");
			docForm = docForm.replaceAll(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.inputWindow"),
					"<table width=700 border=0><tr><td width='100%'></td></tr></table>");
			docForm = CallbackHandler.getCutPreTag(docForm);
			session.setAttribute("docForm", docForm);

			StringBuffer strbuf = new StringBuffer();
			strbuf.append("<html>");
			strbuf.append("<body topmargin=0 leftmargin=0 onload=\"document.copyform.submit();\">\n");
			strbuf.append("<form name='copyform' method='POST' action='");
			strbuf.append(action);
			strbuf.append("'>\n");
			strbuf.append("		<input type=hidden name =\"docID\" value=\"");
			strbuf.append(docID);
			strbuf.append("\">\n");
			strbuf.append("</body>\n");
			strbuf.append("</html>");
			out.println(strbuf.toString());
			return;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO
                } catch (IOException ioex) {
                        ioex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
