/**********************************************************************************
 * α׷ : HttpFileDelete.java α׷ :    :    : ֽź :
 ***********************************************************************************/

package kr.co.kihyun.beans.totsys.report;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.lang.Encoder;
import kr.co.kihyun.moumi.MoumiConfig;
import kr.co.kihyun.text.html.ServletUtil;

public class HttpFileDelete extends HttpServlet {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
        private static final Logger LOG = LoggerFactory.getLogger(kr.co.kihyun.beans.totsys.board.HttpFileUpload.class);
        
	// DB 
	String sql;
	String writeDate;

	public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {

		res.setContentType("text/html");
		res.setContentType("text/html;charset=euc-kr");
		PrintWriter out = res.getWriter();

		String usrFilename = "";
		String svrFilename = "";
		String savePath = "";
		boolean isDel = false;

		try {
			svrFilename = req.getParameter("fileList");
			//   

			// savePath = Moumi.getRoot()+"/totsys/repoper/fileUpload/";
			savePath = MoumiConfig.getTotRoot().getPath() + System.getProperty("file.separator") + "repoper"
					+ System.getProperty("file.separator") + "fileUpload";

			String docID = req.getParameter("docID");
			String dpID = req.getParameter("deptID");

			if (svrFilename != null) {
				svrFilename = Encoder.toJava(svrFilename);

                                //3.丮  (getParameter)_CWE-22/23/36 : Add by KWON,HAN
                                //4.丮  (getProperty)_CWE-22/23/36
                                String chkFilename = "";
                                chkFilename = savePath + System.getProperty("file.separator") + svrFilename;
                                LOG.debug("chkFilename: {}", chkFilename); 
                                if(chkFilename.contains("..") || chkFilename. contains("/")) { // Ưڿ 
                                    LOG.debug("HttpFileDelete doPost ===");
                                    LOG.debug("3.丮  (getParameter)_CWE-22/23/36 : Not Test {}", chkFilename);
                                    LOG.debug("=========================");
                                    return;
                                }
                                //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                        
                                //v2. 4.   ڿ _CWE-22/23/36/99 : Update by KWON,HAN                                
//				File file = new File(savePath + System.getProperty("file.separator") + svrFilename);
//				// File file = new File(savePath+"/"+svrFilename);
//				isDel = file.delete();
                                
                                if (svrFilename != null && !"".equals(svrFilename)) {
                                    //  : ܺ Է° ͸
                                    svrFilename = svrFilename.replaceAll("/","");
                                    svrFilename = svrFilename.replaceAll("\\","");
                                    //svrFilename = svrFilename.replaceAll(".","");
                                    //svrFilename = svrFilename.replaceAll("&","");
                                    
                                    LOG.debug("v2. 4.   ڿ _CWE-22/23/36/99 : HttpFileDelete.doPost svrFilename={} / Not Test", svrFilename);
                                    File file = new File(savePath + System.getProperty("file.separator") + svrFilename);
                                    if (file != null) file.delete();
                                }
                                //================================================================
                                
			}

			if (isDel) {
                            //v2. 1.HTTP  : Update by KWON,HAN                            
//				res.sendRedirect("/totsys/repoper/mydocbox/tempbox/write_file_upload.jsp?execMode=del&svrFilename="
//						+ svrFilename + "&usrFilename=" + usrFilename + "&docID=" + docID + "&deptID=" + dpID);
                            if (svrFilename != null || usrFilename != null) {     
                                //  : ܺ Է° ͸
                                String filtered_svrFilename = svrFilename.replaceAll("\r","").replaceAll("\n","");
                                String filtered_usrFilename = usrFilename.replaceAll("\r","").replaceAll("\n","");      
                                LOG.debug("v2 1.HTTP  : HttpFileDelete.doPost() isDel=true filtered_svrFilename={} Not Test", filtered_svrFilename);
                                LOG.debug("v2 1.HTTP  : HttpFileDelete.doPost() isDel=true filtered_usrFilename={} Not Test", filtered_usrFilename);
				res.sendRedirect("/totsys/repoper/mydocbox/tempbox/write_file_upload.jsp?execMode=del&svrFilename="
						+ filtered_svrFilename + "&usrFilename=" + filtered_usrFilename + "&docID=" + docID + "&deptID=" + dpID);
                            }
                            //========================================                                    
				return;
			} else {
				out.println(ServletUtil.alert("  ...! ٽ õϿ ּ."));
                                
                            //v2. 1.HTTP  : Update by KWON,HAN                                    
//				res.sendRedirect("/totsys/repoper/mydocbox/tempbox/write_file_upload.jsp?execMode=del&svrFilename="
//						+ svrFilename + "&usrFilename=" + usrFilename + "&docID=" + docID + "&deptID=" + dpID);
                            if (svrFilename != null || usrFilename != null) {     
                                //  : ܺ Է° ͸
                                String filtered_svrFilename = svrFilename.replaceAll("\r","").replaceAll("\n","");
                                String filtered_usrFilename = usrFilename.replaceAll("\r","").replaceAll("\n","");      
                                LOG.debug("v2 1.HTTP  : HttpFileDelete.doPost() isDel=true filtered_svrFilename={} Not Test", filtered_svrFilename);
                                LOG.debug("v2 1.HTTP  : HttpFileDelete.doPost() isDel=true filtered_usrFilename={} Not Test", filtered_usrFilename);
				res.sendRedirect("/totsys/repoper/mydocbox/tempbox/write_file_upload.jsp?execMode=del&svrFilename="
						+ svrFilename + "&usrFilename=" + usrFilename + "&docID=" + docID + "&deptID=" + dpID);
                            }
                            //========================================                                 
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

}