/**********************************************************************************
 * α׷ : HttpFileUpload.java α׷ :    :    : ֽź :
 ***********************************************************************************/

package kr.co.kihyun.beans.totsys.report;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URLEncoder;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItem;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.io.MultipartRequest;
import kr.co.kihyun.moumi.MoumiConfig;
import kr.co.kihyun.text.html.ServletUtil;

public class HttpFileUpload extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
        private static final Logger LOG = LoggerFactory.getLogger(HttpFileUpload.class);        
	MultipartRequest multi = null;

	String sql = "";
	String writeDate = "";

	final int maxSize = 10 * (1024 * 1024);

	public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {

		res.setContentType("text/html;charset=euc-kr");
		PrintWriter out = res.getWriter();

		String svrFilename = "";
		String usrFilename = "";
		// String savePath = Moumi.getRoot()+"/totsys/repoper/fileUpload/";
		String savePath = MoumiConfig.getTotRoot().getPath() + System.getProperty("file.separator") + "repoper"
				+ System.getProperty("file.separator") + "fileUpload";
		String connURL = "";
		int succNum = -1;

		try {
			multi = new MultipartRequest(req, savePath);
			usrFilename = multi.getParameter("appendFile");
                        
                        //7.   ε(MultipartRequest)_CWE-434 : Add by KWON,HAN
                        int extIndex = 0 ;
                        extIndex = usrFilename.lastIndexOf('.');
                        if(extIndex < 0 ) {
                            LOG.debug("7.   ε(MultipartRequest)_CWE-434 : Not Test / usrFilename: {}", usrFilename);
                            out.print("<script language='javascript'>alert('Ȯڰ  Դϴ.');</script>");   
                            return;
                        } 
                        String file_ext = usrFilename.substring(usrFilename.lastIndexOf('.') + 1); 
                        if( file_ext.equalsIgnoreCase("exe") || file_ext.equalsIgnoreCase("bat") || file_ext.equalsIgnoreCase("sh") ) { 
                            LOG.debug("7.   ε(MultipartRequest)_CWE-434 : Not Test / usrFilename: {}", usrFilename);
                            out.print("<script language='javascript'>alert('Ȯڰ [exe, bat, sh] ε尡 ѵ Դϴ.');</script>");   
                            return;
                        }  
                        //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++                        

                        String docID = multi.getParameter("docID");
                        String dpID = multi.getParameter("deptID");

                        FileItem upFile = multi.getFileItem("appendFile");

                        svrFilename = docID + "_" + dpID + "_" + usrFilename;

                        //3.丮  (getParameter)_CWE-22/23/36 : Add by KWON,HAN
                        //4.丮  (getProperty)_CWE-22/23/36
                        String chkFilename = "";
                        chkFilename = savePath + System.getProperty("file.separator") + svrFilename;
                        LOG.debug("chkFilename: {}", chkFilename); 
                        if(chkFilename.contains("..") || chkFilename. contains("/")) { // Ưڿ 
                            LOG.debug("HttpFileUpload doPost ===");
                            LOG.debug("3.丮  (getParameter)_CWE-22/23/36 : Not Test {}", chkFilename);
                            LOG.debug("=========================");
                            return;
                        }
                        //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                
                        // succNum = upFile.saveAs(savePath+"/"+svrFilename);
                        upFile.write(new File(savePath + System.getProperty("file.separator") + svrFilename));

                        svrFilename = URLEncoder.encode(svrFilename, "UTF-8");
                        usrFilename = URLEncoder.encode(usrFilename, "UTF-8");

                        if (succNum == 1) {
                                res.sendRedirect("/totsys/repoper/mydocbox/tempbox/write_file_upload.jsp?execMode=up&svrFilename="
                                                + svrFilename + "&usrFilename=" + usrFilename + "&docID=" + docID + "&deptID=" + dpID);
                                return;
                        } else if (succNum == 2) {
                                out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.popup.fileNameCh")));
                        } else if (succNum == -1) {
                                out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.popup.incorrectFileName")));
                        }

                        connURL = "location='/totsys/repoper/mydocbox/tempbox/write_file_upload.jsp?execMode=jump&svrFilename="
                                        + svrFilename + "&usrFilename=" + usrFilename + "&docID=" + docID + "&deptID=" + dpID + "';";
                        
                        //v2. 9.ũνƮ ũƮ (PrintWrier) : Update by KWON,HAN 
//                        out.println(ServletUtil.getJavaScript(connURL));
                        
                        //  : ܺ Է° ͸
                        String filtered_connURL = connURL.replaceAll("<","").replaceAll(">","").replaceAll(",","");
                        LOG.debug("v2 9.ũνƮ ũƮ (PrintWrier) : HttpFileUpload.doPost() try filtered_connURL={}, Not Test", filtered_connURL);
                        out.println(ServletUtil.getJavaScript(filtered_connURL));
                        //========================================                          
                        
		} catch (IOException ex) {
                        //v2. 9.ũνƮ ũƮ (PrintWrier) : Update by KWON,HAN  
//			out.println(ServletUtil.getJavaScript(connURL));
                        
                        //  : ܺ Է° ͸
                        String filtered_connURL = connURL.replaceAll("<","").replaceAll(">","").replaceAll("&","").replaceAll(",","");
                        LOG.debug("v2 9.ũνƮ ũƮ (PrintWrier) : HttpFileUpload.doPost() catch filtered_connURL={}, Not Test", filtered_connURL);
                        out.println(ServletUtil.getJavaScript(filtered_connURL));
                        //========================================  
                        
			ex.printStackTrace();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
