/***********************************************************************************
 * @@ Program Name : HttpDeptList.java Description :  μ  Author :  Create Date : 2003-12-16 History :
 * @@
 ***********************************************************************************/

package kr.co.kihyun.beans.user;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;
import java.util.logging.Level;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.lang.Encoder;
import kr.co.kihyun.lang.MLong;
import kr.co.kihyun.lang.MString;

public class HttpApproveSet extends HttpServlet {

	private static final long serialVersionUID = 1L;
	private static final Logger LOG = LoggerFactory.getLogger(HttpApproveSet.class);

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException,NumberFormatException {
		doPost(req, res);
		return;
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException,NumberFormatException {
		res.setContentType("text/html;charset=euc-kr");
		PrintWriter out = res.getWriter();

        Long reportID = MLong.parseLong(req.getParameter("reportID"));
        String reportType = MString.checkNull(req.getParameter("reportType"));
		String idList = Encoder.toJava(req.getParameter("deptIDs"));
		String typeList = Encoder.toJava(req.getParameter("deptTypes"));
        String docReportID = Encoder.toJava(req.getParameter("docReportID"));
        LOG.debug("idList: {}", idList);
        try {
      
            HttpApproveInsert dm = new HttpApproveInsert(reportID,reportType,idList, typeList, docReportID,req,res);
            
            
        } catch (SQLException ex) {
            java.util.logging.Logger.getLogger(HttpApproveSet.class.getName()).log(Level.SEVERE, null, ex);
        }finally
        {
          
        }
	}

}
