package kr.co.kihyun.beans.user;

//import kr.co.kihyun.tree.*;
//import java.sql.ResultSet;
//import java.io.IOException;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.SQLException;

//import javax.servlet.ServletException;
//import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.db.DBManager;
import kr.co.kihyun.lang.MString;
//import kr.co.kihyun.lang.Encoder;
//import kr.co.kihyun.lang.MInteger;
//import kr.co.kihyun.lang.MLong;
import kr.co.kihyun.moumi.MoumiConfig;
//import kr.co.kihyun.beans.user.HttpSSOLogin;
import kr.co.kihyun.text.html.ServletUtil;

public class UserModify extends DBManager {
    private static final Logger LOG = LoggerFactory.getLogger(HttpUserShareList.class);
    
    public UserModify(HttpServletRequest req,HttpServletResponse res) {
        
        String userId=null;
        PrintWriter out=null;
        String phone=null;
        String email=null;
        String sysAuth=null;
        String rdDualPostYn=null;    //2014.08.19 Add by KWON,HAN

        try {
            res.setContentType("text/html;charset=euc-kr");
            out = res.getWriter();
            if(!HttpSSOLogin.isLogin(req)) {
                String connURL = "location='/totsys/login/login.jsp';";
                out.println(ServletUtil.getJavaScript(connURL));
                return;
            }
            userId=MString.checkNull(req.getParameter("userID"),null);			
            phone=MString.checkNull(req.getParameter("phone"),"null");
            email=MString.checkNull(req.getParameter("email"),"null");
            sysAuth=MString.checkNull(req.getParameter("findOption"),"null");
            //String sysAuth=MString.checkNull(req.getParameter("sysAuth"),"null"); //UI  ޾ƿð
            rdDualPostYn=MString.checkNull(req.getParameter("rdDualPostYn"),null);              //2014.08.19 Add by KWON,HAN

            if(userId.equals("null")) userId=null;
            if(phone.equals("null")) phone=null;

//                  System.out.println("phone::"+phone);
//                  System.out.println("email::"+email);
//                  System.out.println("sysAuth::"+sysAuth);    
//                  System.out.println("rdDualPostYn::"+rdDualPostYn);                            
//                  System.out.println("userId::"+userId);

            //String sql="UPDATE MOUMI_MUSER SET PHONE=?,EMAIL=? WHERE ID=?";
//2014.08.19 Update by KWON,HAN
//                  String sql="UPDATE MOUMI_MUSER SET PHONE=?,EMAIL=?,SYS_AUTH=? WHERE ID=?"; //߰Ұ
//                        
//                  execUpdate(sql,phone,email,sysAuth,userId);
//                  System.out.println("sql:::::"+sql+"::phone::"+phone+"::email::"+email+":::userId:"+userId+":::SYS_AUTH::"+sysAuth);
//                  out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.tot_doc.modify")));
//-----------------------------                           
            String sql="UPDATE MOUMI_MUSER SET PHONE=?,EMAIL=?,SYS_AUTH=?, DUAL_POST_YN=? WHERE ID=?"; //߰Ұ
            //System.out.println("sql:::::"+sql);

            execUpdate(sql,phone,email,sysAuth, rdDualPostYn, userId);
//+++++++++++++++++++++++++++++
            out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.popup.alter")));  // Ǿϴ.
            out.println(ServletUtil.redirect("/totsys/sysadm/user/user_view.jsp?reload=yes&userID="+userId+"&sysAuth="+sysAuth));
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO                
        } catch (IOException ioex) {
            ioex.printStackTrace();
            out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.popup.notCoporationChangeAdmin")));
            out.println(ServletUtil.redirect("/totsys/sysadm/user/user_view.jsp?reload=yes&userID="+userId+"&sysAuth="+sysAuth));
        } catch (SQLException sqlex) {
            sqlex.printStackTrace();
            out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.popup.notCoporationChangeAdmin")));
            out.println(ServletUtil.redirect("/totsys/sysadm/user/user_view.jsp?reload=yes&userID="+userId+"&sysAuth="+sysAuth));
        //++++++++++++++++++++++++++++++++++++++++++++++++    
        } catch (Exception e) {
            e.printStackTrace();
            out.println(ServletUtil.alert(MoumiConfig.getMessageBundle().getString("moumi.message.popup.notCoporationChangeAdmin")));
            
            //v2. 9.ũνƮ ũƮ (PrintWrier) : Update by KWON,HAN 
//            out.println(ServletUtil.redirect("/totsys/sysadm/user/user_view.jsp?reload=yes&userID="+userId+"&sysAuth="+sysAuth));
            
            //  : ܺ Է° ͸
            String callbackFunc = "/totsys/sysadm/user/user_view.jsp?reload=yes&userID="+userId+"&sysAuth="+sysAuth;
            String filtered_callbackFunc = callbackFunc.replaceAll("<","").replaceAll(">","").replaceAll(",","");
            LOG.debug("v2 9.ũνƮ ũƮ (PrintWrier) : UserModify.UserModify() filtered_callbackFunc={}, Not Test", filtered_callbackFunc);
            out.println(ServletUtil.redirect(filtered_callbackFunc));
            //========================================
            
        } finally { 
            execClose(); 
        }
    }
}