/**********************************************************************************
 * α׷ : remit_excepted_list.java α׷ :  丮  丮̸  ̸     :       : 2002/3/31 ֽź :
 * 2002. 6.29 ٿ  : http://cpost.go.kr/shop/shop/way-board.php?db=sq&j=dn&number=57
 ***********************************************************************************/

package kr.co.kihyun.io;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Arrays;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.lang.MString;
import kr.co.kihyun.moumi.MoumiConfig;

public class FileUtil {
	private static final Logger LOG = LoggerFactory.getLogger(FileUtil.class);

	public static String getName(String filename, String appStr) {
     /*   String tmpDot = Integer.toString(filename.lastIndexOf("."));
        String dumy = ".";
        int indexOfdot;
        if(tmpDot.equals("")){
           indexOfdot = filename.lastIndexOf(dumy);
        }else{
           indexOfdot = filename.lastIndexOf(tmpDot);
        }*/
		int indexOfdot = filename.lastIndexOf(".");//̸߿ . ִ  Ȯ
    	return filename.substring(0, indexOfdot) + "_" + appStr + filename.substring(indexOfdot); 
	}

	public static String getName(String filename, String deptID, String userID, String docID, String appStr) {
       /*  String tmpDot = Integer.toString(filename.lastIndexOf("."));
         String dumy = ".";
        int indexOfdot;
        if(tmpDot.equals("")){
           indexOfdot = filename.lastIndexOf(dumy);
        }else{
           indexOfdot = filename.lastIndexOf(tmpDot);
        }*/
		int indexOfdot = filename.lastIndexOf(".");//̸߿ . ִ  Ȯ
		return deptID + "_" + userID + "_" + docID + "_" + appStr + filename.substring(indexOfdot);
	}

	public static String getFirstName(String filename) {
       /*  String tmpDot = Integer.toString(filename.lastIndexOf("."));
         String dumy = ".";
        int indexOfdot;
        if(tmpDot.equals("")){
           indexOfdot = filename.lastIndexOf(dumy);
        }else{
           indexOfdot = filename.lastIndexOf(tmpDot);
        }*/
		int indexOfdot = filename.lastIndexOf(".");
		return filename.substring(0, indexOfdot);
	}

	public static String getExtName(String filename) {
       /*  String tmpDot = Integer.toString(filename.lastIndexOf("."));
         String dumy = ".";
        int indexOfdot;
        if(tmpDot.equals("")){
           indexOfdot = filename.lastIndexOf(dumy);
        }else{
           indexOfdot = filename.lastIndexOf(tmpDot);
        }*/
		int indexOfdot = filename.lastIndexOf(".");
		return filename.substring(indexOfdot);
	}

	public static void putInFiles(String svrFilenames, IUploadable uploadable) throws IOException { 
                 putUpFiles(svrFilenames,uploadable); //  ǲŲ.
                
                            
	}

    public static void putUpFiles(String svrFilenames, IUploadable uploadable) throws IOException {

		   if (MString.isNull(svrFilenames))
			  return;
                    File sourceDir = new File(MoumiConfig.getFileDirectory().getPath());
		    for (String fileName : svrFilenames.split(";")) {
		    if (!MString.isNull(fileName)) {
                    File sourceFile = new File(sourceDir, fileName);
                    if (!sourceFile.exists() && uploadable.getAttachments().get(fileName) != null)
                    continue;
                    
                 //14. ڿ (FileInputStream/FileOutputStream)_CWE-404 : Update by KWON,HAN 
                    //FileInputStream fis = new FileInputStream(sourceFile);
		    //byte[] content = new byte[(int) sourceFile.length()];
                    //Byte[] contentObj = new Byte[content.length];
                    //fis.read(content);//  о´.
                    //for (int i = 0; i < content.length; i++)
                    //contentObj[i] = content[i];
                    //uploadable.addAttachment(fileName, Arrays.asList(contentObj));
                    //fis.close();//Ͻ .
                    //
                FileInputStream fis = null;
                try {
                    fis = new FileInputStream(sourceFile);
                    byte[] content = new byte[(int) sourceFile.length()];
                    Byte[] contentObj = new Byte[content.length];    
                    fis.read(content);//  о´.
                    for (int i = 0; i < content.length; i++)
                    contentObj[i] = content[i];
                    uploadable.addAttachment(fileName, Arrays.asList(contentObj));
                } catch (IOException e) { 
                     e.printStackTrace(); 
                } finally { 
                    fis.close(); //Ͻ .//  ߻ ο  ڿ  
                }
                //===================================================================================                    
        }
	  }
	}

    public static void delUpFiles(String svrFilenames, IUploadable uploadable) throws IOException {
        try {
            
            if (MString.isNull(svrFilenames))
                return;
            
            //9.丮  (Ƽε)_CWE-22/23 : Add by KWON,HAN
            if(svrFilenames.contains("..") || svrFilenames. contains("/")) { // Ưڿ 
                LOG.debug("9.丮  (Ƽε)_CWE-22/23 : Test OK {}", svrFilenames);
                return;
            }
            //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            
            File sourceDir = new File(MoumiConfig.getFileDirectory().getPath());
            for (String fileName : svrFilenames.split(";")) {

                File f = new File(sourceDir,fileName);

                if (f.exists() && f.isFile())
                    f.delete();
                //System.out.print("DEL FileUtil Page File Name: "+svrFilenames+"  Full Path and File Name: "+f+"\n");
            }
        } catch (Exception e) {
            //34.޼   (toString)_CWE-209 : Update by YOUNGJUN,CHO
            //System.out.println(e.toString());
            LOG.error("\nFileUtil delUpFiles Exception - {}", e.toString());
            //================================================
        }
    }
}
