package kr.co.kihyun.lang;

import java.io.UnsupportedEncodingException;

public class Encoder {
	public static String toKR(String str) throws UnsupportedEncodingException {
		if (str == null)
			return "";
		return new String(str.getBytes("8859_1"), "KSC5601");
	}

	public static String toUni(String str) {
		String result = "";
		try {
			if (str == null)
				return "";
			result = new String(str.getBytes("euc-kr"), "8859_1");
		} catch (UnsupportedEncodingException e) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    e.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
		}
		return result;
	}

	public static String toISO(String str) throws UnsupportedEncodingException {
		if (str == null)
			return "";
		return new String(str.getBytes("KSC5601"), "8859_1");
	}

	public static String toUTF8(String str) throws UnsupportedEncodingException {
		if (str == null)
			return "";
		return new String(str.getBytes("KSC5601"), "UTF8");
	}

	public static String toKSC(String str) throws UnsupportedEncodingException {
		if (str == null)
			return "";
		return new String(str.getBytes("UTF8"), "KSC5601");
	}

	/**
	 *  ̽ ڿ  Encoder ȯ
	 */
	public static String toDB(String str) {
		try {
			if (str == null)
				return "";
			return new String(str.getBytes("euc-kr"), "iso-8859-1");
		} catch (Exception e) {
			return str;
		}
	}

	/**
	 *  ̽ ڿ  Encoder ȯ
	 */
	public static String toJava(String str) {
		try {
			if (str == null)
				return "";
			return new String(str.getBytes("8859_1"), "euc-kr");
		} catch (Exception e) {
			return str;
		}
	}

	public static String toEUCKR(String str) {
		try {
			if (str == null)
				return "";
			return new String(str.getBytes("UTF8"), "euc-kr");
		} catch (Exception e) {
			return str;
		}
	}
}