/*********************************************************************************************************
 * α׷ : CalculationForm.java α׷ : ȯ  Ǵ  óϴ° ۼ :  ۼ : 2004-12-02  : 2005-02-04
 **********************************************************************************************************/

package kr.co.kihyun.text.excel;

import java.util.ArrayList;
import java.util.List;

import kr.co.kihyun.lang.MInteger;
import kr.co.kihyun.lang.MString;
import kr.co.kihyun.moumi.doc.table.item.MItem;

public class CalculationForm {

	public static String getCalculationForm(String expr, int rowNum, String type) {

		// ʿ EXPR ^
		if (MString.isNull(expr) || expr.indexOf("^") > -1 || expr.indexOf("~") > -1)
			return expr;

		// "SUM", "(", ")", ":", ",", "+", "-", "*", "/"
		// SUM(B9:F99)
		char[] charList = expr.toCharArray(); //  char array ȯ
		int[] charInfoList = null;
		int[] numList = null;
		int charCount = 0;

		charCount = charList.length;

		// char infomation array, num value array create
		if (charList.length > 0) {
			charInfoList = new int[charCount];
			numList = new int[charCount];
		} else {
			return expr;
		}

		// char array analysis
		for (int i = 0; i < charCount; i++) {

			if (48 <= (int) charList[i] && (int) charList[i] <= 57) {
				numList[i] = Integer.parseInt(Character.toString(charList[i]));
				charInfoList[i] = MItem.INT;
			} else if ((65 <= (int) charList[i] && (int) charList[i] <= 90)
					|| (97 <= (int) charList[i] && (int) charList[i] <= 122)) {
				// a: 97, z: 122, A: 65, Z: 90
				charInfoList[i] = MItem.CHAR;
			} else {
				charInfoList[i] = MItem.SPCHAR; //  == Ÿ 
			}
		}

		// item name ԵǾִ   (rowNum)ŭ  Űų  Ŵ
		StringBuffer exprbuf = new StringBuffer(); // и  StringBuffer ϳ ȯϿ ߰
		String tmpNum = ""; // item name  ڸ ڷ ǥ
		boolean isItemNum = false; // item name  ڵ ̶ appendض "1"+"2"....

		for (int i = 0; i < charCount; i++) {
			if (charInfoList[i] == MItem.CHAR) { // ̰
				if (charInfoList[i] == 's' || charInfoList[i] == 'S') {
					isItemNum = true;
				} else if (i > 0 && (charInfoList[i] == 'u' || charInfoList[i] == 'U')) {
					isItemNum = true;
				} else if (i > 1 && (charInfoList[i] == 'm' || charInfoList[i] == 'M')) { // SUM ̰ Item name ƴϴ
					isItemNum = false;
				} else { // sum    Item name̴
					isItemNum = true;
				}
				exprbuf.append(charList[i]);
			} else if (charInfoList[i] == MItem.INT) { // ̰
				if (i > 0 && MItem.CHAR == charInfoList[i - 1] && isItemNum) { // Item name̸ ù° 
					tmpNum = Integer.toString(numList[i]);
					isItemNum = true;
				} else if (i > 0 && MItem.INT == charInfoList[i - 1] && isItemNum) { // Item name̸ ι° 
					tmpNum += Integer.toString(numList[i]);
					isItemNum = true;
				} else { // Item name ƴ ׳ ڶ
					exprbuf.append(charList[i]);
					isItemNum = false;
				}

				if ((i == (charCount - 1) || MItem.INT != charInfoList[i + 1]) && isItemNum) {
					if (type != null && type.equals("add")) { // ǥ ڷ   ࿡   
						exprbuf.append((MInteger.parseInt(tmpNum) + rowNum));
					} else if (type != null && type.equals("sub")) { // ΰ ǥ Ҷ Form Ǵ Ļ
						exprbuf.append((MInteger.parseInt(tmpNum) - rowNum));
					}
				}
			} else {
				exprbuf.append(charList[i]);
				isItemNum = false;
			}
		}

		return exprbuf.toString();
	}

	// ڰ  ϳ ǥ total ۼҶ ϴ 
	public static String getDynaReportTotCalculationForm(String itemName, int titleRowCount, int rowCount) {
		if (MString.isNull(itemName))
			return "";
		itemName = Character.toString((itemName.toCharArray())[0]);

		StringBuffer strbuf = new StringBuffer();
		strbuf.append("SUM(");
		strbuf.append(itemName);
		strbuf.append((titleRowCount + 1));
		strbuf.append(":");
		strbuf.append(itemName);
		strbuf.append((rowCount + titleRowCount));
		strbuf.append(")");

		return getCalculationForm(strbuf.toString());
	}

	//  ϴ  ױ
	public static String getCalculationForm(String sumStr) {

		if (MString.isNull(sumStr))
			return "";

		StringBuffer strbuf = new StringBuffer();
		strbuf.append(" x:num=\"0\" x:fmla=\"=");
		strbuf.append(sumStr);
		strbuf.append("\"");

		return strbuf.toString();
	}

	// FIXME : remove me.
	public static String getCalculationForms(String arrayName, String propName, String sData) {

		int stTDIndex = 0;
		int edTDIndex = 0;
		int stExIndex = 0;
		int edExIndex = 0;
		int exHeadIndex = 0;
		int index = -1;

		String headEx = "x:fmla=";
		String stEx = "=";
		String edEx = "\"";
		String tdContext = null;
		String endResult = null;
		StringBuffer exprbuf = new StringBuffer();

		while (true) {
			stTDIndex = sData.indexOf("<td", stTDIndex + 1);
			if (stTDIndex == -1)
				break;
			index++;

			edTDIndex = sData.indexOf(">", stTDIndex);
			if (stTDIndex == -1)
				break;

			tdContext = sData.substring(stTDIndex, edTDIndex + 1); // TD ɼ 
			exHeadIndex = tdContext.indexOf(headEx);
			// ) <td nowrap x:num x:fmla="=sum(c2:c5)" >

			if (exHeadIndex != -1) {
				stExIndex = tdContext.indexOf(stEx, exHeadIndex + headEx.length()); // x:fmla="=sum(c2:c5)"  ù° `=` 
																					// ˻
				edExIndex = tdContext.indexOf(edEx, stExIndex + stEx.length()); // x:fmla="=sum(c2:c5)"   `"` ˻
				endResult = tdContext.substring(stExIndex + stEx.length(), edExIndex);
				endResult = endResult.toUpperCase();
				exprbuf.append(arrayName);
				exprbuf.append("[");
				exprbuf.append(index);
				exprbuf.append("].");
				exprbuf.append(propName);
				exprbuf.append(" = '");
				exprbuf.append(endResult);
				exprbuf.append("';\n");
			}
		}
		return exprbuf.toString();
	}

	//  sum javascript itemExprList 
	public static String getCalculationForms(String sData) {

		int stTDIndex = 0;
		int edTDIndex = 0;
		int stExIndex = 0;
		int edExIndex = 0;
		int exHeadIndex = 0;
		int index = -1;

		String headEx = "x:fmla=";
		String stEx = "=";
		String edEx = "\"";
		String tdContext = null;
		String endResult = null;
		StringBuffer exprbuf = new StringBuffer();

		while (true) {
			stTDIndex = sData.indexOf("<td", stTDIndex + 1);
			if (stTDIndex == -1)
				break;
			index++;

			edTDIndex = sData.indexOf(">", stTDIndex);
			if (stTDIndex == -1)
				break;

			tdContext = sData.substring(stTDIndex, edTDIndex + 1); // TD ɼ 
			exHeadIndex = tdContext.indexOf(headEx);
			// ) <td nowrap x:num x:fmla="=sum(c2:c5)" >

			if (exHeadIndex != -1) {
				stExIndex = tdContext.indexOf(stEx, exHeadIndex + headEx.length()); // x:fmla="=sum(c2:c5)"  ù° `=` 
																					// ˻
				edExIndex = tdContext.indexOf(edEx, stExIndex + stEx.length()); // x:fmla="=sum(c2:c5)"   `"` ˻
				endResult = tdContext.substring(stExIndex + stEx.length(), edExIndex);
				endResult = endResult.toUpperCase();
				exprbuf.append("itemExprList[");
				exprbuf.append(index);
				exprbuf.append("] = '");
				exprbuf.append(endResult);
				exprbuf.append("';\n");
			}
		}
		return exprbuf.toString();
	}

	//  sum javascript itemExprList 
	// TODO refactoring, duplicated code with getCalculationForms(String)
	public static List<String> getExprList(String sData) {
		List<String> exprList = new ArrayList<String>();

		int stTDIndex = 0;
		int edTDIndex = 0;
		int stExIndex = 0;
		int edExIndex = 0;
		int exHeadIndex = 0;
		int index = -1;

		String headEx = "x:fmla=";
		String stEx = "=";
		String edEx = "\"";
		String tdContext = null;
		String endResult;
		;
		StringBuffer exprbuf = new StringBuffer();

		while (true) {
			endResult = null;
			stTDIndex = sData.indexOf("<td", stTDIndex + 1);
			if (stTDIndex == -1)
				break;
			index++;

			edTDIndex = sData.indexOf(">", stTDIndex);
			if (stTDIndex == -1)
				break;

			tdContext = sData.substring(stTDIndex, edTDIndex + 1); // TD ɼ 
			exHeadIndex = tdContext.indexOf(headEx);
			// ) <td nowrap x:num x:fmla="=sum(c2:c5)" >

			if (exHeadIndex != -1) {
				stExIndex = tdContext.indexOf(stEx, exHeadIndex + headEx.length()); // x:fmla="=sum(c2:c5)"  ù° `=` 
																					// ˻
				edExIndex = tdContext.indexOf(edEx, stExIndex + stEx.length()); // x:fmla="=sum(c2:c5)"   `"` ˻
				endResult = tdContext.substring(stExIndex + stEx.length(), edExIndex);
				endResult = endResult.toUpperCase();
				exprbuf.append("itemExprList[");
				exprbuf.append(index);
				exprbuf.append("] = '");
				exprbuf.append(endResult);
				exprbuf.append("';\n");
			}
			exprList.add(endResult);
		}
		return exprList;
	}
}