package kr.co.kihyun.tree;

import java.io.IOException;
//import java.io.IOException;
import java.io.PrintWriter;
import java.sql.ResultSet;
import java.sql.SQLException;

//import javax.servlet.ServletException;
//import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kr.co.kihyun.beans.entity.SysAuth;
import kr.co.kihyun.beans.user.HttpSSOLogin;
//import java.util.Calendar;
//import kr.co.kihyun.lang.Encoder;
//import kr.co.kihyun.lang.MInteger;
//import kr.co.kihyun.lang.MLong;
//import kr.co.kihyun.moumi.MoumiConfig;
import kr.co.kihyun.db.DBManager;
import kr.co.kihyun.lang.MString;

public class MakeJSon extends DBManager {

    public int dataCnt = 0, sysAuth;
    public String userId, sql = null;
    public PrintWriter out = null;
    public StringBuffer sbuf = new StringBuffer();

    public MakeJSon(HttpServletRequest req, HttpServletResponse res) {
        try {
            res.setContentType("text/html;charset=euc-kr");
            sysAuth = HttpSSOLogin.getSysAuth(req);
            userId = HttpSSOLogin.getLoginID(req);
            out = res.getWriter();
            String id = req.getParameter("id");
            //String rootId = req.getParameter("rootId");
            String rootId = MString.checkNull(req.getParameter("rootId"), null);
            String deptId = req.getParameter("rel");

            String userYN = MString.checkNull(req.getParameter("userYN"), "N");
            String gubun = MString.checkNull(req.getParameter("gubun"), "ORGAN");
            if (rootId == null || rootId.equals("null") || rootId.equals("ROOT")) {
                rootId = null;
            }
            sbuf.append("[");
            if (gubun.equals("COMMON")) {
                //System.out.println("gubun:::::"+gubun);
                makeGroupCommonSql(id, userId);
                group2JSon(id);
            } else if (gubun.equals("AREA")) {
                //System.out.println("gubun:::::"+gubun);
                makeGroupAreaSql(id, userId);
                group2JSon(id);
            } else if (gubun.equals("DEPT")) {
                //System.out.println("gubun:::::"+gubun);
                makeGroupDeptSql(id, userId, deptId);
                group2JSon(id);
            } else {
                makeTreeSql(id, rootId);
                dept2JSon();
                if (userYN.equals("Y")) {
                    user2JSon(id);
                }
            }
            sbuf.append("]");
            if (dataCnt > 0) {
                sbuf.deleteCharAt(sbuf.lastIndexOf(","));
            }
//System.out.println("MakeJSon.MakeJSon ::: sbuf.toString() \n" + sbuf.toString());            
            out.println(sbuf.toString());
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO
        } catch(IOException ioex) {
            ioex.printStackTrace();
        //++++++++++++++++++++++++++++++++++++++++++++++++
        } catch (Exception ex) {
            //System.out.println("error exception1:" + ex);
            ex.printStackTrace();
        }
    }


    public void makeGroupCommonSql(String id, String userId) {
        sql = null;
        if (id.equals("ROOT")) {
            /*sql="SELECT UP.ID PART_ID,UP.NAME DEPT_NAME,UP.USER_ID,UP.ID DEPT_ID,'closed' STATE ";
             sql+="FROM MOUMI_MUSER US,MOUMI_DEPT DT,MOUMI_USER_PART UP LEFT JOIN MOUMI_USER_USER UU ON (UU.PART_ID = UP.ID) ";
             sql+="WHERE DT.ORGAN IS NOT NULL AND US.ID='"+userId+"' AND US.DEPT_ID=DT.ID ";
             //sql+="AND (UP.USER_ID=US.ID OR UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE SYS_AUTH=9) ";
             sql+="AND (UP.USER_ID=US.ID AND UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE SYS_AUTH=9) ";
             if(sysAuth!=2) sql+="OR UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE SYS_AUTH=2)";
             sql+=") ORDER BY UP.NAME";*/

            sql  = "SELECT UP.ID      AS PART_ID    \n";
            sql += "     , UP.NAME   AS DEPT_NAME   \n";
            sql += "     , UP.USER_ID               \n";
            sql += "     , UP.ID     AS DEPT_ID     \n";
            sql += "     , 'closed'  AS STATE       \n";
            sql += "     , ''       AS ORGAN_DEPT_NAME       \n";     //2014.09.17 Add by KWON,HAN 
            sql += "     , ''       AS UPPER_DEPT_NAME       \n";     //2014.09.17 Add by KWON,HAN 
            sql += "     , (  \n";
            sql += "         SELECT COUNT(A.PART_ID) AS PART_ID_COUNT      \n";
            sql += "         FROM MOUMI_USER_DEPT A      \n";
            sql += "             , MOUMI_DEPT B     \n";
            sql += "         WHERE A.PART_ID = UP.ID   \n";
            sql += "             AND A.ID = B.ID    \n";
            sql += "             AND B.SEL_TYPE = 'Y' AND B.IS_OUT = 'N'  \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "     ) AS PART_ID_COUNT  \n";   // 2014.12.19 YOUNGJUN.CHO ( Ҽ μ īƮ ϵ ߰)
            sql += "  FROM MOUMI_MUSER  US         \n";
            sql += "     , MOUMI_DEPT  DT          \n";
            sql += "     , MOUMI_USER_PART  UP     \n";
            sql += " WHERE DT.ORGAN IS NOT NULL  \n";
            sql += "   AND US.DEPT_ID=DT.ID  \n";
            sql += "   AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "   AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += "   AND (UP.USER_ID=US.ID AND UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE SYS_AUTH=9))  \n";
            sql += "   AND UP.USE_YN = 'Y'  \n";
            sql += " ORDER BY UP.NAME  \n";

//System.out.println("MakeJSon.makeGroupCommonSql 1:::id.equals(ROOT)::\n" + sql);
            return;
        } else {
            //2014.09.17 Update by KWON.HAN 
            //sql = "SELECT PART_ID,NAME DEPT_NAME,'' USER_ID,ID DEPT_ID,'opened' STATE FROM MOUMI_USER_DEPT WHERE PART_ID='" + id + "' ORDER BY NAME";
            sql  = "SELECT A.PART_ID    \n";
            sql += "     , A.NAME       AS DEPT_NAME    \n";
            sql += "     , ''           AS USER_ID    \n";
            sql += "     , A.ID         AS DEPT_ID    \n";
            sql += "     , 'opened'     AS STATE    \n"; 
            sql += "     , ( SELECT name FROM moumi_dept where id = ( CASE WHEN dt.id = dt.organ AND dt.upper_dept IS NOT NULL   \n"; 
            sql += "                                                       THEN ( SELECT organ FROM moumi_dept where id = dt.upper_dept )    \n"; 
            sql += "                                                       ELSE dt.organ END )    \n"; 
            sql += "                                                              ) AS ORGAN_DEPT_NAME    \n";
            sql += "     , ( SELECT name FROM moumi_dept where id = dt.upper_dept ) AS UPPER_DEPT_NAME    \n";
            sql += "  FROM MOUMI_USER_DEPT A    \n";
            sql += "     , MOUMI_DEPT      DT    \n";
            sql += " WHERE A.PART_ID = '" + id + "'     \n";
            sql += "   AND A.ID = DT.ID    \n";
            sql += "   AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "   AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += " ORDER BY A.NAME    \n";
            
//System.out.println("MakeJSon.makeGroupCommonSql 2:::::\n" + sql);
            return;
        }
    }

    public void makeGroupAreaSql(String id, String userId) {
        sql = null;
        if (id.equals("ROOT")) {
            /*sql="SELECT UP.ID PART_ID,UP.NAME DEPT_NAME,UP.USER_ID,UP.ID DEPT_ID,'closed' STATE ";
             sql+="FROM MOUMI_MUSER US,MOUMI_DEPT DT,MOUMI_USER_PART UP LEFT JOIN MOUMI_USER_USER UU ON (UU.PART_ID = UP.ID) ";
             sql+="WHERE DT.ORGAN IS NOT NULL AND US.ID='"+userId+"' AND US.DEPT_ID=DT.ID ";
             //sql+="AND (UP.USER_ID=US.ID OR UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE SYS_AUTH=7) ";
             sql+="AND (UP.USER_ID=US.ID AND UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE SYS_AUTH=7) ";
             if(sysAuth!=2) sql+="OR UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE SYS_AUTH=2)";
             sql+=") ORDER BY UP.NAME";*/
            sql = " SELECT UP.ID    AS PART_ID       \n";
            sql += "      , UP.NAME  AS DEPT_NAME     \n";
            sql += "      , UP.USER_ID                \n";
            sql += "      , UP.ID    AS DEPT_ID       \n";
            sql += "      , 'closed' AS STATE         \n";
            sql += "     , ''       AS ORGAN_DEPT_NAME       \n";     //2014.09.17 Add by KWON,HAN 
            sql += "     , ''       AS UPPER_DEPT_NAME       \n";     //2014.09.17 Add by KWON,HAN             
            sql += "     , (  \n";
            sql += "         SELECT COUNT(A.PART_ID) AS PART_ID_COUNT      \n";
            sql += "         FROM MOUMI_USER_DEPT A      \n";
            sql += "             , MOUMI_DEPT B     \n";
            sql += "         WHERE A.PART_ID = UP.ID   \n";
            sql += "             AND A.ID = B.ID    \n";
            sql += "             AND B.SEL_TYPE = 'Y' AND B.IS_OUT = 'N'  \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "     ) AS PART_ID_COUNT  \n";   // 2014.12.19 YOUNGJUN.CHO ( Ҽ μ īƮ ϵ ߰)
            sql += "   FROM MOUMI_MUSER US      \n";
            sql += "      , MOUMI_DEPT DT       \n";
            sql += "      , MOUMI_DEPT GR       \n";
            sql += "       ,MOUMI_USER_PART UP  \n";
            sql += " WHERE DT.ORGAN IS NOT NULL   \n";
            sql += "   AND US.DEPT_ID=DT.ID   \n";
            sql += "   AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "   AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += "   AND DT.ORGAN = GR.ID   \n";
            sql += "   AND UP.USER_ID=US.ID   \n";
            sql += "   AND UP.USE_YN = 'Y'    \n";
            sql += "   AND UP.USER_ID IN (    \n";
            sql += "                      SELECT US.ID   \n";
            sql += "                        FROM MOUMI_MUSER US  \n";
            sql += "                           , MOUMI_DEPT DT   \n";
            sql += "                       WHERE US.SYS_AUTH=7   \n";
            sql += "                         AND US.DEPT_ID = DT.ID   \n";
            sql += "                         AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "                         AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += "                         AND DT.ORGAN = ( SELECT GR.ID   \n";
            sql += "                                            FROM MOUMI_MUSER US   \n";
            sql += "                                               , MOUMI_DEPT DT    \n";
            sql += "                                               , MOUMI_DEPT GR    \n";
            sql += "                                           WHERE US.ID='" + userId + "'   \n";
            sql += "                                             AND US.DEPT_ID = DT.ID   \n";
            sql += "                                             AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "                                             AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += "                                             AND DT.ORGAN = GR.ID    \n";
            sql += "                                        )   \n";
            sql += "                     )    \n";
            sql += " ORDER BY UP.NAME   \n";

//System.out.println("MakeJSon.makeGroupAreaSql:::id.equals(ROOT)::\n" + sql);
            return;
        } else {
            //2014.09.17 Update by KWON.HAN 
            //sql = "SELECT PART_ID,NAME DEPT_NAME,'' USER_ID,ID DEPT_ID,'opened' STATE FROM MOUMI_USER_DEPT WHERE PART_ID='" + id + "' ORDER BY NAME";
            sql  = "SELECT A.PART_ID    \n";
            sql += "     , A.NAME       AS DEPT_NAME    \n";
            sql += "     , ''           AS USER_ID    \n";
            sql += "     , A.ID         AS DEPT_ID    \n";
            sql += "     , 'opened'     AS STATE    \n"; 
            sql += "     , ( SELECT name FROM moumi_dept where id = ( CASE WHEN dt.id = dt.organ AND dt.upper_dept IS NOT NULL   \n"; 
            sql += "                                                       THEN ( SELECT organ FROM moumi_dept where id = dt.upper_dept )    \n"; 
            sql += "                                                       ELSE dt.organ END )    \n"; 
            sql += "                                                              ) AS ORGAN_DEPT_NAME    \n";
            sql += "     , ( SELECT name FROM moumi_dept where id = dt.upper_dept ) AS UPPER_DEPT_NAME    \n";
            sql += "  FROM MOUMI_USER_DEPT A    \n";
            sql += "     , MOUMI_DEPT      DT    \n";
            sql += " WHERE A.PART_ID = '" + id + "'     \n";
            sql += "   AND A.ID = DT.ID    \n";
            sql += "   AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "   AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += " ORDER BY A.NAME    \n";
           
//System.out.println("MakeJSon.makeGroupAreaSql:::::\n" + sql);
            return;
        }
    }

    public void makeGroupDeptSql(String id, String userId, String deptId) {
        sql = null;
        if (id.equals("ROOT")) {
            /*sql="SELECT UP.ID PART_ID,UP.NAME DEPT_NAME,UP.USER_ID,UP.ID DEPT_ID,'closed' STATE ";
             sql+="FROM MOUMI_MUSER US,MOUMI_DEPT DT,MOUMI_USER_PART UP LEFT JOIN MOUMI_USER_USER UU ON (UU.PART_ID = UP.ID) ";
             sql+="WHERE DT.ORGAN IS NOT NULL AND US.ID='"+userId+"' AND US.DEPT_ID=DT.ID ";
             //sql+="AND (UP.USER_ID=US.ID OR UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE DEPT_ID='"+deptId+"') ";
             sql+="AND (UP.USER_ID=US.ID AND UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE DEPT_ID='"+deptId+"') ";
             if(sysAuth!=2) sql+="OR UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE SYS_AUTH=2)";
             sql+=") ORDER BY UP.NAME";*/
            sql = "SELECT UP.ID    AS PART_ID       \n";
            sql += "     , UP.NAME  AS DEPT_NAME     \n";
            sql += "     , UP.USER_ID                \n";
            sql += "     , UP.ID    AS DEPT_ID       \n";
            sql += "     , 'closed' AS STATE         \n";
            sql += "     , ''       AS ORGAN_DEPT_NAME       \n";     //2014.09.17 Add by KWON,HAN 
            sql += "     , ''       AS UPPER_DEPT_NAME       \n";     //2014.09.17 Add by KWON,HAN             
            sql += "     , (  \n";
            sql += "         SELECT COUNT(A.PART_ID) AS PART_ID_COUNT      \n";
            sql += "         FROM MOUMI_USER_DEPT A      \n";
            sql += "             , MOUMI_DEPT B     \n";
            sql += "         WHERE A.PART_ID = UP.ID   \n";
            sql += "             AND A.ID = B.ID    \n";
            sql += "             AND B.SEL_TYPE = 'Y' AND B.IS_OUT = 'N'  \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "     ) AS PART_ID_COUNT  \n";   // 2014.12.19 YOUNGJUN.CHO ( Ҽ μ īƮ ϵ ߰)
            sql += "  FROM MOUMI_MUSER US        \n";
            sql += "     , MOUMI_DEPT DT         \n";
            sql += "     , MOUMI_DEPT GR         \n";
            sql += "     , MOUMI_USER_PART UP    \n";
            sql += " WHERE DT.ORGAN IS NOT NULL   \n";
            sql += "   AND US.DEPT_ID=DT.ID       \n";
            sql += "   AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "   AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += "   AND DT.ORGAN = GR.ID       \n";
            sql += "   AND UP.USER_ID=US.ID       \n";
            sql += "   AND UP.USE_YN = 'Y'        \n";
            sql += "   AND UP.USER_ID IN (        \n";
            sql += "                      select us.id    \n";
            sql += "                        from moumi_muser us   \n";
            sql += "                           , moumi_dept dt    \n";
            sql += "                       where us.dept_id = dt.ID   \n";
            sql += "                         AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "                         AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += "                         and dt.id = ( SELECT dt.ID    \n";
            sql += "                                         FROM MOUMI_MUSER US   \n";
            sql += "                                            , MOUMI_DEPT DT    \n";
            sql += "                                        WHERE US.ID='" + userId + "'   \n";
            sql += "                                          and US.DEPT_ID = dt.id    \n";
            sql += "                                          AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "                                          AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += "                                     )   \n";
            sql += "                     )    \n";
            sql += " ORDER BY UP.NAME    \n";

//System.out.println("MakeJSon.makeGroupDeptSql:::id.equals(ROOT)::\n" + sql);
            return;
        } else {
            //2014.09.17 Update by KWON.HAN 
            //sql = "SELECT PART_ID,NAME DEPT_NAME,'' USER_ID,ID DEPT_ID,'opened' STATE FROM MOUMI_USER_DEPT WHERE PART_ID='" + id + "' ORDER BY NAME";
            sql  = "SELECT A.PART_ID    \n";
            sql += "     , A.NAME       AS DEPT_NAME    \n";
            sql += "     , ''           AS USER_ID    \n";
            sql += "     , A.ID         AS DEPT_ID    \n";
            sql += "     , 'opened'     AS STATE    \n"; 
            sql += "     , ( SELECT name FROM moumi_dept where id = ( CASE WHEN dt.id = dt.organ AND dt.upper_dept IS NOT NULL   \n"; 
            sql += "                                                       THEN ( SELECT organ FROM moumi_dept where id = dt.upper_dept )    \n"; 
            sql += "                                                       ELSE dt.organ END )    \n"; 
            sql += "                                                              ) AS ORGAN_DEPT_NAME    \n";
            sql += "     , ( SELECT name FROM moumi_dept where id = dt.upper_dept ) AS UPPER_DEPT_NAME    \n";
            sql += "  FROM MOUMI_USER_DEPT A    \n";
            sql += "     , MOUMI_DEPT      DT    \n";
            sql += " WHERE A.PART_ID = '" + id + "'     \n";
            sql += "   AND A.ID = DT.ID    \n";
            sql += "   AND DT.SEL_TYPE='Y'          \n";  // 2014.12.19 YOUNGJUN.CHO (ĺμ ȸǵ  ߰, SEL_TYPE = 'Y')
            sql += "   AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += " ORDER BY A.NAME    \n";
            
//System.out.println("MakeJSon.makeGroupDeptSql:::::\n" + sql);
            return;
        }
    }

    public void group2JSon(String id) {
        int ii = 0;
        ResultSet rs = null;
        String partId, deptName, userId, deptId, upper, organ, seltype, pri, state = "closed";
        partId = deptName = userId = deptId = upper = organ = seltype = pri = "";
        
        //2014.09.17 Add by KWON,HAN  +++
        String organdeptname;    
        String upperdeptname;    
        organdeptname = "";      
        upperdeptname = "";         
        //+++++++++++++++++++++++++++++++
        
        try {
            rs = execQuery(sql);
            //System.out.println("group2JSon:::::"+sql);
            if (rs == null) {
                return;
            }
            while (rs.next()) {
                partId = MString.checkNull(rs.getString(1));
                deptName = MString.checkNull(rs.getString(2));
                if (id.equals("ROOT")) {
                    //deptName = new GroupCount().getCount(partId, deptName);
                    deptName = deptName + "(" + MString.checkNull(rs.getString(8), "0") + ")";
                }
                userId = MString.checkNull(rs.getString(3));
                deptId = MString.checkNull(rs.getString(4));
                state = MString.checkNull(rs.getString(5));
                
                organdeptname = MString.checkNull(rs.getString(6));      //2014.09.17 Add by KWON,HAN 
                upperdeptname = MString.checkNull(rs.getString(7));      //2014.09.17 Add by KWON,HAN   
                
                sbuf.append("{ \"data\":\"" + deptName + "\",\"attr\": { \"ID\":\"" + deptId + "\", ");
                sbuf.append("\"UPPER\":\"" + upper + "\",\"ORGAN\":\"" + organ + "\", \"SELTYPE\":\"" + seltype + "\", ");
                sbuf.append("\"deptname\":\"" + deptName + "\",");           //2014.09.17 Add by KWON,HAN 
                sbuf.append("\"organdeptname\":\"" + organdeptname + "\","); //2014.09.17 Add by KWON,HAN 
                sbuf.append("\"upperdeptname\":\"" + upperdeptname + "\","); //2014.09.17 Add by KWON,HAN                 
                sbuf.append("\"PRI\":\"" + pri + "\",\"rel\":\"GROUP\"},\"state\" : \"" + state + "\"}");
                sbuf.append(",");
                dataCnt++;

            }
            close(rs);
            rs = null;
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO
        } catch(SQLException sqlex) {
            sqlex.printStackTrace();
        //++++++++++++++++++++++++++++++++++++++++++++++++
        } catch (Exception ex) {
            //System.out.println("error exception2:" + ex);
            ex.printStackTrace();
        } finally {
            if (rs != null) {
                close(rs);
            }
            execClose();
        }
    }

    public void makeTreeSql(String id, String rootId) {
        sql = null;
        if (rootId != null) {
            sql = "SELECT dt.ID, dt.NAME, dt.UPPER_DEPT, dt.ORGAN,                                                   \n";
            sql += "  ( CASE WHEN dt.SEL_TYPE='Y' AND dt.SEL_TYPE<>'0' THEN 1 ELSE 0 END ) AS SEL_TYPE, dt.PRIORITY   \n";
            sql += "     , ( SELECT name FROM moumi_dept where id = ( CASE WHEN dt.id = dt.organ AND dt.upper_dept IS NOT NULL   \n"; 
            sql += "                                                       THEN ( SELECT organ FROM moumi_dept where id = dt.upper_dept )    \n"; 
            sql += "                                                       ELSE dt.organ END )    \n"; 
            sql += "                                                              ) AS ORGAN_DEPT_NAME    \n";
            sql += "     , ( SELECT name FROM moumi_dept where id = dt.upper_dept ) AS UPPER_DEPT_NAME    \n";            
            sql += "FROM MOUMI_DEPT dt                                                                 \n";
            sql += "WHERE dt.ORGAN IS NOT NULL AND dt.ID='" + rootId + "'                                       \n";
            sql += "   AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            
                //  2ȸ batch , ӱΰ ӱ ORGAN ÷ ID  UPDATE ϴ 쿡 or  ּóѴ.
            // ڰ  μ  ȸǵ Ѵ.
            // 2014.09.16 by youngjun cho.
            //sql+="  OR (UPPER_DEPT='"+rootId+"' AND ID=ORGAN)                                       \n";
            sql += "ORDER BY dt.NAME                                                                     \n";

//System.out.println("::makeTreeSql:::rootId!=null:id::::"+id+"::::::::rootId::::::::"+rootId);
//System.out.println("makeTreeSql::rootId!=null:::\n"+sql);

            return;
        }
        if (id.equals("ROOT")) {
            sql = "SELECT dt.ID, dt.NAME, dt.UPPER_DEPT, dt.ORGAN,                                                   \n";
            sql += "  ( CASE WHEN SEL_TYPE='Y' AND SEL_TYPE<>'0' THEN 1 ELSE 0 END ) AS SEL_TYPE, dt.PRIORITY   \n";
            sql += "     , ( SELECT name FROM moumi_dept where id = ( CASE WHEN dt.id = dt.organ AND dt.upper_dept IS NOT NULL   \n"; 
            sql += "                                                       THEN ( SELECT organ FROM moumi_dept where id = dt.upper_dept )    \n"; 
            sql += "                                                       ELSE dt.organ END )    \n"; 
            sql += "                                                              ) AS ORGAN_DEPT_NAME    \n";
            sql += "     , ( SELECT name FROM moumi_dept where id = dt.upper_dept ) AS UPPER_DEPT_NAME    \n";               
            sql += "FROM MOUMI_DEPT  dt                                                                 \n";
            sql += "WHERE dt.ORGAN IS NOT NULL AND dt.UPPER_DEPT IS NULL                                    \n";
            sql += "  AND dt.SYS_AUTH<3                                                                  \n";
            sql += "   AND DT.IS_OUT='N'        \n";   // 2014.09.22 BY YOUNGJUN CHO(  ߰)
            sql += "ORDER BY dt.NAME                                                                     \n";

//System.out.println("::makeTreeSql:::id.equals(ROOT):::id::::"+id+"::::::::rootId::::::::"+rootId);
//System.out.println("makeTreeSql:::id.equals(ROOT)::\n"+sql);

            return;
        }

            sql = "SELECT dt.ID, dt.NAME, dt.UPPER_DEPT, dt.ORGAN,                                                   \n";
            sql += "  ( CASE WHEN dt.SEL_TYPE='Y' AND dt.SEL_TYPE<>'0' THEN 1 ELSE 0 END ) AS SEL_TYPE, dt.PRIORITY   \n";
            sql += "     , ( SELECT name FROM moumi_dept where id = ( CASE WHEN dt.id = dt.organ AND dt.upper_dept IS NOT NULL   \n"; 
            sql += "                                                       THEN ( SELECT organ FROM moumi_dept where id = dt.upper_dept )    \n"; 
            sql += "                                                       ELSE dt.organ END )    \n"; 
            sql += "                                                              ) AS ORGAN_DEPT_NAME    \n";
            sql += "     , ( SELECT name FROM moumi_dept where id = dt.upper_dept ) AS UPPER_DEPT_NAME    \n";           
            sql += "FROM MOUMI_DEPT  dt                                                                  \n";
            sql += "WHERE dt.UPPER_DEPT='" + id + "' AND dt.ID <> dt.UPPER_DEPT AND dt.SYS_AUTH < 6                       \n";

            //  󱳵 б ȸ ʵ Ѵ.(IS_OUT : 'Y'= 󱳵 / 'N'= 󱳾ȵ)
        //  2ȸ batch , TC_SYMOCMOC000 ̺ ORG_UON ÷ üũϿ MOUMI_DEPT(IS_OUT)  UPDATE Ѵ.
        // (ORG_UON : 'Y' = 󱳾ȵ / 'N' = 󱳵)
        // 2014.09.16 by youngjun cho.
        sql += "  AND dt.IS_OUT = 'N'                                                                \n";
        sql += "ORDER BY dt.NAME                                                                     \n";

//System.out.println("makeTreeSql:::::\n"+sql);
        return;
    }

    
    public void dept2JSon() {
        int ii = 0;
        ResultSet rs = null;
        String deptId, name, upper, organ, seltype, pri;
        deptId = name = upper = organ = seltype = pri = null;

        //2014.09.17 Add by KWON,HAN  +++
        String organdeptname;    
        String upperdeptname;    
        organdeptname = "";      
        upperdeptname = "";         
        //+++++++++++++++++++++++++++++++ 
        
        try {
            rs = execQuery(sql);
//System.out.println("dept2JSon:::::"+sql);
            if (rs == null) {
                return;
            }
            while (rs.next()) {
                deptId = MString.checkNull(rs.getString(1));
                name = MString.checkNull(rs.getString(2));
                upper = MString.checkNull(rs.getString(3));
                organ = MString.checkNull(rs.getString(4));
                seltype = MString.checkNull(rs.getString(5));
                pri = MString.checkNull(rs.getString(6));
                
                organdeptname = MString.checkNull(rs.getString(7));      //2014.09.17 Add by KWON,HAN 
                upperdeptname = MString.checkNull(rs.getString(8));      //2014.09.17 Add by KWON,HAN                   
                
                sbuf.append("{ \"data\":\"" + name + "\",\"attr\": { \"ID\":\"" + deptId + "\", ");
                sbuf.append("\"UPPER\":\"" + upper + "\",\"ORGAN\":\"" + organ + "\", \"SELTYPE\":\"" + seltype + "\", ");
                sbuf.append("\"deptname\":\"" + name + "\",");               //2014.09.17 Add by KWON,HAN 
                sbuf.append("\"organdeptname\":\"" + organdeptname + "\","); //2014.09.17 Add by KWON,HAN 
                sbuf.append("\"upperdeptname\":\"" + upperdeptname + "\","); //2014.09.17 Add by KWON,HAN
                sbuf.append("\"PRI\":\"" + pri + "\",\"rel\":\"DEPT\"},\"state\" : \"closed\"}");
                sbuf.append(",");
                dataCnt++;

            }
            close(rs);
            rs = null;
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO
        } catch(SQLException sqlex) {
            sqlex.printStackTrace();
        //++++++++++++++++++++++++++++++++++++++++++++++++
        } catch (Exception ex) {
            //System.out.println("error exception2:" + ex);
            ex.printStackTrace();
        } finally {
            if (rs != null) {
                close(rs);
            }
            execClose();
        }
    }

    public void user2JSon(String id) {
        int ii = 0;
        ResultSet rs = null;
        String userId, name, sysAuth;
        String subSysadm = Integer.toString(SysAuth.SUB_SYSADM.ordinal());  //2014.10.15 Add by KWON,HAN 
        String deptName;              //2014.08.26 Add by KWON,HAN 
        //2014.08.26 Update by KWON,HAN 
        //sql="SELECT ID,NAME,sys_auth, DEPT_ID FROM MOUMI_MUSER WHERE DEL_TYPE='N' AND DEPT_ID='"+id+"'";
        sql = "SELECT ID,NAME,sys_auth, (SELECT X.NAME FROM MOUMI_DEPT X WHERE X.ID = DEPT_ID AND ROWNUM = 1) FROM MOUMI_MUSER WHERE DEL_TYPE='N' AND DEPT_ID='" + id + "'";
//System.out.println("user2JSon:::::"+sql);
        try {
            rs = execQuery(sql);
            if (rs == null) {
                return;
            }
            while (rs.next()) {
                userId = MString.checkNull(rs.getString(1));
                name = MString.checkNull(rs.getString(2));
                sysAuth = MString.checkNull(rs.getString(3));
                deptName = MString.checkNull(rs.getString(4));    //2014.08.26 Add by KWON,HAN 
                
//System.out.println("SysAuth.SUB_SYSADM.ordinal():::::"+subSysadm);                                
//System.out.println("sysAuth:::::"+sysAuth); 
            
            //2014.10.15 Update by KWON,HAN 
                sbuf.append("{ \"data\":\"" + name + "(" + userId + ")");
            if(sysAuth.equals(subSysadm)) {
                sbuf.append(" []");
            }
                sbuf.append("\",");            
                sbuf.append("\"attr\": { \"ID\":\"" + userId + "\", \"SYSAUTH\":\"" + sysAuth + "\",");
            //=============================                
                sbuf.append("\"name\":\"" + name + "\",");         //2014.08.26 Add by KWON,HAN 
                sbuf.append("\"deptid\":\"" + id + "\",");         //2014.08.26 Add by KWON,HAN 
                sbuf.append("\"deptname\":\"" + deptName + "\","); //2014.08.26 Add by KWON,HAN 
                sbuf.append("\"rel\":\"USER\"},\"state\" : \"opened\"}");
                sbuf.append(",");
                dataCnt++;
            }
            close(rs);
            rs = null;

//System.out.println("MakeJSon.user2JSon() sbuf:::::"+sbuf);
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO
        } catch(SQLException sqlex) {
            sqlex.printStackTrace();
        //++++++++++++++++++++++++++++++++++++++++++++++++
        } catch (Exception ex) {
            //System.out.println("error exception2:" + ex);
            ex.printStackTrace();
        } finally {
            if (rs != null) {
                close(rs);
            }
            execClose();
        }
    }
}
