package kr.co.kihyun.tree;

import java.io.IOException;
//import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

//import javax.servlet.ServletException;
//import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import kr.co.kihyun.beans.user.HttpSSOLogin;
//import java.util.List;
import kr.co.kihyun.db.DBPool;
//import kr.co.kihyun.lang.Encoder;
//import kr.co.kihyun.lang.MInteger;
//import kr.co.kihyun.lang.MLong;
//import kr.co.kihyun.moumi.MoumiConfig;
//import kr.co.kihyun.db.DBManager;
import kr.co.kihyun.lang.MString;
import kr.co.kihyun.service.StatisticsService;
import kr.co.kihyun.service.vo.SearchVO;

public class MakeSearchJSon extends DBPool {
    private static final Logger LOG = LoggerFactory.getLogger(StatisticsService.class);
    
    public int dataCnt = 1;
    public Connection con = null;
    public PrintWriter out = null;
    public ArrayList list = new ArrayList();
    public StringBuffer sbuf = new StringBuffer();
    public String userId = null;
        
    public MakeSearchJSon(HttpServletRequest req, HttpServletResponse res) {
        try {
            res.setContentType("text/html;charset=euc-kr");
            userId = HttpSSOLogin.getLoginID(req);
            out = res.getWriter();
            String startId = req.getParameter("startId");
            String gubun = MString.checkNull(req.getParameter("gubun"), "ORGAN");
            String keyWord = req.getParameter("keyWord");
            if (keyWord != null) {
                keyWord = new String(keyWord.getBytes("8859_1"), "UTF-8");
            }

            list.add("#" + startId);

            //2014.08.26 Add By KWON,HAN
            if (gubun.equals("USER")) {
                getSearchUserData(keyWord);
            } else {
                //++++++++++++++++++++++++++
                if (gubun.equals("GROUP") || gubun.equals("GROUP_AREA") || gubun.equals("GROUP_DEPT")) {
                    getSearchGroupData(keyWord, gubun, userId);
                } else {
                    getSearchData(keyWord);
                }
                //++++++++++++++++++++++++++
            }
            //++++++++++++++++++++++++++
            sbuf.append("[");
            for (int ii = 0; ii < list.size(); ii++) {
                sbuf.append("\"" + list.get(ii) + "\",");
            }
            sbuf.append("]");
            sbuf.deleteCharAt(sbuf.lastIndexOf(","));
            out.println(sbuf.toString());
            
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO        
        } catch (IOException ioex) {
            ioex.printStackTrace();
        //++++++++++++++++++++++++++++++++++++++++++++++++
        } catch (Exception ex) {
            //System.out.println("error exception1:" + ex);
            ex.printStackTrace();
        }
    }

    //++++++++++++++++++++++++++
    //2014.08.26 Add By KWON,HAN
    //++++++++++++++++++++++++++
    public void getSearchUserData(String keyWord) {
        ResultSet rs = null;
        PreparedStatement stmt = null;

        //String sql="SELECT UPPER_DEPT FROM MOUMI_DEPT WHERE NAME LIKE '%"+keyWord+"%'";
        String sql = "";

        sql = sql + "SELECT A.ID   \n";
        sql = sql + "     , A.NAME   \n";
        sql = sql + "     , A.DEPT_ID   \n";
        sql = sql + "  FROM ( SELECT US.ID   \n";
        sql = sql + "                , us.name AS NAME   \n";
        sql = sql + "                , US.DEPT_ID    \n";
        sql = sql + "             FROM MOUMI_MUSER  US   \n";
        sql = sql + "                , MOUMI_DEPT   DT   \n";
        sql = sql + "            WHERE US.del_type='0'   \n";
        sql = sql + "              AND US.DEPT_ID = DT.ID   \n";
        sql = sql + "       ) A    \n";
        //19.SQL (getParameter) : Update by KWON,HAN
        //sql = sql + " WHERE A.ID LIKE  '%" + keyWord + "%'   \n";
        //sql = sql + "    OR A.NAME LIKE '%" + keyWord + "%'   \n";
        sql = sql + " WHERE A.ID LIKE  '%' || " + "?" + " || '%'   \n";
        sql = sql + "    OR A.NAME LIKE '%' || " + "?" + " || '%'   \n";        
        //==================================================
        
        String sId = "";
        String sName = "";
        String tmp = "";

        try {
            con = getConnection();
            stmt = con.prepareStatement(sql);
            //19.SQL (getParameter) : Add by KWON,HAN
            stmt.setString(1, keyWord);
            stmt.setString(2, keyWord);
            //+++++++++++++++++++++++++++++++++++++++
            rs = stmt.executeQuery();
            
            /*
            // 2014.11.14 by YoungJun,Cho : ÿ ߵǴµ, ߰  ResultSet  Žϴ ߿ ٸ ResultSet  Ž  ڵ ResultSet  ݾƹ  ߰ߵ.
            while (rs.next()) {
                sId = rs.getString(1);
                sName = rs.getString(1);
                tmp = rs.getString(3);
                if (sId == null || sId.equals("")) {
                    continue;
                }
                list.add("#" + sId);
                dataCnt++;
                if (dataCnt > 500) {
                    return;
                }

                //μ ãƼ  Ʈ ģ,
                if (tmp == null || tmp.equals("")) {
                    continue;
                }
                list.add("#" + tmp);
                dataCnt++;
                if (dataCnt > 500) {
                    return;
                }
                getSearchLoop(tmp);
            }
            */      
            
            // 2014.11.14 by YoungJun,Cho
            // id, name  like ˻  ResultSet   loop  Žϸ鼭, ArrayList(SearchVO ü)  صд.
            //  ResultSet  ݾƹ, ArrayList  ٽ Žϸ鼭 μ ã ޼带 Ѵ.
            
            // id, name  like ˻   ArrayList .
            ArrayList<SearchVO> searchList = new ArrayList<SearchVO>();
            
            //   Ž.
            while(rs.next()) {
                
                sId = rs.getString(1);      // id
                sName = rs.getString(1);    // name
                tmp = rs.getString(3);      // dept_id
                
                // id    skip ϰ  record Ž.
                if (sId == null || sId.equals("")) {
                    continue;
                }
                
                // ResultSet  Ž ڵ庰 SearchVO ü .
                SearchVO tmpSearchUser = new SearchVO();
                tmpSearchUser.setId( sId );
                tmpSearchUser.setName( sName );
                tmpSearchUser.setDeptId( tmp );
                
                // ArrayList  Ž  ߰.
                searchList.add(tmpSearchUser);
            }
            
            // ResultSet Ž  Ƿ, ݾƹ. 
            if (rs != null) {
                rs.close();
            }
            
            // id, name  like ˻ (ArrayList)  Ž(μ ã )
            for(SearchVO searchData : searchList) {
                list.add("#" + searchData.getId());
                dataCnt++;
                
                if (dataCnt > 500) {
                    return;
                }
                
                //μ ãƼ  Ʈ ģ,
                if (searchData.getDeptId() == null || searchData.getDeptId().equals("")) {
                    continue;
                }
                
                list.add("#" + searchData.getDeptId());
                dataCnt++;
                
                if (dataCnt > 500) {
                    return;
                }
                getSearchLoop(searchData.getDeptId());
            }
            
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
        } catch (SQLException sqlex) {    
            sqlex.printStackTrace();
        //++++++++++++++++++++++++++++++++++++++++++++++++
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                    rs = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
            if (stmt != null) {
                try {
                    stmt.close();
                    stmt = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
            if (con != null) {
                try {
                    con.close();
                    con = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
        }
    }

    public void getSearchData(String keyWord) {
        ResultSet rs = null;
        PreparedStatement stmt = null;
        //String sql="SELECT UPPER_DEPT FROM MOUMI_DEPT WHERE SEL_TYPE='Y' AND NAME LIKE '%"+keyWord+"%'";
        //String sql="SELECT UPPER_DEPT FROM MOUMI_DEPT WHERE NAME LIKE '%"+keyWord+"%'";

        //19.SQL (getParameter) : Update by KWON,HAN
        //String sql = "SELECT NVL(UPPER_DEPT, ORGAN) AS UPPER_DEPT FROM MOUMI_DEPT WHERE NAME LIKE '%" + keyWord + "%'";
        String sql = "SELECT NVL(UPPER_DEPT, ORGAN) AS UPPER_DEPT FROM MOUMI_DEPT WHERE NAME LIKE '%' || " + "?" + " || '%' ";
        //==================================================
        
        try {
            con = getConnection();
            stmt = con.prepareStatement(sql);
            
            //19.SQL (getParameter) : Add by KWON,HAN
            stmt.setString(1, keyWord);
            //+++++++++++++++++++++++++++++++++++++++
            
            rs = stmt.executeQuery();
            
            /*
            // 2014.11.14 by YoungJun,Cho : ÿ ߵǴµ, ߰  ResultSet  Žϴ ߿ ٸ ResultSet  Ž  ڵ ResultSet  ݾƹ  ߰ߵ.
            while (rs.next()) {
                String tmp = rs.getString(1);
                if (tmp == null || tmp.equals("")) {
                    continue;
                }
                list.add("#" + tmp);
                dataCnt++;
                if (dataCnt > 500) {
                    return;
                }
                getSearchLoop(tmp);
            }
            */
            
            // 2014.11.14 by YoungJun,Cho
            // name  like ˻  ResultSet   loop  Žϸ鼭, ArrayList(SearchVO ü)  صд.
            //  ResultSet  ݾƹ, ArrayList  ٽ Žϸ鼭 μ ã ޼带 Ѵ.
            
            // name  like ˻   ArrayList .
            ArrayList<SearchVO> searchList = new ArrayList<SearchVO>();
            
            //   Ž.
            while(rs.next()) {
                String tmpUpperDept = rs.getString(1);  // upper_dept
                
                // upper_dept    skip ϰ  record Ž.
                if (tmpUpperDept == null || tmpUpperDept.equals("")) {
                    continue;
                }
                
                // ResultSet  Ž ڵ庰 SearchVO ü .
                SearchVO tmpSearch = new SearchVO();
                tmpSearch.setUpperDept( tmpUpperDept );
                
                // ArrayList  Ž  ߰.
                searchList.add(tmpSearch);
            }
            
            // ResultSet Ž  Ƿ, ݾƹ. 
            if (rs != null) {
                rs.close();
            }
            
            // id, name  like ˻ (ArrayList)  Ž(μ ã )
            for (SearchVO searchData : searchList) {
                String tmpUpperDept = searchData.getUpperDept();
                
                list.add("#" + tmpUpperDept);
                dataCnt++;
                
                if (dataCnt > 500) {
                    return;
                }
                
                //μ ãƼ  Ʈ ģ,
                getSearchLoop(tmpUpperDept);
            }
            
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
        } catch (SQLException sqlex) {    
            sqlex.printStackTrace();
        //++++++++++++++++++++++++++++++++++++++++++++++++
        } catch (Exception ex) {
            //System.out.println("error exception2:" + ex);
            ex.printStackTrace();
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                    rs = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
            if (stmt != null) {
                try {
                    stmt.close();
                    stmt = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
            if (con != null) {
                try {
                    con.close();
                    con = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
        }
    }

    public void getSearchGroupData(String keyWord, String strGubun, String strUserId) {
        ResultSet rs = null;
        PreparedStatement stmt = null;
        //String sql="SELECT PART_ID FROM MOUMI_USER_DEPT WHERE DEL_TYPE='N' AND NAME LIKE '%"+keyWord+"%'";
        
        //19.SQL (getParameter) : Update by KWON,HAN
        //String  sql  = "SELECT PART_ID FROM MOUMI_USER_DEPT WHERE NAME LIKE '%" + keyWord + "%'   \n";
        String  sql  = "SELECT PART_ID FROM MOUMI_USER_DEPT WHERE NAME LIKE '%' || " + "?" + " || '%'   \n";
        //==================================================

        if (strGubun.equals("GROUP")) {
                //2014.09.16 Add by KOWN.HAN : MakeJSon.makeGroupCommonSql  
                sql += "UNION  \n";
                sql += "SELECT UP.ID    AS PART_ID     \n";
                sql += "   --, UP.NAME  AS DEPT_NAME   \n";
                sql += "   --, UP.USER_ID              \n";
                sql += "   --, UP.ID    AS DEPT_ID     \n";
                sql += "   --, 'closed'  AS STATE      \n";
                sql += "  FROM MOUMI_MUSER  US         \n";
                sql += "     , MOUMI_DEPT  DT          \n";
                sql += "     , MOUMI_USER_PART  UP     \n";
                sql += " WHERE DT.ORGAN IS NOT NULL  \n";
                sql += "   AND US.DEPT_ID=DT.ID  \n";
                sql += "   AND (UP.USER_ID=US.ID AND UP.USER_ID IN (SELECT ID FROM MOUMI_MUSER WHERE SYS_AUTH=9))  \n";
                sql += "   AND UP.USE_YN = 'Y'  \n";
                //19.SQL (getParameter) : Update by KWON,HAN
              //sql += "   AND UP.NAME LIKE '%" + keyWord + "%'   \n";
                sql += "   AND UP.NAME LIKE '%' || " + "?" + " || '%'   \n";
                //===========================================
                sql += " ORDER BY 1  \n";
        }
        if (strGubun.equals("GROUP_AREA")) {
                //2014.09.16 Add by KOWN.HAN : MakeJSon.makeGroupAreaSql  
                sql += "UNION  \n";   
                sql += " SELECT UP.ID    AS PART_ID       \n";
                sql += "    --, UP.NAME  AS DEPT_NAME     \n";
                sql += "    --, UP.USER_ID                \n";
                sql += "    --, UP.ID    AS DEPT_ID       \n";
                sql += "    --, 'closed' AS STATE         \n";
                sql += "   FROM MOUMI_MUSER US      \n";
                sql += "      , MOUMI_DEPT DT       \n";
                sql += "      , MOUMI_DEPT GR       \n";
                sql += "      , MOUMI_USER_PART UP  \n";
                sql += " WHERE DT.ORGAN IS NOT NULL   \n";
                sql += "   AND US.DEPT_ID=DT.ID   \n";
                sql += "   AND DT.ORGAN = GR.ID   \n";
                sql += "   AND UP.USER_ID=US.ID   \n";
                sql += "   AND UP.USE_YN = 'Y'    \n";
                sql += "   AND UP.USER_ID IN (    \n";
                sql += "                      SELECT US.ID   \n";
                sql += "                        FROM MOUMI_MUSER US  \n";
                sql += "                           , MOUMI_DEPT DT   \n";
                sql += "                       WHERE US.SYS_AUTH=7   \n";
                sql += "                         AND US.DEPT_ID = DT.ID   \n";
                sql += "                         AND DT.ORGAN = ( SELECT GR.ID   \n";
                sql += "                                            FROM MOUMI_MUSER US   \n";
                sql += "                                               , MOUMI_DEPT DT    \n";
                sql += "                                               , MOUMI_DEPT GR    \n";
                //19.SQL (getParameter) : Update by KWON,HAN
              //sql += "                                           WHERE US.ID='" + userId + "'   \n";
                sql += "                                           WHERE US.ID= " + "?" + "   \n";
                //===========================================
                sql += "                                             AND US.DEPT_ID = DT.ID   \n";
                sql += "                                             AND DT.ORGAN = GR.ID    \n";
                sql += "                                        )   \n";
                sql += "                     )    \n";
                //19.SQL (getParameter) : Update by KWON,HAN
              //sql += "   AND UP.NAME LIKE '%" + keyWord + "%'   \n";
                sql += "   AND UP.NAME LIKE '%' || " + "?" + " || '%'   \n";
                //==========================================
                sql += " ORDER BY 1   \n";            
        }        
        if (strGubun.equals("GROUP_DEPT")) {
                //2014.09.16 Add by KOWN.HAN : MakeJSon.makeGroupDeptSql  
                sql += "UNION  \n";
                sql += "SELECT UP.ID    AS PART_ID       \n";
                sql += "   --, UP.NAME  AS DEPT_NAME     \n";
                sql += "   --, UP.USER_ID                \n";
                sql += "   --, UP.ID    AS DEPT_ID       \n";
                sql += "   --, 'closed'  AS STATE        \n";
                sql += "  FROM MOUMI_MUSER US        \n";
                sql += "     , MOUMI_DEPT DT         \n";
                sql += "     , MOUMI_DEPT GR         \n";
                sql += "     , MOUMI_USER_PART UP    \n";
                sql += " WHERE DT.ORGAN IS NOT NULL   \n";
                sql += "   AND US.DEPT_ID=DT.ID       \n";
                sql += "   AND DT.ORGAN = GR.ID       \n";
                sql += "   AND UP.USER_ID=US.ID       \n";
                sql += "   AND UP.USE_YN = 'Y'        \n";
                sql += "   AND UP.USER_ID IN (        \n";
                sql += "                      select us.id    \n";
                sql += "                        from moumi_muser us   \n";
                sql += "                           , moumi_dept dt    \n";
                sql += "                       where us.dept_id = dt.ID   \n";
                sql += "                         and dt.id = ( SELECT dt.ID    \n";
                sql += "                                         FROM MOUMI_MUSER US   \n";
                sql += "                                            , MOUMI_DEPT DT    \n";
                //19.SQL (getParameter) : Update by KWON,HAN
              //sql += "                                        WHERE US.ID='" + userId + "'   \n";
                sql += "                                        WHERE US.ID= " + "?" + "   \n";
                //==========================================
                sql += "                                          and US.DEPT_ID = dt.id    \n";
                sql += "                                     )   \n";
                sql += "                     )    \n";
                //19.SQL (getParameter) : Update by KWON,HAN
              //sql += "   AND UP.NAME LIKE '%" + keyWord + "%'   \n";
                sql += "   AND UP.NAME LIKE '%' || " + "?" + " || '%'   \n";
                //===========================================
                sql += " ORDER BY 1    \n";   
        }

//        LOG.debug("MakeSearchJSon.getSearchGroupData sql={} \n", sql.toString());
//        LOG.debug("userId={}", userId);
//        LOG.debug("keyWord={}", keyWord);
        

        try {
            con = getConnection();
            stmt = con.prepareStatement(sql);
            
            //19.SQL (getParameter) : Add by KWON,HAN
                stmt.setString(1, keyWord);
            if (strGubun.equals("GROUP")) {
                stmt.setString(2, keyWord);            
            }
            if (strGubun.equals("GROUP_AREA")) {
               stmt.setString(2, userId);     
               stmt.setString(3, keyWord);     
            }
            if (strGubun.equals("GROUP_DEPT")) {
               stmt.setString(2, userId);     
               stmt.setString(3, keyWord);    
            }
            //+++++++++++++++++++++++++++++++++++++++
            
            rs = stmt.executeQuery();
            
            while (rs.next()) {
                String tmp = rs.getString(1);
//LOG.debug("tmp={}", tmp);                
                if (tmp == null || tmp.equals("")) {
                    continue;
                }
                list.add("#" + tmp);
                dataCnt++;
                if (dataCnt > 500) {
                    return;
                }
//2014.09.15 Delete by KWON,HAN : ʿ .
                //getSearchLoop(tmp);
            }
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
        } catch (SQLException sqlex) {    
            sqlex.printStackTrace();
        //++++++++++++++++++++++++++++++++++++++++++++++++
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                    rs = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
            if (stmt != null) {
                try {
                    stmt.close();
                    stmt = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
            if (con != null) {
                try {
                    con.close();
                    con = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
        }
    }

    public void getSearchLoop(String tmpp) {
        if (dataCnt > 500) {
            return;
        }
        ResultSet rs = null;
        PreparedStatement stmt = null;
        /*String sql="SELECT UPPER_DEPT FROM MOUMI_DEPT WHERE SEL_TYPE='Y' AND ID='"+tmpp+"' ";
         sql+="AND (UPPER_DEPT IS NOT NULL AND UPPER_DEPT<>'"+tmpp+"')";*/
        String sql  = "SELECT UPPER_DEPT    \n"; 
               sql += "  FROM MOUMI_DEPT    \n"; 
        //19.SQL (getParameter) : Update by KWON,HAN       
        //     sql += " WHERE ID ='" + tmpp + "'  \n";
        //     sql += "   AND (UPPER_DEPT IS NOT NULL AND UPPER_DEPT <>'" + tmpp + "')  \n";
               sql += " WHERE ID = " + "?" + "  \n";
               sql += "   AND (UPPER_DEPT IS NOT NULL AND UPPER_DEPT <> " + "?" + ")  \n";               
        //==========================================
               
//        LOG.debug("MakeSearchJSon.getSearchLoop sql={} \n", sql.toString());
//        LOG.debug("tmpp={}", tmpp);
        
        try {
            stmt = con.prepareStatement(sql);
        //19.SQL (getParameter) : Update by KWON,HAN    
        //17.SQL (Database)_CWE-89 
            stmt.setString(1, tmpp);            
            stmt.setString(2, tmpp);         
       //==========================================    
            rs = stmt.executeQuery();
            if (rs.next()) {
                String tmp1 = rs.getString(1);
                if (tmp1 == null || tmp1.equals("")) {
                    return;
                }
                list.add("#" + tmp1);
                dataCnt++;
                getSearchLoop(tmp1);
            }
        //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
        } catch (SQLException sqlex) {    
            sqlex.printStackTrace();
        //++++++++++++++++++++++++++++++++++++++++++++++++    
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            if (rs != null) {
                try {
                    rs.close();
                    rs = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
            if (stmt != null) {
                try {
                    stmt.close();
                    stmt = null;
                //44.  ó(Ŭ)_CWE-754 Add by YOUNGJUN,CHO    
                } catch (SQLException sqlex) {    
                    sqlex.printStackTrace();
                //++++++++++++++++++++++++++++++++++++++++++++++++
                } catch (Exception ex) {
                    //31. Ȳ  _CWE-390 Add by YOUNGJUN,CHO
                    ex.printStackTrace();
                    //++++++++++++++++++++++++++++++++++++++++++++++++
                }
            }
        }
    }
}
